LuaCore.Require("functions.lua")

function OnInitialize()
	flag_print_log			= false
	if StateGarage:IsLiteVersion() == 1 then
		flag_smallpack		= true
	else
		flag_smallpack		= false
	end
	flag_rmpack				= true
	
	channel_id 				= StateGarage:GetChannelId().mValue
	
	currentCarID			= 0
	currentCar				= nil
	currentDriverID 		= 0
	currentDriver			= nil
	selectedDriverID		= 0
	flag_toDealer			= false
	stringIndex				= 113
	driverSPMaxSkill		= ''
	flag_show_sub 			= true
	flag_show_btn_sinario	= true
	flag_show_btn_next		= true
	flag_move_stage_title	= true
	flag_show_map			= true
	flag_championship_mode	= false
	flag_rm_mode			= false
	flag_show_energybar		= false
	flag_sidebar_position 	= false
	flag_rm_redeem_from_pop	= false
	flag_vs_redeem_from_pop	= false
	flag_vs_mode			= false
	flag_curstage_type		= 0
	selected_substage		= nil
	
	uiR_current_ui			= _uiComponentDisplay:new()
	uiR_pre_ui				= _uiComponentDisplay:new()
	
	IniUI_Map('ui_map')
	IniUI_Main('ui_main')
	IniUI_Dealer('ui_dealer')
	IniUI_Slect_item('ui_select_item')
	IniUI_Stage('ui_stage')
	IniUI_Garage('ui_garage')
	IniUI_Vipstore('ui_vipstore')
	
	if flag_smallpack == false then
		IniUI_Challenge('ui_challenge')
		IniUI_Challenge_ak('ui_challenge_ak')
		IniUI_Challenge_tr('ui_challenge_tr')
		IniUI_Challenge_redeem('ui_challenge_redeem')
		IniUI_Challenge_redeem_tr('ui_challenge_redeem_tr')
	end
	
	IniUI_Navi_top('ui_navi_top')
	IniUI_Driver('ui_driver')
	IniUI_Championship('ui_championship')
	IniUI_Gacha('ui_gacha')
	IniUI_VSMode('ui_vsmode')
	IniUI_PVP_Redeem('ui_pvp_redeem')
	
	IniUI_Popup_upg2max('ui_popup_upg2max')
end

function IniUI_Map(ui_name)
	--uiR
	ui_map_root, uiR_ui_map = Ini_uiR(ui_name)
	map_topbar = IniComponent(ui_name, 'map_topbar')
	--component
	--uiC
end

function IniUI_Main(ui_name)
	--uiR
	ui_main_root, uiR_ui_main = Ini_uiR(ui_name)
	--component
	main_sidebar_left = IniComponent(ui_name, 'main_sidebar_left')
	main_sidebar_right = IniComponent(ui_name, 'main_sidebar_right')
	main_btn_mission_bubble = IniComponent(ui_name, 'main_btn_mission_bubble')
	main_btn_mission = IniComponent(ui_name, 'main_btn_mission')
	main_btn_shop = IniComponent(ui_name, 'main_btn_shop')
	main_btn_garage = IniComponent(ui_name, 'main_btn_garage')
	main_stage_btn = IniComponent(ui_name, 'main_stage_btn')
	main_btn_bg = IniComponent(ui_name, 'main_btn_bg')
	main_btn_pvp = IniComponent(ui_name, 'main_btn_pvp')
	main_btn_driver = IniComponent(ui_name, 'main_btn_driver')
	main_btn_mall = IniComponent(ui_name, 'main_btn_mall')
	main_bg = IniComponent(ui_name, 'main_bg')
	main_btn_mask = IniComponent(ui_name, 'main_btn_mask')
	main_btn_pvp_disable = IniComponent(ui_name, 'main_btn_pvp_disable')
	main_btn_shop_disable = IniComponent(ui_name, 'main_btn_shop_disable')
	main_btn_garage_disable = IniComponent(ui_name, 'main_btn_garage_disable')
	main_btn_driver_disable = IniComponent(ui_name, 'main_btn_driver_disable')
	main_btn_stage_disable = IniComponent(ui_name, 'main_btn_stage_disable')
	main_btn_mission = IniComponent(ui_name, 'main_btn_mission')
	main_btn_achievement = IniComponent(ui_name, 'main_btn_achievement')
	main_btn_friends = IniComponent(ui_name, 'main_btn_friends')
	main_btn_invite_friends = IniComponent(ui_name, 'main_btn_invite_friends')
	main_banner_slider = IniComponent(ui_name, 'main_banner_slider')
	main_service_btn = IniComponent(ui_name, 'main_service_btn')
	navi_top_vm_btn = IniComponent(ui_name, 'navi_top_vm_btn')
	--main_btn_mission_dialog_bubble = IniComponent(ui_name, 'main_btn_mission_dialog_bubble')
	--main_btn_campaign = IniComponent(ui_name, 'main_btn_campaign')
	main_btn_cmpack = IniComponent(ui_name, 'main_btn_cmpack')
	--main_btn_rm = IniComponent(ui_name, 'main_btn_rm')
	--main_rmpack = IniComponent(ui_name, 'main_rmpack')
	--main_banner_move_btn = IniComponent(ui_name, 'main_banner_move_btn')
	--main_driver_icon = IniComponent(ui_name, 'main_driver_icon')
	--uiC
end

function IniUI_Dealer(ui_name)
	--uiR
	ui_dealer_root, uiR_ui_dealer = Ini_uiR(ui_name)
	--component
	dealer_bg = IniComponent(ui_name, 'dealer_bg')
	dealer_status = IniComponent(ui_name, 'dealer_status')
	dealer_status_acc_data_cur = IniComponent(ui_name, 'dealer_status_acc_data_cur')
	dealer_status_spmax_data_cur = IniComponent(ui_name, 'dealer_status_spmax_data_cur')
	dealer_status_turning_data_cur = IniComponent(ui_name, 'dealer_status_turning_data_cur')
	dealer_status_pgbar_acc = IniComponent(ui_name, 'dealer_status_pgbar_acc')
	dealer_status_pgbar_spmax = IniComponent(ui_name, 'dealer_status_pgbar_spmax')
	dealer_status_pgbar_turning = IniComponent(ui_name, 'dealer_status_pgbar_turning')
	dealer_class = IniComponent(ui_name, 'dealer_class')
	dealer_class_vip = IniComponent(ui_name, 'dealer_class_vip')
	dealer_namebar = IniComponent(ui_name, 'dealer_namebar')
	dealer_cargroup = IniComponent(ui_name, 'dealer_cargroup')
	dealer_carselect_btn_left = IniComponent(ui_name, 'dealer_carselect_btn_left')
	dealer_carselect_btn_right = IniComponent(ui_name, 'dealer_carselect_btn_right')
	dealer_bg_arrow = IniComponent(ui_name, 'dealer_bg_arrow')
	dealer_sale_banner = IniComponent(ui_name, 'dealer_sale_banner')	
	dealer_lockedcar = IniComponent(ui_name, 'dealer_lockedcar')
	dealer_btn_purchase = IniComponent(ui_name, 'dealer_btn_purchase')
	dealer_lock = IniComponent(ui_name, 'dealer_lock')
	dealer_data = IniComponent(ui_name, 'dealer_data')
	dealer_weight = IniComponent(ui_name, 'dealer_weight')
	dealer_cartype = IniComponent(ui_name, 'dealer_cartype')
	dealer_namebar_shadow = IniComponent(ui_name, 'dealer_namebar_shadow')
	dealer_namebar_eff = IniComponent(ui_name, 'dealer_namebar_eff')
	dealer_data_price = IniComponent(ui_name, 'dealer_data_price')
	dealer_girl = IniComponent(ui_name, 'dealer_girl')
	dealer_girl_talk = IniComponent(ui_name, 'dealer_girl_talk')
	dealer_girl_pix = IniComponent(ui_name, 'dealer_girl_pix')
	dealer_girl_talk_text = IniComponent(ui_name, 'dealer_girl_talk_text')
	dealer_intro = IniComponent(ui_name, 'dealer_intro')
	dealer_intro_text = IniComponent(ui_name, 'dealer_intro_text')
	dealer_purchased = IniComponent(ui_name, 'dealer_purchased')
	dealer_soldout = IniComponent(ui_name, 'dealer_soldout')
	dealer_sale_mark = IniComponent(ui_name, 'dealer_sale_mark')
	dealer_sale_time = IniComponent(ui_name, 'dealer_sale_time')
	dealer_sale_mark_80 = IniComponent(ui_name, 'dealer_sale_mark_80')
	dealer_data_discount = IniComponent(ui_name, 'dealer_data_discount')
	dealer_data_payback = IniComponent(ui_name, 'dealer_data_payback')
	dealer_data_price_ml = IniComponent(ui_name, 'dealer_data_price_ml')
	dealer_btn_coinpurchase = IniComponent(ui_name, 'dealer_btn_coinpurchase')
	dealer_img_diamondbuy = IniComponent(ui_name, 'dealer_img_diamondbuy')
	
	--uiC
end

function IniUI_Slect_item(ui_name)
	--uiR
	ui_select_item_root, uiR_ui_select_item = Ini_uiR(ui_name)
	--component
	--item_go_btn = IniComponent(ui_name, 'item_go_btn')
	navi_top_rig_car = IniComponent(ui_name, 'navi_top_rig_car')
	navi_top_rig_car_disable = IniComponent(ui_name, 'navi_top_rig_car_disable')
	--item_stage_info = IniComponent(ui_name, 'item_stage_info')
	navi_top_rig_driver = IniComponent(ui_name, 'navi_top_rig_driver')
	--navi_top_rig_driver_bg = IniComponent(ui_name, 'navi_top_rig_driver_bg')
	navi_top_rig_driver_skill_1 = IniComponent(ui_name, 'navi_top_rig_driver_skill_1')
	navi_top_rig_driver_skill_2 = IniComponent(ui_name, 'navi_top_rig_driver_skill_2')
	navi_top_rig_driver_skill_3 = IniComponent(ui_name, 'navi_top_rig_driver_skill_3')
	navi_top_rig_driver_disable = IniComponent(ui_name, 'navi_top_rig_driver_disable')
	navi_top_rig_driver_icon = IniComponent(ui_name, 'navi_top_rig_driver_icon')
	navi_top_rig_driver_icon_null = IniComponent(ui_name, 'navi_top_rig_driver_icon_null')
	--item_next_stage_info_text = IniComponent(ui_name, 'item_next_stage_info_text')
	--item_next_stage_info_type = IniComponent(ui_name, 'item_next_stage_info_type')
	item_car_info_name = IniComponent(ui_name, 'item_car_info_name')
	item_car_info_speed = IniComponent(ui_name, 'item_car_info_speed')
	item_stage_speed = IniComponent(ui_name, 'item_stage_speed')
	item_stage_goal = IniComponent(ui_name, 'item_stage_goal')
	--item_next_stage_info_obj = IniComponent(ui_name, 'item_next_stage_info_obj')
	
	--item_next_stage_info_speed = IniComponent(ui_name, 'item_next_stage_info_speed')
	
	item_car_info = IniComponent(ui_name, 'item_car_info')
	navi_top_driver_text = IniComponent(ui_name, 'navi_top_driver_text')
	item_bg = IniComponent(ui_name, 'item_bg')
	itme_downbar_bg = IniComponent(ui_name, 'itme_downbar_bg')
	item_slider = IniComponent(ui_name, 'item_slider')
	item_stage_speedwarning = IniComponent(ui_name, 'item_stage_speedwarning')
	--uiC
end

function IniUI_Stage(ui_name)
	--uiR
	ui_stage_root, uiR_ui_stage = Ini_uiR(ui_name)
	--component
	stage_bg = IniComponent(ui_name, 'stage_bg')
	stage_locked = IniComponent(ui_name, 'stage_locked')
	stage_locked_text = IniComponent(ui_name, 'stage_locked_text')
	--stage_tip = IniComponent(ui_name, 'stage_tip')
	--uiC
end

function IniUI_Garage(ui_name)
	--uiR
	ui_garage_root, uiR_ui_garage = Ini_uiR(ui_name)
	--component
	garage_bg = IniComponent(ui_name, 'garage_bg')
	garage_status = IniComponent(ui_name, 'garage_status')
	garage_status_acc_data_cur = IniComponent(ui_name, 'garage_status_acc_data_cur')
	garage_status_spmax_data_cur = IniComponent(ui_name, 'garage_status_spmax_data_cur')
	garage_status_turning_data_cur = IniComponent(ui_name, 'garage_status_turning_data_cur')
	garage_status_pgbar_acc = IniComponent(ui_name, 'garage_status_pgbar_acc')
	garage_status_pgbar_spmax = IniComponent(ui_name, 'garage_status_pgbar_spmax')
	garage_status_pgbar_turning = IniComponent(ui_name, 'garage_status_pgbar_turning')
	--garage_btn_upgd2max_confirm = IniComponent(ui_name, 'garage_btn_upgd2max_confirm')
	--garage_btn_upgd2max_cancel = IniComponent(ui_name, 'garage_btn_upgd2max_cancel')
	garage_class = IniComponent(ui_name, 'garage_class')
	garage_class_vip = IniComponent(ui_name, 'garage_class_vip')
	garage_namebar = IniComponent(ui_name, 'garage_namebar')
	garage_namebar_shadow = IniComponent(ui_name, 'garage_namebar_shadow')
	garage_namebar_eff = IniComponent(ui_name, 'garage_namebar_eff')
	garage_cargroup = IniComponent(ui_name, 'garage_cargroup')
	garage_carselect_btn_left = IniComponent(ui_name, 'garage_carselect_btn_left')
	garage_carselect_btn_right = IniComponent(ui_name, 'garage_carselect_btn_right')
	bg_arrow = IniComponent(ui_name, 'bg_arrow')
	garage_exit_btn = IniComponent(ui_name, 'garage_exit_btn')
	garage_lv = IniComponent(ui_name, 'garage_lv')
	garage_weight = IniComponent(ui_name, 'garage_weight')
	garage_cartype = IniComponent(ui_name, 'garage_cartype')
	garage_data = IniComponent(ui_name, 'garage_data')
	garage_data_price = IniComponent(ui_name, 'garage_data_price')
	garage_girl = IniComponent(ui_name, 'garage_girl')
	garage_girl_talk = IniComponent(ui_name, 'garage_girl_talk')
	garage_girl_pix = IniComponent(ui_name, 'garage_girl_pix')
	garage_girl_talk_text = IniComponent(ui_name, 'garage_girl_talk_text')
	garage_intro = IniComponent(ui_name, 'garage_intro')
	garage_intro_text = IniComponent(ui_name, 'garage_intro_text')
	garage_data_bg_head_eff = IniComponent(ui_name, 'garage_data_bg_head_eff')
	garage_lvmax = IniComponent(ui_name, 'garage_lvmax')
	garage_lvmax_not = IniComponent(ui_name, 'garage_lvmax_not')
	garage_2dealer_btn = IniComponent(ui_name, 'garage_2dealer_btn')
	--uiC
	garage_fuction_btn_upgd, uiC_garage_fuction_btn_upgd = Ini_uiC(ui_name, 'garage_fuction_btn_upgd')
	garage_btn_upgd2max, uiC_garage_btn_upgd2max = Ini_uiC(ui_name, 'garage_btn_upgd2max')
end

function IniUI_Vipstore(ui_name)
	--uiR
	ui_vipstore_root, uiR_ui_vipstore = Ini_uiR(ui_name)
	--component
	--uiC
end

function IniUI_Challenge(ui_name)
	--uiR
	ui_challenge_root, uiR_ui_challenge = Ini_uiR(ui_name)
	--component
	challenge_buy_item = IniComponent(ui_name, 'challenge_buy_item')
	--challenge_pre_btn = IniComponent(ui_name, 'challenge_pre_btn')
	--challenge_next_btn = IniComponent(ui_name, 'challenge_next_btn')
	challenge_buy_item_btn = IniComponent(ui_name, 'challenge_buy_item_btn')
	challenge_back2normal_btn = IniComponent(ui_name, 'challenge_back2normal_btn')
	challenge_back2normal_x_btn = IniComponent(ui_name, 'challenge_back2normal_x_btn')
	--challenge_infotext_network = IniComponent(ui_name, 'challenge_infotext_network')
	challenge_infotext_buyitem = IniComponent(ui_name, 'challenge_infotext_buyitem')
	--uiC
end

function IniUI_Challenge_ak(ui_name)
	--uiR
	ui_challenge_ak_root, uiR_ui_challenge_ak = Ini_uiR(ui_name)
	--component
	challenge_ak_navi_slider = IniComponent(ui_name, 'challenge_ak_navi_slider')
	--uiC
end

function IniUI_Challenge_tr(ui_name)
	--uiR
	ui_challenge_tr_root, uiR_ui_challenge_tr = Ini_uiR(ui_name)
	--component
	challenge_tr_navi_slider = IniComponent(ui_name, 'challenge_tr_navi_slider')
	--uiC
end

function IniUI_Challenge_redeem(ui_name)
	--uiR
	ui_challenge_redeem_root, uiR_ui_challenge_redeem = Ini_uiR(ui_name)
	--component
	--uiC
end

function IniUI_Challenge_redeem_tr(ui_name)
	--uiR
	ui_challenge_redeem_tr_root, uiR_ui_challenge_redeem_tr = Ini_uiR(ui_name)
	--component
	challenge_redeem_tr_spark01 = IniComponent(ui_name, 'challenge_redeem_tr_spark01')
	challenge_redeem_tr_spark02 = IniComponent(ui_name, 'challenge_redeem_tr_spark02')
	challenge_redeem_tr_spark03 = IniComponent(ui_name, 'challenge_redeem_tr_spark03')
	challenge_redeem_tr_spark04 = IniComponent(ui_name, 'challenge_redeem_tr_spark04')
	challenge_redeem_tr_call = IniComponent(ui_name, 'challenge_redeem_tr_call')
	challenge_redeem_tr_namebar = IniComponent(ui_name, 'challenge_redeem_tr_namebar')
	challenge_redeem_tr_class = IniComponent(ui_name, 'challenge_redeem_tr_class')
	challenge_redeem_tr_weight = IniComponent(ui_name, 'challenge_redeem_tr_weight')
	challenge_redeem_tr_cartype = IniComponent(ui_name, 'challenge_redeem_tr_cartype')
	challenge_redeem_tr_intro = IniComponent(ui_name, 'challenge_redeem_tr_intro')
	--uiC
end

function IniUI_Navi_top(ui_name)
	--uiR
	ui_navi_top_root, uiR_ui_navi_top = Ini_uiR(ui_name)
	--component
	navi_top_back2title_btn = IniComponent(ui_name, 'navi_top_back2title_btn')
	navi_top_popup_msg = IniComponent(ui_name, 'navi_top_popup_msg')
	navi_top_popup_msg_text = IniComponent(ui_name, 'navi_top_popup_msg_text')
	stage_info_title = IniComponent(ui_name, 'stage_info_title')
	stage_info_stage_num = IniComponent(ui_name, 'stage_info_stage_num')
	stage_sub_info = IniComponent(ui_name, 'stage_sub_info')
	stage_info_main_waist = IniComponent(ui_name, 'stage_info_main_waist')
	stage_info_waist_eff = IniComponent(ui_name, 'stage_info_waist_eff')
	stage_info_gold_detail = IniComponent(ui_name, 'stage_info_gold_detail')
	stage_info_silver_detail = IniComponent(ui_name, 'stage_info_silver_detail')
	stage_info_copper_detail = IniComponent(ui_name, 'stage_info_copper_detail')
	stage_info_main_bottom = IniComponent(ui_name, 'stage_info_main_bottom')	
	item_next_stage_info_speed = IniComponent(ui_name, 'item_next_stage_info_speed')	
	stage_sub = IniComponent(ui_name, 'stage_sub')	
	stage_btn_next = IniComponent(ui_name, 'stage_btn_next')	
	--stage_btn_championship = IniComponent(ui_name, 'stage_btn_championship')	
	stage_btn_sinario = IniComponent(ui_name, 'stage_btn_sinario')	
	item_go_btn = IniComponent(ui_name, 'item_go_btn')
	navi_top_inventory = IniComponent(ui_name, 'navi_top_inventory')
	navi_top_close_vm_btn = IniComponent(ui_name, 'navi_top_close_vm_btn')
	navi_top_stage_sub_chp_btn_start = IniComponent(ui_name, 'navi_top_stage_sub_chp_btn_start')
	--navi_top_stage_sub_rm = IniComponent(ui_name, 'navi_top_stage_sub_rm')
	--navi_top_stage_sub_rm_title = IniComponent(ui_name, 'navi_top_stage_sub_rm_title')
	--navi_top_stage_sub_rm_energy_eff = IniComponent(ui_name, 'navi_top_stage_sub_rm_energy_eff')
	navi_top_stage_sub_rm_btn_start = IniComponent(ui_name, 'navi_top_stage_sub_rm_btn_start')
	navi_top_stage_sub_rm_energy_bar = IniComponent(ui_name, 'navi_top_stage_sub_rm_energy_bar')
	navi_top_inventory_trophy = IniComponent(ui_name, 'navi_top_inventory_trophy')
	navi_top_inventory_t = IniComponent(ui_name, 'navi_top_inventory_t')
	stage_sub_bg_text = IniComponent(ui_name, 'stage_sub_bg_text')
	--uiC
	navi_top_back_btn, uiC_navi_top_back_btn = Ini_uiC(ui_name, 'navi_top_back_btn')
	navi_top_stage_sub_vs_btn_start, uiC_navi_top_stage_sub_vs_btn_start = Ini_uiC(ui_name, 'navi_top_stage_sub_vs_btn_start')
end

function IniUI_Driver(ui_name)
	--uiR
	ui_driver_root, uiR_ui_driver = Ini_uiR(ui_name)
	--component
	driver_exit_btn = IniComponent(ui_name, 'driver_exit_btn')
	driver_card_name = IniComponent(ui_name, 'driver_card_name')
	driver_card_name_shadow = IniComponent(ui_name, 'driver_card_name_shadow')
	driver_card_name_eff = IniComponent(ui_name, 'driver_card_name_eff')
	driver_card_level = IniComponent(ui_name, 'driver_card_level')
	driver_card_ability = IniComponent(ui_name, 'driver_card_ability')
	driver_card_ability_1 = IniComponent(ui_name, 'driver_card_ability_1')
	driver_card_ability_2 = IniComponent(ui_name, 'driver_card_ability_2')
	driver_card_ability_3 = IniComponent(ui_name, 'driver_card_ability_3')
	driver_card_ability_1_t = IniComponent(ui_name, 'driver_card_ability_1_t')
	driver_card_ability_1_tn = IniComponent(ui_name, 'driver_card_ability_1_tn')
	driver_card_ability_2_t = IniComponent(ui_name, 'driver_card_ability_2_t')
	driver_card_ability_2_tn = IniComponent(ui_name, 'driver_card_ability_2_tn')
	driver_card_ability_3_t = IniComponent(ui_name, 'driver_card_ability_3_t')
	driver_card_ability_3_tn = IniComponent(ui_name, 'driver_card_ability_3_tn')
	driver_card_ability_1_dot = IniComponent(ui_name, 'driver_card_ability_1_dot')
	driver_card_ability_2_dot = IniComponent(ui_name, 'driver_card_ability_2_dot')
	driver_card_ability_3_dot = IniComponent(ui_name, 'driver_card_ability_3_dot')
	driver_btn_buy_price = IniComponent(ui_name, 'driver_btn_buy_price')
	driver_discount = IniComponent(ui_name, 'driver_discount')
	driver_pad_cover = IniComponent(ui_name, 'driver_pad_cover')
	driver_card_cell = IniComponent(ui_name, 'driver_card_cell')
	driver_card_bg_head_eff = IniComponent(ui_name, 'driver_card_bg_head_eff')
	driver_sale_mark = IniComponent(ui_name, 'driver_sale_mark')
	driver_pad_redeem = IniComponent(ui_name, 'driver_pad_redeem')
	driver_pad_redeem_price = IniComponent(ui_name, 'driver_pad_redeem_price')
	--uiC
	driver_btn_promote, uiC_driver_btn_promote = Ini_uiC(ui_name, 'driver_btn_promote')
	driver_btn_select, uiC_driver_btn_select = Ini_uiC(ui_name, 'driver_btn_select')
	driver_btn_buy, uiC_driver_btn_buy = Ini_uiC(ui_name, 'driver_btn_buy')
end

function IniUI_Championship(ui_name)
	--uiR
	ui_championship_root, uiR_ui_championship = Ini_uiR(ui_name)
	--component
	championship_locked = IniComponent(ui_name, 'championship_locked')
	championship_record_time = IniComponent(ui_name, 'championship_record_time')
	championship_record_pos = IniComponent(ui_name, 'championship_record_pos')
	--uiC
end

function IniUI_Gacha(ui_name)
	--uiR
	ui_gacha_root, uiR_ui_gacha = Ini_uiR(ui_name)
	--component
	--uiC
end

function IniUI_VSMode(ui_name)
	--uiR
	ui_vsmode_root, uiR_ui_vsmode = Ini_uiR(ui_name)
	--component
	--uiC
end

function IniUI_PVP_Redeem(ui_name)
	--uiR
	ui_pvp_redeem_root, uiR_ui_pvp_redeem = Ini_uiR(ui_name)
	--component
	--uiC
end

function IniUI_Popup_upg2max(ui_name)
	--uiR
	ui_popup_upg2max_root, uiR_ui_popup_upg2max = Ini_uiR(ui_name)
	--component
	popup_upg2max_status_pgbar_acc = IniComponent(ui_name, 'popup_upg2max_status_pgbar_acc')
	popup_upg2max_status_acc_data_cur = IniComponent(ui_name, 'popup_upg2max_status_acc_data_cur')
	popup_upg2max_status_pgbar_spmax = IniComponent(ui_name, 'popup_upg2max_status_pgbar_spmax')
	popup_upg2max_status_spmax_data_cur = IniComponent(ui_name, 'popup_upg2max_status_spmax_data_cur')
	popup_upg2max_status_pgbar_turning = IniComponent(ui_name, 'popup_upg2max_status_pgbar_turning')
	popup_upg2max_status_turning_data_cur = IniComponent(ui_name, 'popup_upg2max_status_turning_data_cur')
	popup_upg2max_confirm_price = IniComponent(ui_name, 'popup_upg2max_confirm_price')
	--uiC
end