function GetTime(time_ms)
{
	var mm = parseInt(time_ms / 60000);
	var ss = parseInt((time_ms % 60000) / 1000);
	var ms = parseInt((time_ms % 60000) % 1000);
	var ss_length = ss.toString().length;
	var ms_length = ms.toString().length;
	
	while(ss_length < 2)
	{
		ss = '0' + ss;
		ss_length++;
	}
	while(ms_length < 3)
	{
		ms = '0' + ms;
		ms_length++;
	}
	
	return mm + ':' + ss + '.' + ms;
}

function _currentDriverInfo()
{
	this.CurrentDriver;
	this.Skill1;
	this.Skill1NextLv;
	this.Skill1UnlockDesc;
	this.Skill2;
	this.Skill2NextLv;
	this.Skill2UnlockDesc;
	this.Skill3;
	this.Skill3NextLv;
	this.Skill3UnlockDesc;
	
	this.setCurrentDriver 	= setCurrentDriver;
	this.setPrice 			= setPrice;
	this.setUpgradePrice 	= setUpgradePrice;
	this.getSkillLvDot 		= getSkillLvDot;
	
	function setCurrentDriver(current_driver_id)
	{
		this.CurrentDriver = StateGarage.GetDriverInfoByID(current_driver_id);
		this.Skill1 = StateGarage.GetSkillInfo(this.CurrentDriver.mSkill1, this.CurrentDriver.mSkill1Level);
		if(this.CurrentDriver.mDriverLevelIsFull)
		{
			this.Skill1NextLv = this.CurrentDriver.mSkill1Level
		}
		else
		{
			this.Skill1NextLv = StateGarage.GetDriverInfo(this.CurrentDriver.mID, this.CurrentDriver.mLevel + 1).mSkill1Level;
		}
		this.Skill1UnlockDesc = StateGarage.GetSkillInfo(this.CurrentDriver.mSkill1, this.CurrentDriver.mSkill1Level + 1).mUnlockDesc;
		this.Skill2 = StateGarage.GetSkillInfo(this.CurrentDriver.mSkill2, this.CurrentDriver.mSkill2Level);
		if(this.CurrentDriver.mDriverLevelIsFull)
		{
			this.Skill2NextLv = this.CurrentDriver.mSkill2Level
		}
		else
		{
			this.Skill2NextLv = StateGarage.GetDriverInfo(this.CurrentDriver.mID, this.CurrentDriver.mLevel + 1).mSkill2Level;
		}
		this.Skill2UnlockDesc = StateGarage.GetSkillInfo(this.CurrentDriver.mSkill2, this.CurrentDriver.mSkill2Level + 1).mUnlockDesc;
		this.Skill3 = StateGarage.GetSkillInfo(this.CurrentDriver.mSkill3, this.CurrentDriver.mSkill3Level);
		if(this.CurrentDriver.mDriverLevelIsFull)
		{
			this.Skill3NextLv = this.CurrentDriver.mSkill3Level
		}
		else
		{
			this.Skill3NextLv = StateGarage.GetDriverInfo(this.CurrentDriver.mID, this.CurrentDriver.mLevel + 1).mSkill3Level;
		}
		this.Skill3UnlockDesc = StateGarage.GetSkillInfo(this.CurrentDriver.mSkill3, this.CurrentDriver.mSkill3Level + 1).mUnlockDesc;
	}
	
	function setPrice(component_name)
	{
		SetPrice(component_name, this.CurrentDriver.mCoin, this.CurrentDriver.mRealMoney, 0, 'P');
	}
	
	function setUpgradePrice(component_name)
	{
		if(this.CurrentDriver.mUpgradeCoin == 0 && this.CurrentDriver.mUpgradeMoney == 0)
		{
			SetComponentText(component_name, 'P' + '----');
		}
		else
		{
			SetPrice(component_name, this.CurrentDriver.mUpgradeCoin, this.CurrentDriver.mUpgradeMoney, 0, 'P');
		}
	}
	
	function getSkillLvDot(skill, next_driver_lv)
	{
		var skill_level_dot = '';
		for(var i = 1; i <= skill.mMaxLevel; i++)
		{
			if(skill.mSkillLevel == 0)
			{
				skill_level_dot += '0';
			}
			else
			{
				if(i <= skill.mSkillLevel)
				{
					skill_level_dot += '1';
				}
				else if(i == skill.mSkillLevel + 1)
				{
					if(!this.CurrentDriver.mPurchased)
					{
						skill_level_dot += '0';
					}
					else if(skill.mSkillLevel == next_driver_lv)
					{
						skill_level_dot += '0';
					}
					else
					{
						skill_level_dot += '2';
					}
					
					//skill_level_dot += '2';
				}
				else
				{
					skill_level_dot += '0';
				}
			}
			
		}
		return skill_level_dot;
	}
}

function _uiComponentDisplay()
{
	//component object
	this.CName;
	//is show
	this.DFlag			= false;
	//is enable
	this.EFlag 			= true;
	//show animation
	this.ShowAni 		= 'ui_ani_show_default';
	//show animation delay
	this.ShowAniDelay 	= 300;
	//hide animation
	this.HideAni 		= 'ui_ani_hide_default';
	//hide animation delay
	this.HideAniDelay 	= 100;
	
	//set component object
	this.setCName 			= setCName;
	//set show flag
	this.setDFlag 			= setDFlag;
	//set enable flag
	this.setEFlag 			= setEFlag;
	//set show ani
	this.setShowAni 		= setShowAni;
	//set show animation delay
	this.setShowAniDelay 	= setShowAniDelay;
	//set hide ani
	this.setHideAni			= setHideAni;
	//set hide animation delay
	this.setHideAniDelay 	= setHideAniDelay;
	
	function setCName(component_name)
	{
		this.CName = component_name;
	}
	function setDFlag(display_flag)
	{
		this.DFlag = display_flag;
	}
	function setEFlag(enable_flag)
	{
		this.EFlag = enable_flag;
	}
	function setShowAni(ui_show_animation)
	{
		this.ShowAni = ui_show_animation;
	}
	function setShowAniDelay(delay_show)
	{
		this.ShowAniDelay = delay_show;
	}
	function setHideAni(ui_hide_animation)
	{
		this.HideAni = ui_hide_animation;
	}
	function setHideAniDelay(delay_hide)
	{
		this.HideAniDelay = delay_hide;
	}
}

function SetPrice()//(component_name, coin, realmoney, [rmb], 'price_tag')
{
	var price_tag = '';
	var churrency = 'C'
	var price = 0;
	
	//set price tag
	if(arguments[arguments.length - 1] != ' ')
	{
		price_tag = arguments[arguments.length - 1];
	}
	
	//set churrency
	if(arguments.length == 4)
	{
		if(arguments[2] != 0)
		{
			churrency = 'G';
			price = arguments[2];
		}
		else
		{
			price = arguments[1];
		}
	}
	else
	{
		if(arguments[3] == 0)
		{
			if(arguments[2] != 0)
			{
				churrency = 'G';
				price = arguments[2];
			}
			else
			{
				price = arguments[1];
			}
		}
		else
		{
			churrency = 'Y';
			price = arguments[3];
		}
	}
	
	SetComponentText(arguments[0], price_tag + churrency + price);
}

//------------------------------------------------------------------------------------A-D-V-A-N-C-E-D-M-E-T-H-O-D-//
//show ui with ani unlock screen
function AM_ShowComponent()//(_uiR, ['UI_TYPE'], [change_delay])
{
	for(var i = 1; i <= arguments.length; i++)
	{
		switch(i)
		{
			case 1:
				break;
			//ui type
			case 2:
				if(arguments[1] == 'UEFF_POP')
				{
					arguments[0].setShowAni('ui_ani_show_popup');
				}
				if(arguments[1] == 'CEFF_POP')
				{
					arguments[0].setShowAni('ui_ani_show_stagecontinue');
				}
				break;
			//change delay
			case 3:
				arguments[0].setShowAniDelay(arguments[2]);
				break;
		}
	}
	
	if(arguments[0].DFlag)
	{
		arguments[0].CName.Show(arguments[0].DFlag);
		//AniPlay
		arguments[0].CName.PlaySkeletonAnimation(arguments[0].ShowAniDelay, arguments[0].ShowAni, true, false);
	}
	else
	{
		//AniFadeOutUnlockScreen
		arguments[0].CName.FadeOut(0, arguments[0].HideAniDelay, false, EnumInterpolatorType.Linear);
		arguments[0].CName.Enable(false);
		//AniPlay
		arguments[0].CName.PlaySkeletonAnimation(arguments[0].HideAniDelay, arguments[0].HideAni, false, true);
	}
}

//set value with symbol or not
function AM_SetComponentValue()//(component_name, ['symbol'], value)
{
	var symbol = false;
	
	if(arguments[1] == '+')
	{
		symbol = true;
	}

	arguments[0].SetTextByInteger(arguments[arguments.length - 1], symbol);
}

//set progressbar range and value
function AM_SetPGbarValue()//(component_name, range, front_value, [back_value])
{
	var	back_value = 0;
	
	if(arguments.length == 4)
	{
		back_value = arguments[3];
	}
	
	arguments[0].SetProgressRange(0, arguments[1]);
	arguments[0].SetProgressValue(arguments[2]);
	arguments[0].SetProgressBgValue(back_value);
}

//play sound
function AM_PlaySound()//(component_name, [delay], [sound_name], [volume])
{
	var volume = 0.5;
	var delay = 0;
	var sound_name = 'sfx_ui_click2.wav';

	for(var i = 1; i <= arguments.length; i++)
	{
		switch(i)
		{
			case 1:
				break;
			case 2:
				delay = arguments[1];
				break;
			case 3:
				sound_name = arguments[2];
				break;
			case 4:
				volume = arguments[3];
				break;
		}
	}
	
	//arguments[0].Show(true);
	arguments[0].PlaySound(sound_name, sound_name, volume, delay);
}

//play bgm
function AM_PlayBGM()//('BGM_NAME', fadeout_time, fadein_time, [volume])
{
	var fadeout_time = 500;
	var fadein_time = 500;
	var volume = 0.5;
	
	if(arguments.length == 4)
	{
		volume = arguments[3];
	}
	
	if(arguments.length >= 3)
	{
		fadeout_time = arguments[1];
		fadein_time = arguments[2];
	}
	
	GUIFactory.PlayMusic('bgm', arguments[0], fadeout_time, fadein_time, volume);
}

//set text
function AM_SetComponentText()//(component_name, 'TEXT1', 'TEXT2', 'TEXT...')
{
	if(arguments.length == 2)
	{
		//set text
		arguments[0].SetText(arguments[1]);
	}
	else
	{
		//set block text
		for(var i = 1; i <= arguments.length; i++)
		{
			//if 'space' ramain default
			if(arguments[i] != ' ')
			{
				arguments[0].SetBlockText(i - 1, arguments[i]);
			}
		}
	}
}
//set text with string index
function AM_GetSTRIndex()//(string_index, [replacement], ['STRING'])
{
	var string;
	
	if(arguments.length == 3)
	{
		string = arguments[0];
	}
	else
	{
		string = StateGarage.GetString(arguments[0]).mValue;
	}
	
	if(arguments.length >= 2 && arguments[1] != '')
	{
		string = string.replace('%s', arguments[1]);
	}
	
	return string;
}
//-A-D-V-A-N-C-E-D-M-E-T-H-O-D------------------------------------------------------------------------------------//

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////get current car info
function GetCurrentCarInfo()
{
	currentCarID = StateGarage.GetCurrentCarShopItemID();
	return StateGarage.GetCarInfoByShopItemID(currentCarID,0);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////get current car lv 1 info
function GetCurrentCarInfoLevelOne()
{
	currentCarID = StateGarage.GetCurrentCarShopItemID();
	return StateGarage.GetCarInfoByShopItemID(currentCarID,1);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////get current driver info
function GetCurrentDriverInfo()
{
	currentDriverID = StateGarage.GetCurrentDriverShopItemId();
	return StateGarage.GetDriverInfoByID(currentDriverID);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////get current driver info
function GetSelectedDriverInfo()
{
	selectedDriverID = StateGarage.GetSelectedDriverShopItemId();
	return StateGarage.GetDriverInfoByID(selectedDriverID);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////show component
function ShowComponent(component_name)
{
	component_name.Show(true);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////hide component
function HideComponent(component_name)
{
	component_name.Show(false);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////hid component with ani unlock screen
function HideComponentWithAni(component_name, delay, ani_name)
{
	component_name.PlaySkeletonAnimation(delay, ani_name, false, true);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////component display config
function DisplayConfig(component_name, display_flag)
{
	component_name.Show(display_flag);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////component display config by name
function DisplayConfigByCName(c_name)
{
	c_name.CName.Show(c_name.DFlag);
	c_name.CName.Enable(c_name.EFlag);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////check component
function ClickComponent(component_name)
{
	component_name.Click();
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////uncheck component
function UnCheckComponent(component_name)
{
	component_name.Check(false);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////uncheck component
function CheckComponent(component_name)
{
	component_name.Check(true);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////enable component
function EnableComponent(component_name)
{
	component_name.Enable(true);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////disable component
function DisableComponent(component_name)
{
	component_name.Enable(false);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////set component offset
function SetComponentOffset(component_name, distance_x, distance_y)
{
	component_name.SetOffset(distance_x, distance_y);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////set text
function SetComponentText(component_name, text)
{
	component_name.SetText(text);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////set text block
function SetComponentTextBlock(component_name, block_index, text)
{
	component_name.SetBlockText( block_index, text );
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////set value
function SetComponentValue(component_name, value)
{
	component_name.SetTextByInteger(value, false);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////set value with symbol
function SetComponentValueWithSymbol(component_name, value)
{
	component_name.SetTextByInteger(value, true);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////set progressbar range
function SetPGbarRange(component_name, value)
{
	component_name.SetProgressRange(0, value);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////set front progressbar value
function SetFrontPGbarValue(component_name, value)
{
	component_name.SetProgressValue(value);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////set back progressbar value
function SetBackPGbarValue(component_name, value)
{
	component_name.SetProgressBgValue(value);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////set whole progressbar value
function SetWholePGbarValue(component_name, range_value, front_value, back_value)
{
	component_name.SetProgressRange(0, range_value);
	component_name.SetProgressValue(front_value);
	if(back_value == '')
	{
		component_name.SetProgressBgValue(front_value);
	}
	else
	{
		component_name.SetProgressBgValue(back_value);
	}
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////change component pix to grey
function ChangeComponent2Grey(component_name)
{
	component_name.SetGrey(1);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////change component pix to color
function ChangeComponent2Color(component_name)
{
	component_name.SetGrey(0);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////replace spx
function ReplaceCurrentSpx(component_name, spx_name, tag)
{
	component_name.SetCurrentRenderObject('F2DModel', spx_name, tag);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////replace spx by state
function ReplaceSpxByState(component_name, component_state, spx_name, tag)
{
	component_name.SetRenderObject(component_state, 'F2DModel', spx_name, tag);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////replace spr
function ReplaceCurrentSpr(component_name, spr_name)
{
	component_name.SetCurrentRenderObject('F2DSprite', spr_name, '');
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////replace spr by state
function ReplaceSprByState(component_name, component_state, spr_name)
{
	component_name.SetRenderObject(component_state, 'F2DSprite', spr_name, '');
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////replace button spr by state
function ReplaceButtonRes()//(component_name, normal_spr_name, ['focus_spr_name'])
{
	arguments[0].SetRenderObject(EnumGUIGraphicState.Normal, 'F2DSprite', arguments[1], '');
	arguments[0].SetRenderObject(EnumGUIGraphicState.Focus, 'F2DSprite', arguments[arguments.length - 1], '');
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////animation play
function AniPlay(component_name, delay, ani_name)
{
	if(component_name.IsShow())
	{
		component_name.PlaySkeletonAnimation(delay, ani_name, true, false);
	}
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////animation play
function AniPlayUnlockScreen(component_name, delay, ani_name)
{
	if(component_name.IsShow())
	{
		component_name.PlaySkeletonAnimation(delay, ani_name, false, false);
	}
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////animation move x
function AniMoveX(component_name, distance_x, delay, duration)
{
	component_name.OffsetTo(delay, duration, true, distance_x, 0, EnumInterpolatorType.Linear);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////animation move y
function AniMoveY(component_name, distance_y, delay, duration)
{
	component_name.OffsetTo(delay, duration, true, 0, distance_y, EnumInterpolatorType.Linear);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////animation fade in
function AniFadeIn(component_name, delay, duration)
{
	component_name.FadeIn(delay, duration, true, EnumInterpolatorType.Linear);
	component_name.Enable(true);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////animation fade in
function AniFadeInUnlockScreen(component_name, delay, duration)
{
	component_name.FadeIn(delay, duration, false, EnumInterpolatorType.Linear);
	component_name.Enable(true);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////animation fade out
function AniFadeOut(component_name, delay, duration)
{
	component_name.FadeOut(delay, duration, true, EnumInterpolatorType.Linear);
	component_name.Enable(false);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////animation fade out
function AniFadeOutUnlockScreen(component_name, delay, duration)
{
	component_name.FadeOut(delay, duration, false, EnumInterpolatorType.Linear);
	component_name.Enable(false);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////play sound
function PlaySound(component_name, sound_name, delay, volume)
{
	component_name.Show(true);
	component_name.PlaySound(sound_name, sound_name, volume, delay);
}