JSCore.Require("functions.js")
JSCore.Require("initialize.js")
JSCore.Require("display.js")

//----------------------------------------------------------------------------------------------G-A-M-E-S-T-A-R-T-//
function OnStartGame()
{
	//InitializeUIRoots();
	//uiC_navi_top_rig.setDFlag(false);
	
	//ConfigUIRoots();
}
//-G-A-M-E-S-T-A-R-T----------------------------------------------------------------------------------------------//
//------------------------------------------------------------------------------------------------------S-T-A-R-T-//
function OnStartState()
{
//carrier_build
	//HideComponent(mall_tag_present);
//carrier_build
	//HideComponent(item_next_stage_info_text);
	HideComponent(driver_card_ability_1_tn);
	HideComponent(driver_card_ability_2_tn);
	HideComponent(driver_card_ability_3_tn);
	//HideComponent(item_car_info_name);
	
	HideComponent(navi_top_popup_msg);
	ShowComponent(ui_map_root);
	//ShowComponent(ui_main_root);
	ShowComponent(ui_navi_top_root);
	uiC_navi_top_back_btn.setDFlag(false);
	//uiC_navi_top_rig.setDFlag(false);
	ConfigNaviButtons();
	SetCurrentUIData(uiR_ui_main);
	StateGarage.SelectCarByShopItemID(StateGarage.GetCurrentPlayerCarShopItemID());
	InitializeMain();
}
//-S-T-A-R-T------------------------------------------------------------------------------------------------------//
function OnTutorialFinish(id)
{
	switch(id)
	{
		case 4:
			stringIndex = 121;
			break;
		case 6:
			stringIndex = 122;
			break;	
		case 10:
			stringIndex = 113;
			break;
		case 11:
			stringIndex = 122;
			break;
		case 12:
			stringIndex = 122;
			break;
		default :
			stringIndex = 113;
	}
}
//----------------------------------------------------------------------------------------------------F-I-N-I-S-H-//
function OnBackToGarage( autoExecStage )
{
	var current_chapterid = StateGarage.GetSelectedChapter();
	var current_stageid = StateGarage.GetSelectedStage();
	var current_stage = StateGarage.GetStageInfoByID(current_chapterid, current_stageid);

	AM_SetComponentText(item_next_stage_info_text, current_chapterid.toString() + '-' + current_stageid.toString());
	AM_SetComponentText(item_next_stage_info_type, current_stage.mType.toString());
	//AM_SetComponentText(item_next_stage_info_type, '12');
	AM_SetComponentText(item_next_stage_info_obj, ' ', current_stage.mClearDesc, ' ');
	
	if(current_stage.mType == 3 )
	{
		//dialog stage
		if ( autoExecStage )
		{
			if( !(current_chapterid == 1 && current_stageid == 1) )
			{
				if ( current_chapterid == 1 && current_stageid == 5 )
				{
					// 好友功能解锁后
					if ( StateGarage.IsTutorialFinished( 14 ) )
					{
						StateGarage.LaunchStage(current_chapterid, current_stageid);
					}
				}
				else
				{
					StateGarage.LaunchStage(current_chapterid, current_stageid);
				}
			}
		}
		
		ClickStageButton();
	}
	else
	{
		//normal stage
		ClickStageContinueButton();
	}
	
	ShowComponent(ui_map_root);
	ShowComponent(ui_navi_top_root);
}

function OnFinishChallenge(challenge_group_id)
{
	//ClickChallengeButton();
	ConfigChallengeGroup(challenge_group_id);
	
	ShowComponent(ui_map_root);
	ShowComponent(ui_navi_top_root);
}

function BackToStage()
{
	ClickStageButton();
	ShowComponent(ui_map_root);
	ShowComponent(ui_navi_top_root);
}

function ShowNaviTopAndMap()
{
	ShowComponent(ui_map_root);
	ShowComponent(ui_navi_top_root);
	SetCurrentUIData(uiR_ui_main);
}
//-F-I-N-I-S-H----------------------------------------------------------------------------------------------------//
//--------------------------------------------------------------------------------------------------C-A-R-D-A-T-A-//
function RefreshCurrentCarData(currentcarinfor)
{
	var acc_plus = '';
	var spmax_plus = '';
	var turning_plus = '';
	var maxData = StateGarage.GetMaxLevelCarInfo(StateGarage.GetCurrentCarShopItemID());
	var currentCarSpeedTotal = 0;
	
	currentCar = currentcarinfor;
	if(uiR_ui_garage.DFlag)
	{
		//car class
		SetComponentValue(garage_class, currentcarinfor.mClass);
		if(currentcarinfor.mClass == 0)
		{
			ReplaceSprByState(garage_namebar, EnumGUIGraphicState.Normal, 'ui_garage_name_vip_bg');
			ReplaceSprByState(garage_class, EnumGUIGraphicState.Normal, 'ui_car_class_vip_bg');
			ShowComponent(garage_class_vip);
		}
		else
		{
			ReplaceSprByState(garage_namebar, EnumGUIGraphicState.Normal, 'ui_garage_name_bg');
			ReplaceSprByState(garage_class, EnumGUIGraphicState.Normal, 'ui_car_class_bg');
			HideComponent(garage_class_vip);
		}
		//speed limit
		ConfigCarMaxSpeedWithDriverSkill(StateGarage.GetCurrentDriverShopItemId(), currentcarinfor);
		
		//car name
		SetComponentText(item_car_info_name, currentcarinfor.mName);
		//car weight
		switch(currentcarinfor.mWeight)
		{
			case 1:
				SetComponentValue(garage_weight, 0);
				break;
			case 2:
				SetComponentValue(garage_weight, 1);
				break;
			case 3:
				SetComponentValue(garage_weight, 2);
				break;
		}
		//car type
		SetComponentValue(garage_cartype, currentcarinfor.mCarType);
		//car name
		SetComponentText(garage_namebar, currentcarinfor.mName);
		SetComponentText(garage_namebar_shadow, currentcarinfor.mName);
		SetComponentText(garage_namebar_eff, currentcarinfor.mName);
		//ReplaceSprByState(navi_top_rig_car_icon, EnumGUIGraphicState.Normal, 'icon_' + currentcarinfor.mIconName);
		//pgbar
		AM_SetPGbarValue(garage_status_pgbar_acc, 999, currentcarinfor.mAccelCurrLevelDisplayValue, currentcarinfor.mAccelNextLevelDisplayValue);
		AM_SetPGbarValue(garage_status_pgbar_spmax, 999, currentcarinfor.mMaxSpeedCurrLevelDisplayValue, currentcarinfor.mMaxSpeedNextLevelDisplayValue);
		AM_SetPGbarValue(garage_status_pgbar_turning, 999, currentcarinfor.mTurningCurrLevelDisplayValue, currentcarinfor.mTurningNextLevelDisplayValue);	
		//car lv
		SetComponentText(garage_lv, 'LV.' + currentcarinfor.mLevel.toString());
		//full lv
		if(currentCar.mCarLevelIsFull)
		{
			ShowComponent(garage_lvmax);
			HideComponent(garage_data_price);
			uiC_garage_fuction_btn_upgd.setDFlag(false);
			uiC_garage_btn_upgd2max.setDFlag(false);
			//SetComponentText(garage_fuction_btn_upgd, '1');
			//ChangeComponent2Grey(uiC_garage_fuction_btn_upgd.CName);
			//ReplaceButtonRes(uiC_garage_fuction_btn_upgd.CName, 'ui_btn_pop_g');
			SetComponentText(garage_intro_text, StateGarage.GetString(109).mValue);
		}
		else
		{
			HideComponent(garage_lvmax);
			ShowComponent(garage_data_price);
			acc_plus = 'A' + currentcarinfor.mAccelNextLevelDisplayValue;
			spmax_plus = 'A' + currentcarinfor.mMaxSpeedNextLevelDisplayValue;
			turning_plus = 'A' + currentcarinfor.mTurningNextLevelDisplayValue;
			uiC_garage_fuction_btn_upgd.setDFlag(true);
			uiC_garage_btn_upgd2max.setDFlag(true);
			//SetComponentText(garage_fuction_btn_upgd, '0');
			//ChangeComponent2Color(uiC_garage_fuction_btn_upgd.CName);
			//ReplaceButtonRes(uiC_garage_fuction_btn_upgd.CName, 'ui_btn_pop_y');
			SetComponentText(garage_intro_text, StateGarage.GetString(108).mValue);
		}
		//current data
		AM_SetComponentText(garage_status_acc_data_cur, currentcarinfor.mAccelCurrLevelDisplayValue.toString(), acc_plus);
		AM_SetComponentText(garage_status_spmax_data_cur, currentcarinfor.mMaxSpeedCurrLevelDisplayValue.toString(), spmax_plus);
		AM_SetComponentText(garage_status_turning_data_cur, currentcarinfor.mTurningCurrLevelDisplayValue.toString(), turning_plus);
		//set price
		if(currentcarinfor.mUpgradeCoin == 0 && currentcarinfor.mUpgradeMoney == 0)
		{
			SetComponentText(garage_data_price, 'P----');
		}
		else
		{
			SetPrice(garage_data_price, currentcarinfor.mUpgradeCoin, currentcarinfor.mUpgradeMoney, 'P');
		}
		
	}
	if(uiR_ui_dealer.DFlag)
	{
		//currentCar = GetCurrentCarInfoLevelOne();
		//currentcarinfor	= GetCurrentCarInfoLevelOne();
		//car class
		SetComponentValue(dealer_class, currentcarinfor.mClass);
		if(currentcarinfor.mClass == 0)
		{
			ReplaceSprByState(dealer_namebar, EnumGUIGraphicState.Normal, 'ui_garage_name_vip_bg');
			ReplaceSprByState(dealer_class, EnumGUIGraphicState.Normal, 'ui_car_class_vip_bg');
			ShowComponent(dealer_class_vip);
		}
		else
		{
			ReplaceSprByState(dealer_namebar, EnumGUIGraphicState.Normal, 'ui_garage_name_bg');
			ReplaceSprByState(dealer_class, EnumGUIGraphicState.Normal, 'ui_car_class_bg');
			HideComponent(dealer_class_vip);
		}
		//car weight
		switch(currentcarinfor.mWeight)
		{
			case 1:
				SetComponentValue(dealer_weight, 0);
				break;
			case 2:
				SetComponentValue(dealer_weight, 1);
				break;
			case 3:
				SetComponentValue(dealer_weight, 2);
				break;
		}
		/*
		if(currentcarinfor.mWeight == 1)
		{
			SetComponentValue(dealer_weight, 0);
		}
		else if(currentcarinfor.mWeight == 3)
		{
			SetComponentValue(dealer_weight, 2);
		}
		else
		{
			SetComponentValue(dealer_weight, 1);
		}
		*/
		//car type
		SetComponentValue(dealer_cartype, currentcarinfor.mCarType);
		//car name
		SetComponentText(dealer_namebar, currentcarinfor.mName);
		SetComponentText(dealer_namebar_shadow, currentcarinfor.mName);
		SetComponentText(dealer_namebar_eff, currentcarinfor.mName);
		//pgbar front
		//AM_SetPGbarValue(dealer_status_pgbar_acc, 999, currentcarinfor.mAccelCurrLevelDisplayValue);
		//AM_SetPGbarValue(dealer_status_pgbar_spmax, 999, currentcarinfor.mMaxSpeedCurrLevelDisplayValue);
		//AM_SetPGbarValue(dealer_status_pgbar_turning, 999, currentcarinfor.mTurningCurrLevelDisplayValue);
		
		AM_SetPGbarValue(dealer_status_pgbar_acc, 999, currentCar.mAccelCurrLevelDisplayValue, maxData.mAccelValue);
		AM_SetPGbarValue(dealer_status_pgbar_spmax, 999, currentCar.mMaxSpeedCurrLevelDisplayValue, maxData.mMaxSpeedValue);
		AM_SetPGbarValue(dealer_status_pgbar_turning, 999, currentCar.mTurningCurrLevelDisplayValue, maxData.mTurningValue);
		//current
		AM_SetComponentText(dealer_status_acc_data_cur, currentcarinfor.mAccelCurrLevelDisplayValue.toString(), '/' + maxData.mAccelValue);
		AM_SetComponentText(dealer_status_spmax_data_cur, currentcarinfor.mMaxSpeedCurrLevelDisplayValue.toString(), '/' + maxData.mMaxSpeedValue);
		AM_SetComponentText(dealer_status_turning_data_cur, currentcarinfor.mTurningCurrLevelDisplayValue.toString(), '/' + maxData.mTurningValue);
		//AM_SetComponentValue(dealer_status_weight_data_cur, currentcarinfor.mWeight);
		//lock
		SetComponentText(dealer_lock, currentcarinfor.mLockDescription);
		//set price
		switch(currentcarinfor.mCarId)
		{
			case 13:
				ConfigSaleInfo(dealer_sale_banner, 'ui_welcomeplus_banner');
				if(StateGarage.IsGiftPackBought(1))
				{
					SetPrice(dealer_data_price, currentcarinfor.mCostCoin, 85, currentcarinfor.mCostRMB, 'S');
				}
				else
				{
					SetPrice(dealer_data_price, currentcarinfor.mCostCoin, currentcarinfor.mCostMoney, currentcarinfor.mCostRMB, 'P');
				}
				break;
			case 37:
				ConfigSaleInfo(dealer_sale_banner, 'ui_challenge_ad_ae86');
				SetPrice(dealer_data_price, currentcarinfor.mCostCoin, currentcarinfor.mCostMoney, currentcarinfor.mCostRMB, 'P');
				break;
			case 39:
				ConfigSaleInfo(dealer_sale_mark, dealer_sale_banner, 'ui_sale_info_bumble_t');
				SetPrice(dealer_data_price, currentcarinfor.mCostCoin, currentcarinfor.mCostMoney, currentcarinfor.mCostRMB, 'B');
				break;	
			default:
				//HideComponent(dealer_sale_mark);
				//HideComponent(dealer_sale_banner);
				SetPrice(dealer_data_price, currentcarinfor.mCostCoin, currentcarinfor.mCostMoney, currentcarinfor.mCostRMB, 'P');
		}
		//SetComponentText(dealer_data_price, currentcarinfor.mCostRMB.toString());
		//set car desc
		SetComponentText(dealer_intro_text, currentcarinfor.mCarDescription);
	}
}

function ConfigSaleInfo()//(component_sale_mark, banner_component, banner_res, )
{	
	switch(arguments.length)
	{
		case 2:
			ReplaceSprByState(arguments[0], EnumGUIGraphicState.Normal, arguments[1]);
			ShowComponent(arguments[0]);
			AniPlay(arguments[0], 200, 'ui_ani_show_default');
			break;
		case 3:
			ReplaceSprByState(arguments[1], EnumGUIGraphicState.Normal, arguments[2]);
			ShowComponent(arguments[1]);
			AniPlay(arguments[1], 200, 'ui_ani_show_default');
		default:
			ShowComponent(arguments[0]);
			AniPlay(arguments[0], 500, 'ui_ani_show_default');
	}
	
	//if(arguments.length == 1)
	//{
	//	ShowComponent(arguments[0]);
	//	AniPlay(arguments[0], 300, 'ui_ani_show_default');
	//}
	//else
	//{
	//	ReplaceSprByState(arguments[0], EnumGUIGraphicState.Normal, arguments[1]);
	//	ShowComponent(arguments[1]);
	//	AniPlay(arguments[1], 200, 'ui_ani_show_default');
	//}
}
//-C-A-R-D-A-T-A--------------------------------------------------------------------------------------------------//
//--------------------------------------------------------------------------------------------U-P-G-R-A-D-E-C-A-R-//
function OnUpgradeCar()
{
	//--<CONFIG>--//hide car data plus
	RefreshCurrentCarData(GetCurrentCarInfo());
	
	//InitializePopupGarage();
	
	if(currentCar.mCarLevelIsFull)
	{
		ShowComponent(garage_lvmax);
		HideComponent(garage_data_price);
		uiC_garage_fuction_btn_upgd.setDFlag(false);
		uiC_garage_btn_upgd2max.setDFlag(false);
		//uiC_garage_btn_upgd2max_confirm.setDFlag(false);
		//uiC_garage_btn_upgd2max_cancel.setDFlag(false);
		ConfigShowgirl(garage_girl, '', AM_GetSTRIndex(103));
	}
	
	ConfigCarFunctionButtons();
	
	ShowComponent(garage_data_bg_head_eff);
	AniPlayUnlockScreen(garage_data, 0, 'ui_ani_show_mvrl');	
}

function ClickUpgradeCar2MaxLvButton()
{
	var maxData = StateGarage.GetMaxLevelCarInfo(StateGarage.GetCurrentCarShopItemID());
	
	InitializeUIPopup();
	//current data
	AM_SetComponentText(popup_upg2max_status_acc_data_cur, currentCar.mAccelCurrLevelDisplayValue.toString(), 'A' + maxData.mAccelValue);
	AM_SetComponentText(popup_upg2max_status_spmax_data_cur, currentCar.mMaxSpeedCurrLevelDisplayValue.toString(), 'A' + maxData.mMaxSpeedValue);
	AM_SetComponentText(popup_upg2max_status_turning_data_cur, currentCar.mTurningCurrLevelDisplayValue.toString(), 'A' + maxData.mTurningValue);
	//pgbar
	AM_SetPGbarValue(popup_upg2max_status_pgbar_acc, 999, currentCar.mAccelCurrLevelDisplayValue, maxData.mAccelValue);
	AM_SetPGbarValue(popup_upg2max_status_pgbar_spmax, 999, currentCar.mMaxSpeedCurrLevelDisplayValue, maxData.mMaxSpeedValue);
	AM_SetPGbarValue(popup_upg2max_status_pgbar_turning, 999, currentCar.mTurningCurrLevelDisplayValue, maxData.mTurningValue);
	//set price
	SetPrice(popup_upg2max_confirm_price, currentCar.mUpgradeCoin, currentCar.mUpgrade2MaxCost, 'P');

	uiR_ui_popup_upg2max.setDFlag(true);
	
	ConfigUIPopup();
}

function ClickUpgradeCar2MaxLvCancelButton()
{
	InitializeUIPopup();
	ConfigUIPopup();
}
//-U-P-G-R-A-D-E-C-A-R--------------------------------------------------------------------------------------------//
//----------------------------------------------------------------------------------------------C-H-A-N-G-E-C-A-R-//
function OnChangeCar()
{
	//uiC_garage_btn_upgd2max.setDFlag(true);
	//uiC_garage_fuction_btn_upgd.setDFlag(true);
	
	//RefreshCurrentCarData(GetCurrentCarInfo());
	ShowComponent(garage_data_bg_head_eff);
	
	if(uiR_ui_garage.DFlag)
	{
		RefreshCurrentCarData(GetCurrentCarInfo());
		AniPlayUnlockScreen(garage_data, 0, 'ui_ani_show_mvrl');
		AniPlayUnlockScreen(garage_namebar, 200, 'ui_ani_show_mvx_fd');
		ShowComponent(garage_class);
		AniPlayUnlockScreen(garage_class, 400, 'ui_ani_show_default');
		AniPlayUnlockScreen(garage_weight, 350, 'ui_ani_show_mvx_fd');
		AniPlayUnlockScreen(garage_cartype, 400, 'ui_ani_show_mvx_fd');
	}
	else if(uiR_ui_dealer.DFlag)
	{
		HideComponent(dealer_sale_mark);
		HideComponent(dealer_sale_banner);
		RefreshCurrentCarData(GetCurrentCarInfoLevelOne());
		AniPlayUnlockScreen(dealer_data, 0, 'ui_ani_show_mvrl');
		if(currentCar.mIsPurchased)
		{
			HideComponent(dealer_lockedcar);
			HideComponent(dealer_lock);
			HideComponent(dealer_data_price);
			HideComponent(dealer_btn_purchase);
			ShowComponent(dealer_purchased);
			ShowComponent(dealer_soldout);
		}
		else
		{
			HideComponent(dealer_purchased);
			HideComponent(dealer_soldout);
			//ShowComponent(dealer_lockedcar);
			//AniFadeInUnlockScreen(dealer_lockedcar, 500, 300);
			if(currentCar.mIsLock)
			{
				ShowComponent(dealer_lock);
				HideComponent(dealer_btn_purchase);
				ShowComponent(dealer_lockedcar);
				ShowComponent(dealer_data_price);
			}
			else
			{
				ShowComponent(dealer_btn_purchase);
				HideComponent(dealer_lock);
				HideComponent(dealer_lockedcar);
				ShowComponent(dealer_data_price);
				//AniFadeInUnlockScreen(dealer_btn_purchase, 500, 300);
			}
	
			//AniPlayUnlockScreen(dealer_namebar, 200, 'ui_ani_show_mvx_fd');
			//AniPlayUnlockScreen(dealer_class, 300, 'ui_ani_show_mvx_fd');
		}
		AniPlayUnlockScreen(dealer_namebar, 200, 'ui_ani_show_mvx_fd');
		ShowComponent(dealer_class);
		AniPlayUnlockScreen(dealer_class, 400, 'ui_ani_show_default');
		AniPlayUnlockScreen(dealer_weight, 350, 'ui_ani_show_mvx_fd');
		AniPlayUnlockScreen(dealer_cartype, 400, 'ui_ani_show_mvx_fd');
	}
	ConfigCarFunctionButtons();
	//change intro
	if(!dealer_girl.IsShow())
	{
		AniPlayUnlockScreen(dealer_intro, 500, 'ui_ani_show_default');
	}
	if(!garage_girl.IsShow())
	{
		AniPlayUnlockScreen(garage_intro, 500, 'ui_ani_show_default');
	}
}
//-C-H-A-N-G-E-C-A-R----------------------------------------------------------------------------------------------//
//--------------------------------------------------------------------------------------------------------Y-C-A-R-//
function OnBuyCar()
{
	StateGarage.SelectCarByShopItemID(StateGarage.GetBoughtCarShopItemID());
	OnChangeCar();
	ConfigShowgirl(dealer_girl, '', AM_GetSTRIndex(104));
}
//-B-U-Y-C-A-R----------------------------------------------------------------------------------------------------//
//----------------------------------------------------------------------------------------------S-E-L-E-C-T-C-A-R-//
function OnSelectCar()
{
	//ReplaceSprByState(navi_top_rig_car_icon, EnumGUIGraphicState.Normal, 'icon_' + GetCurrentCarInfo().mIconName);
	
	ConfigCarFunctionButtons();
	ConfigShowgirl(garage_girl, '', AM_GetSTRIndex(105));
}
//-S-E-L-E-C-T-C-A-R----------------------------------------------------------------------------------------------//
//----------------------------------------------------------------------------------------------B-U-Y-D-R-I-V-E-R-//
function OnBuyDriver()
{
	ConfigDriverInfo(StateGarage.GetCurrentDriverShopItemId());
	ReplaceSprByState(navi_top_rig_driver_icon, EnumGUIGraphicState.Normal, GetCurrentDriverInfo().mIcon);
}
//-B-U-Y-D-R-I-V-E-R----------------------------------------------------------------------------------------------//
//--------------------------------------------------------------------------------------U-P-G-R-A-D-E-D-R-I-V-E-R-//
function OnUpgradeDriver()
{
	ConfigDriverInfo(StateGarage.GetCurrentDriverShopItemId());
}
//-U-P-G-R-A-D-E-D-R-I-V-E-R--------------------------------------------------------------------------------------//
//----------------------------------------------------------------------------------------S-E-L-E-C-T-D-R-I-V-E-R-//
function OnSelectDriver()
{
	ReplaceSprByState(navi_top_rig_driver_icon, EnumGUIGraphicState.Normal, GetCurrentDriverInfo().mIcon);
	
	if(StateGarage.GetCurrentDriverShopItemId() == StateGarage.GetSelectedDriverShopItemId())
	{
		uiC_driver_btn_select.setDFlag(true);
		uiC_driver_btn_select.setEFlag(false);
		SetComponentText(driver_btn_select, '1');
		ReplaceButtonRes(uiC_driver_btn_select.CName, 'ui_btn_pop_g');
	}
	else
	{
		uiC_driver_btn_select.setDFlag(true);
		uiC_driver_btn_select.setEFlag(true);
		SetComponentText(driver_btn_select, '0');
		ReplaceButtonRes(uiC_driver_btn_select.CName, 'ui_btn_pop_r');
	}
	ConfigDriverFunctionButtons();
}
//-S-E-L-E-C-T-D-R-I-V-E-R----------------------------------------------------------------------------------------//
//--------------------------------------------------------------------------------------------------S-T-A-N-D-B-Y-//
function OnStandBy()
{
	var delay = 0;
	ClickBackButton();
	if(!flag_click_btmbar_garage)
	{
		OnBackToGarage( 0 );
		delay = 100;
	}
	else
	{

	}
	
	flag_show_btn_standby = true;
	ConfigStandbyButtons(delay);
	flag_show_btn_upgrade = false;
	ConfigFunctionButtons(false);
	flag_show_navi_btn = false;
}

//-S-T-A-N-D-B-Y--------------------------------------------------------------------------------------------------//
//------------------------------------------------------------------------------------------------F-U-N-C-T-I-O-N-//

//-F-U-N-C-T-I-O-N------------------------------------------------------------------------------------------------//