LuaCore.Require("functions.lua")
LuaCore.Require("initialize.lua")
LuaCore.Require("display.lua")

function FunctionTest()

end
----------------------------------------------------------------------------------------------------B-U-N-T-T-O-N---
----------------------------------------------------------------------------------------------------N-A-V-I-T-O-P---
function ClickNaviBack()
	local functionName = 'ClickNaviBack'
	InitializeUIRoots()
	
	if ui_select_item_root:IsShow() == 1 then
		if flag_championship_mode == true then
			_uiComponentDisplay.setDFlag(uiR_ui_championship, true)
			_uiComponentDisplay.setDFlag(uiC_navi_top_back_btn, true)
			SetCurrentUIData(uiR_ui_championship)
			InitializeChampionship()
			--AniMoveY(stage_info_title, 430, 200, 100)
			AniPlayUnlockScreen(stage_info_title, 200, 'ui_ani_show_default')
			flag_move_stage_title = true
			ShowComponent(stage_sub_info)
			AniPlayUnlockScreen(stage_sub_info, 300, 'ui_ani_show_default')
			--InitializeMap()
		elseif flag_vs_mode == true then
			_uiComponentDisplay.setDFlag(uiR_ui_vsmode, true)
			_uiComponentDisplay.setDFlag(uiC_navi_top_back_btn, true)
			SetCurrentUIData(uiR_ui_vsmode)
			InitializeVSMode()
			
		else
			_uiComponentDisplay.setDFlag(uiR_ui_stage, true)
			_uiComponentDisplay.setDFlag(uiC_navi_top_back_btn, true)
			SetCurrentUIData(uiR_ui_stage)
			InitializeStage()
			--AniMoveY(stage_info_title, 430, 200, 100)
			AniPlayUnlockScreen(stage_info_title, 200, 'ui_ani_show_default')
			flag_move_stage_title = true
			ShowComponent(stage_sub_info)
			AniPlayUnlockScreen(stage_sub_info, 300, 'ui_ani_show_default')
			--InitializeMap()
		end
		flag_move_stage_title = true
	end
	if ui_stage_root:IsShow() == 1 then
		_uiComponentDisplay.setDFlag(uiR_ui_main, true)
		_uiComponentDisplay.setDFlag(uiC_navi_top_back_btn, false)
		SetCurrentUIData(uiR_ui_main)
		--HideComponentWithAni(stage_info_title, 100, 'ui_ani_hide_default')
		InitializeMain()
	end
	if ui_championship_root:IsShow() == 1 then
		_uiComponentDisplay.setDFlag(uiR_ui_main, true)
		_uiComponentDisplay.setDFlag(uiC_navi_top_back_btn, false)
		SetCurrentUIData(uiR_ui_main)
		--HideComponentWithAni(stage_info_title, 100, 'ui_ani_hide_default')
		flag_championship_mode = false
		InitializeMain()
	end
	if ui_vsmode_root:IsShow() == 1 then
		_uiComponentDisplay.setDFlag(uiR_ui_main, true)
		_uiComponentDisplay.setDFlag(uiC_navi_top_back_btn, false)
		SetCurrentUIData(uiR_ui_main)
		flag_vs_mode = false
		InitializeMain()
	end
	
	ConfigUIRoots()
	ConfigNaviButtons()
end
function PopMsg(...)--([string_index], [replacement])
	local arguments = {...}
	local string_index = 102
	local replacement = ''

	for v in ipairs(arguments) do
		if v == 1 then
			string_index = arguments[v]
		elseif v == 2 then
			replacement = arguments[v]
		end
	end

	SetComponentText(navi_top_popup_msg_text, AM_GetSTR(string_index, replacement))
	ShowComponent(navi_top_popup_msg)
	AniPlayUnlockScreen(navi_top_popup_msg, 0, 'ui_ani_show_popup_nobtn')
	AM_PlaySound(navi_top_popup_msg, 0, 'sfx_ui_disable', 1)
end
----------------------------------------------------------------------------------------------------------M-A-I-N---
function ClickButtonMask()
	SetComponentText(navi_top_popup_msg_text, StateGarage:GetString(102).mValue)
	ShowComponent(navi_top_popup_msg)
	AniPlayUnlockScreen(navi_top_popup_msg, 0, 'ui_ani_show_popup_nobtn')
end

function ClickButtonMaskUnfinishTutorial()
	if StateGarage:GetCurrentPlayerCarShopItemID() == 0 then
		stringIndex = 121
	elseif StateGarage:IsTutorialFinished(6) ~= 0 then
		if StateGarage:IsTutorialFinished(5) == 0 then
			stringIndex = 122
		else
			stringIndex = 113
		end
	end
	SetComponentText(navi_top_popup_msg_text, StateGarage:GetString(stringIndex).mValue)
	ShowComponent(navi_top_popup_msg)
	AniPlayUnlockScreen(navi_top_popup_msg, 0, 'ui_ani_show_popup_nobtn')
end

function ClickButtonMaskSIUnfinishTutorial()
	SetComponentText(navi_top_popup_msg_text, StateGarage:GetString(122).mValue)
	ShowComponent(navi_top_popup_msg)
	AniPlayUnlockScreen(navi_top_popup_msg, 0, 'ui_ani_show_popup_nobtn')
end

function ClickButtonMaskRMPR()
	SetComponentText(navi_top_popup_msg_text, StateGarage:GetString(25).mValue)
	ShowComponent(navi_top_popup_msg)
	AniPlayUnlockScreen(navi_top_popup_msg, 0, 'ui_ani_show_popup_nobtn')
end

function ClickButtonMaskADUnfinishTutorial()
	SetComponentText(navi_top_popup_msg_text, StateGarage:GetString(113).mValue)
	ShowComponent(navi_top_popup_msg)
	AniPlayUnlockScreen(navi_top_popup_msg, 0, 'ui_ani_show_popup_nobtn')
end

function Back2Main()
	InitializeUIRoots()
	
	_uiComponentDisplay.setDFlag(uiR_ui_main, true)
	_uiComponentDisplay.setDFlag(uiC_navi_top_back_btn, false)
	SetCurrentUIData(uiR_ui_main)
	InitializeMain()
	
	ConfigUIRoots()
	ConfigNaviButtons()
end

function ClickBack2TitleButton()
	ClearScreen(true)
end

function ClickB2TCancelButton()
	ClearScreen(false, 0)
end

function ClickVMButton()
	ClearScreen(true)
	ShowComponent(navi_top_close_vm_btn)
	AniPlayUnlockScreen(navi_top_close_vm_btn, 600, 'ui_ani_show_default')
	HideComponent(navi_top_vm_btn)
end

function ClickVMCloseButton()
	ClearScreen(false, 0)
	HideComponentWithAni(navi_top_close_vm_btn, 0, 'ui_ani_hide_default')
	-- HideComponent(navi_top_close_vm_btn)
	ShowComponent(navi_top_vm_btn)
	AniPlayUnlockScreen(navi_top_vm_btn, 600, 'ui_ani_show_default')
end
--[[
function ClickSidebarButton()
	if flag_pop_sidebar == false then
		AniMoveX(main_sidebar_right, -350, 200, 150)
		flag_pop_sidebar = true
		HideComponentWithAni(main_driver_icon, 100, 'ui_ani_hide_default')
	else
		AniMoveX(main_sidebar_right, 350, 200, 150)
		flag_pop_sidebar = false
		ShowComponent(main_driver_icon)
		AniPlayUnlockScreen(main_driver_icon, 300, 'ui_ani_show_default')
	end
end
--]]
--------------------------------------------------------------------------------------------------------S-T-A-G-E---
function ClickStageButton()	
	SetStageInfo()
	
	StateGarage:OnGoToStage()
end

function SetStageInfo()	
	local functionName = 'SetStageInfo'
	InitializeUIRoots()
	
	_uiComponentDisplay.setDFlag(uiR_ui_stage, true)

	_uiComponentDisplay.setDFlag(uiC_navi_top_back_btn, true)
	
	--HideComponent(main_btn_mission_dialog_bubble)
	--AniPlayUnlockScreen(main_sidebar_left, 100, 'ui_ani_show_default')
	--AniPlayUnlockScreen(main_sidebar_right, 100, 'ui_ani_show_default')

	AniPlayUnlockScreen(main_btn_bg, 100, 'ui_ani_hide_main_dbar')
	InitializeStage()
	
	ConfigUIRoots()
	ConfigNaviButtons()
	SetCurrentUIData(uiR_ui_stage)
	AM_PringLog('CALL: ' .. functionName)
end
------------------------------------------------------------------------------------------------S-T-A-G-E-I-N-F-O---
function ClickSubstageButton()
	local functionName = 'ClickSubstageButton'
	local cur_chapter_id = StateGarage:GetSelectedChapter()
	local cur_stage_id = StateGarage:GetSelectedStage()
	local cur_substage = StateGarage:GetStageInfoByID(cur_chapter_id, cur_stage_id)
	
	SetSubstageData(cur_chapter_id, cur_stage_id)
	
	--stage status
	if cur_substage.mStatus == 3 then
		--locked stage
		ShowComponent(stage_locked)
		ShowComponent(stage_locked_text)
		AniPlayUnlockScreen(stage_locked, 0, 'ui_ani_show_popup_nobtn')
		AM_PlaySound(stage_locked, 0, 'sfx_ui_disable', 1)
		
		AM_SetComponentText(stage_info_stage_num, cur_chapter_id .. '-' .. cur_stage_id, ' ', 0)
		AM_SetComponentText(item_next_stage_info_speed, ' ', '----', '')
		SetComponentText(stage_info_main_waist, '')
		AM_SetComponentText(stage_info_main_bottom, '0', '----', '', '')
		AM_SetComponentText(stage_info_gold_detail, 'g', ' ', '----', ' ', '')
		AM_SetComponentText(stage_info_silver_detail, 's', ' ', '----', ' ', '')
		AM_SetComponentText(stage_info_copper_detail, 'b', ' ', '----', ' ', '')
		
		HideComponent(stage_btn_next)
		flag_show_btn_next = true
		HideComponent(stage_btn_sinario)
		flag_show_btn_sinario = true
		ReplaceButtonRes(stage_sub_bg_text, 'ui_stage_target')
	else
		StateGarage:OnViewStageInfo()
		ShowComponent(stage_bg)
		AM_PlaySound(stage_bg, 0, 'sfx_ui_confirm', 1)
		ShowComponent(stage_info_waist_eff)
		
		--dialog stage
		if cur_substage.mType == 3 then
			HideComponent(stage_btn_next)
			flag_show_btn_next = true
			ShowComponent(stage_btn_sinario)
			ReplaceButtonRes(stage_sub_bg_text, 'ui_stage_story')
			if flag_show_btn_sinario == true then
				AniPlayUnlockScreen(stage_btn_sinario, 400, 'ui_ani_show_default')
				flag_show_btn_sinario = false
			end
			
			if selected_substage == cur_chapter_id .. cur_stage_id then
				StateGarage:LaunchStage(cur_chapter_id, cur_stage_id)
				AM_PringLog('substage: 2nd click')
			else
				selected_substage = cur_chapter_id .. cur_stage_id
				AM_PringLog('substage: 1st click')
			end
		--normal stage
		else
			ShowComponent(stage_btn_next)
			if flag_show_btn_next == true then
				AniPlayUnlockScreen(stage_btn_next, 400, 'ui_ani_show_default')
				flag_show_btn_next = false
			end
			HideComponent(stage_btn_sinario)
			ReplaceButtonRes(stage_sub_bg_text, 'ui_stage_target')
			flag_show_btn_sinario = true
			
			if selected_substage == cur_chapter_id .. cur_stage_id then
				ClickStageContinueButton()
				AM_PringLog('substage: 2nd click')
			else
				selected_substage = cur_chapter_id .. cur_stage_id
				AM_PringLog('substage: 1st click')
			end
			
		end
	end
end

function SetSubstageDefaultData()
	local functionName = 'SetSubstageDefaultData'
	local cur_chapter_id = StateGarage:GetSelectedChapter()
	local cur_stage_id = StateGarage:GetSelectedStage()
	local cur_substage = StateGarage:GetStageInfoByID(cur_chapter_id, cur_stage_id)
	
	SetSubstageData(cur_chapter_id, cur_stage_id)
	
	--stage status
	if cur_substage.mStatus == 3 then
		--locked stage
		ShowComponent(stage_locked)
		ShowComponent(stage_locked_text)
		AniPlayUnlockScreen(stage_locked, 0, 'ui_ani_show_popup_nobtn')
		AM_PlaySound(stage_locked, 0, 'sfx_ui_disable', 1)
		
		AM_SetComponentText(stage_info_stage_num, cur_chapter_id .. '-' .. cur_stage_id, ' ', 0)
		AM_SetComponentText(item_next_stage_info_speed, ' ', '----', '')
		SetComponentText(stage_info_main_waist, '')
		AM_SetComponentText(stage_info_main_bottom, '0', '----', '', '')
		AM_SetComponentText(stage_info_gold_detail, 'g', ' ', '----', ' ', '')
		AM_SetComponentText(stage_info_silver_detail, 's', ' ', '----', ' ', '')
		AM_SetComponentText(stage_info_copper_detail, 'b', ' ', '----', ' ', '')
		
		HideComponent(stage_btn_next)
		flag_show_btn_next = true
		HideComponent(stage_btn_sinario)
		ReplaceButtonRes(stage_sub_bg_text, 'ui_stage_target')
		flag_show_btn_sinario = true
	else
		StateGarage:OnViewStageInfo()
		ShowComponent(stage_bg)
		--AM_PlaySound(stage_bg, 0, 'sfx_ui_confirm', 1)
		ShowComponent(stage_info_waist_eff)
		
		--dialog stage
		if cur_substage.mType == 3 then
			HideComponent(stage_btn_next)
			flag_show_btn_next = true
			ShowComponent(stage_btn_sinario)
			ReplaceButtonRes(stage_sub_bg_text, 'ui_stage_story')
			if flag_show_btn_sinario == true then
				AniPlayUnlockScreen(stage_btn_sinario, 400, 'ui_ani_show_default')
				flag_show_btn_sinario = false
			end
			
			selected_substage = cur_chapter_id .. cur_stage_id
		--normal stage
		else
			ShowComponent(stage_btn_next)
			if flag_show_btn_next == true then
				AniPlayUnlockScreen(stage_btn_next, 400, 'ui_ani_show_default')
				flag_show_btn_next = false
			end
			HideComponent(stage_btn_sinario)
			ReplaceButtonRes(stage_sub_bg_text, 'ui_stage_target')
			flag_show_btn_sinario = true

			selected_substage = cur_chapter_id .. cur_stage_id
		end
	end
end
----------------------------------------------------------------------------------------------I-T-E-M-S-E-L-E-C-T---
function ClickStageContinueButton()
	local functionName = 'ClickStageContinueButton'
	local current_driver_id = StateGarage:GetSelectedDriverShopItemId()
	
	if flag_championship_mode == false then
		StateGarage:OnGoToItemsUI()
	end
	
	InitializeUIRoots()
	InitializeSelectItem()
	ShowComponent(stage_info_waist_eff)
	
	if flag_move_stage_title == true then
		--AniMoveY(stage_info_title, -430, 150, 100)
		if flag_vs_mode ==	true then
			AniPlayUnlockScreen(stage_info_title, 150, 'ui_ani_show_default')
		else
			AniPlayUnlockScreen(stage_info_title, 150, 'ui_ani_hide_default')
		end
		flag_move_stage_title = false
	end
	
	_uiComponentDisplay.setDFlag(uiR_ui_select_item, true)
	_uiComponentDisplay.setDFlag(uiC_navi_top_back_btn, true)
	
	if current_driver_id ~= 0 then
		ShowComponent(navi_top_driver_text)
		HideComponent(navi_top_rig_driver_icon_null)
		AM_SetComponentText(navi_top_driver_text, ' ', GetSelectedDriverInfo().mName)
		ReplaceSprByState(navi_top_rig_driver_icon, EnumGUIGraphicState.Normal, StateGarage:GetDriverInfoByID(current_driver_id).mIcon .. '_body')
		AniPlayUnlockScreen(navi_top_rig_driver_icon, 400, 'ui_ani_show_mvx_fd')
		ConfigCarMaxSpeedWithDriverSkill(current_driver_id, GetCurrentCarInfo())
	else
		HideComponent(navi_top_driver_text)
		ShowComponent(navi_top_rig_driver_icon_null)
		AniPlayUnlockScreen(navi_top_rig_driver_icon_null, 400, 'ui_ani_show_mvx_fd')
	end

	ConfigUIRoots()
	ConfigNaviButtons()
	SetCurrentUIData(uiR_ui_select_item)
end
------------------------------------------------------------------------------------------------------G-A-R-A-G-E---
function ClickGarageButton()
	local functionName = 'ClickGarageButton'
	StateGarage:OnGoToGarage()

	InitializeUIRoots()
	InitializeGarage()
	
	_uiComponentDisplay.setDFlag(uiR_ui_garage, true)
	_uiComponentDisplay.setDFlag(uiC_navi_top_back_btn, false)

	StateGarage:SetCSViewIndex(EnumCarSelectionView.Garage)
	StateGarage:SelectCarByShopItemID(StateGarage:GetCurrentPlayerCarShopItemID())
	
	if StateGarage:GetCarArrayNumber() == 1 then
		HideComponent(bg_arrow)
	else
		ShowComponent(bg_arrow)
	end
	
	if ui_main_root:IsShow() == 1 then
		SetCurrentUIData(uiR_ui_main)
	end
	
	if ui_select_item_root:IsShow() == 1 then
		SetCurrentUIData(uiR_ui_select_item)
	end
	
	if ui_stage_root:IsShow() == 1 then
			SetCurrentUIData(uiR_ui_stage)
	end
	
	ConfigUIRoots()
	ConfigNaviButtons()
	
	HideComponent(garage_girl)
	AniPlayUnlockScreen(garage_intro, 500, 'ui_ani_show_default')
end

function ClickGarageExitButton()
	local functionName = 'ClickGarageExitButton'
	
	if flag_challengeMode == true then
		ConfigChallengeGroup(StateGarage:GetCurrentChallengeId())
		AM_PlayBGM('bgm_city2')
	else
		if uiR_current_ui.CName == uiR_ui_main.CName then
			InitializeUIRoots()
			
			_uiComponentDisplay.setDFlag(uiR_ui_main, true)
			
			ConfigUIRoots()
			ConfigNaviButtons()
		
			InitializeMain()
		end
		
		if uiR_current_ui.CName == uiR_ui_select_item.CName then
			ClickStageContinueButton()
			if flag_vs_mode == true then
				ShowComponent(navi_top_stage_sub_rm_energy_bar)
				AniPlayUnlockScreen(navi_top_stage_sub_rm_energy_bar, 500, 'ui_ani_show_default')
				ConfigEnergyBar(true)
			else
			end
		end
		
		if uiR_current_ui.CName == uiR_ui_stage.CName then
			InitializeUIRoots()
			
			_uiComponentDisplay.setDFlag(uiR_ui_stage, true)
			_uiComponentDisplay.setDFlag(uiC_navi_top_back_btn, true)
			
			ConfigUIRoots()
			ConfigNaviButtons()
		end
	end
end

function Click2DealerButton()
	flag_toDealer = true
	ClickDealerButton()
end

function RefreshArrow()
	if StateGarage:GetCarArrayNumber() == 1 then
		HideComponent(bg_arrow)
	else
		ShowComponent(bg_arrow)
	end
end
------------------------------------------------------------------------------------------------------D-R-I-V-E-R---
function ClickDriverButton()
	local functionName = 'ClickDriverButton'
	StateGarage:OnGoToDriver()

	InitializeUIRoots()
	
	_uiComponentDisplay.setDFlag(uiR_ui_driver, true)
	_uiComponentDisplay.setDFlag(uiC_navi_top_back_btn, false)
	
	ConfigUIRoots()
	ConfigNaviButtons()
	
	ConfigDriverInfo(StateGarage:GetSelectedDriverShopItemId())
	
	--ShowComponent(ui_map_root)
end

function ClickDriverExitButton()
	local functionName = 'ClickDriverExitButton'
	if flag_challengeMode == true then
		ConfigChallengeGroup(StateGarage:GetCurrentChallengeId())
		AM_PlayBGM('bgm_city2')
	else
		if uiR_current_ui.CName == uiR_ui_main.CName then
			InitializeUIRoots()
		
			_uiComponentDisplay.setDFlag(uiR_ui_main, true)
		
			ConfigUIRoots()
			ConfigNaviButtons()
	
			InitializeMain()
		end
		if uiR_current_ui.CName == uiR_ui_select_item.CName then
			ClickStageContinueButton()
		end
	end
	ReleaseDriverTexture()
end

------------------------------------------------------------------------------------------------------D-E-A-L-E-R---
function ClickDealerButton()
	local functionName = 'ClickDealerButton'
	StateGarage:OnGoToDealear()

	InitializeUIRoots()
	InitializeDealer()
	
	_uiComponentDisplay.setDFlag(uiR_ui_dealer, true)
	_uiComponentDisplay.setDFlag(uiC_navi_top_back_btn, false)
		
	StateGarage:SetCSViewIndexUnchangeCar(EnumCarSelectionView.Dealer)
	StateGarage:SelectCarByShopItemID(StateGarage:GetCurrentCarShopItemID())
	
	ConfigUIRoots()
	ConfigNaviButtons()
	
	if flag_toDealer == false then
		SetCurrentUIData(uiR_ui_dealer)
	end	
	
	ConfigShowgirl(dealer_girl)
	HideComponent(dealer_girl)
end

function GoToDealerAndLocateCurrentCar()
	local functionName = 'GoToDealerAndLocateCurrentCar'
	StateGarage:OnGoToDealear()

	InitializeUIRoots()
	InitializeDealer()
	
	_uiComponentDisplay.setDFlag(uiR_ui_dealer, true)
	_uiComponentDisplay.setDFlag(uiC_navi_top_back_btn, false)
		
	StateGarage:SetCSViewIndexUnchangeCar(EnumCarSelectionView.Dealer)
	StateGarage:SelectCarByShopItemID(StateGarage:GetCurrentCarShopItemID())
	
	ConfigUIRoots()
	ConfigNaviButtons()
	
	if flag_toDealer == false then
		SetCurrentUIData(uiR_ui_dealer)
	elseif flag_championship_mode == true then
		SetCurrentUIData(uiR_ui_select_item)
	end
	
	ConfigShowgirl(dealer_girl)
	HideComponent(dealer_girl)
end

function GoToDriverAndLocateCurrentDriver()
	local functionName = 'GoToDriverAndLocateCurrentDriver'
	StateGarage:OnGoToDriver()

	InitializeUIRoots()
	
	_uiComponentDisplay.setDFlag(uiR_ui_driver, true)
	_uiComponentDisplay.setDFlag(uiC_navi_top_back_btn, false)
	
	ConfigUIRoots()
	ConfigNaviButtons()
	
	ConfigDriverInfo(StateGarage:GetCurrentDriverShopItemId())
end

function ClickDealerExitButton()
	local functionName = 'ClickDealerExitButton'
	if flag_toDealer == true then
		ClickGarageButton()
		AM_PlayBGM('bgm_garage')
	else
		if flag_challengeMode == true then
			ConfigChallengeGroup(StateGarage:GetCurrentChallengeId())
			AM_PlayBGM('bgm_city2')
		elseif flag_championship_mode == true then
			ClickStageContinueButton()
			AM_PlayBGM('bgm_garage')
		else
			InitializeUIRoots()
			
			_uiComponentDisplay.setDFlag(uiR_ui_main, true)
			
			ConfigUIRoots()
			ConfigNaviButtons()
			
			InitializeMain()
			SetCurrentUIData(uiR_ui_main)
		end
	end
	flag_toDealer = false
end
------------------------------------------------------------------------------------------------------S-O-C-I-A-L---
function ClickPvpButton()
	
end

function ClickSocialExitButton()
	InitializeUIRoots()
	
	_uiComponentDisplay.setDFlag(uiR_ui_main, true)
	
	ConfigUIRoots()
	ConfigNaviButtons()
	
	InitializeMain()
	SetCurrentUIData(uiR_ui_main)
end
--------------------------------------------------------------------------------------------------V-I-P-S-T-O-R-E---
function ClickVIPStoreButton()
	local functionName = 'ClickVIPStoreButton'
	StateGarage:OnEnterVIPStore()
	
	InitializeUIRoots()
	
	_uiComponentDisplay.setDFlag(uiR_ui_vipstore, true)
	_uiComponentDisplay.setDFlag(uiC_navi_top_back_btn, false)
	
	ConfigUIRoots()
	ConfigNaviButtons()
end

function ClickVIPStoreExitButton()
	local functionName = 'ClickVIPStoreExitButton'
	InitializeUIRoots()
	
	_uiComponentDisplay.setDFlag(uiR_ui_main, true)
	
	ConfigUIRoots()
	ConfigNaviButtons()
	
	InitializeMain()
	SetCurrentUIData(uiR_ui_main)
end
------------------------------------------------------------------------------------------------C-H-A-L-L-E-N-G-E---
function ClickChallengeExitButton()
	local functionName = 'ClickChallengeExitButton'
	InitializeUIRoots()
	
	_uiComponentDisplay.setDFlag(uiR_ui_main, true)
	flag_challengeMode = false
	
	ConfigUIRoots()
	ConfigNaviButtons()
	
	InitializeMain()
	SetCurrentUIData(uiR_ui_main)
end

function ClickBuyItemButton()
	local functionName = 'ClickBuyItemButton'
	--buttons
	HideComponent(challenge_buy_item_btn)
	ShowComponent(challenge_back2normal_btn)
	ShowComponent(challenge_back2normal_x_btn)
	AniPlayUnlockScreen(challenge_back2normal_x_btn, 200, 'ui_ani_show_default')
	
	--infotext
	--HideComponent(challenge_infotext_network)
	ShowComponent(challenge_infotext_buyitem)
	
	ConfigChallangeNavi(false)
	--HideComponent(challenge_pre_btn)
	--HideComponent(challenge_next_btn)
	ShowComponent(challenge_buy_item)
	AniPlayUnlockScreen(challenge_buy_item, 200, 'ui_ani_show_default')
end

function ClickBack2NormalButton()
	local functionName = 'ClickBack2NormalButton'
	--buttons
	ShowComponent(challenge_buy_item_btn)
	HideComponent(challenge_back2normal_btn)
	HideComponent(challenge_back2normal_x_btn)
	
	--infotext
	HideComponent(challenge_infotext_buyitem)
	--ShowComponent(challenge_infotext_network)
	
	ConfigChallangeNavi(true)
	--ConfigChallengeNaviArrow()
	HideComponent(challenge_buy_item)
	AniPlayUnlockScreen(challenge_buy_item, 200, 'ui_ani_hide_default')
end

function ConfigChallangeNavi(flag_show)
	local functionName = 'ConfigChallangeNavi'
	--config slider
	if ui_challenge_ak_root:IsShow() == 1 then
		if flag_show == true then
			ShowComponent(challenge_ak_navi_slider)
			AniPlayUnlockScreen(challenge_ak_navi_slider, 200, 'ui_ani_show_default')
		else
			HideComponent(challenge_ak_navi_slider)
			AniPlayUnlockScreen(challenge_ak_navi_slider, 200, 'ui_ani_hide_default')
		end
	elseif ui_challenge_tr_root:IsShow() == 1 then
		if flag_show == true then
			ShowComponent(challenge_tr_navi_slider)
			AniPlayUnlockScreen(challenge_tr_navi_slider, 200, 'ui_ani_show_default')
		else
			HideComponent(challenge_tr_navi_slider)
			AniPlayUnlockScreen(challenge_tr_navi_slider, 200, 'ui_ani_hide_default')
		end
	end
end
--[[
function ConfigChallengeNaviArrow()
	local functionName = 'ConfigChallengeNaviArrow'
	--config arrow
	if ui_challenge_ak_root:IsShow() == 1 then
		ShowComponent(challenge_next_btn)
		AniPlayUnlockScreen(challenge_next_btn, 200, 'ui_ani_show_default')
	elseif ui_challenge_tr_root:IsShow() == 1 then
		ShowComponent(challenge_pre_btn)
		AniPlayUnlockScreen(challenge_pre_btn, 200, 'ui_ani_show_default')
	else
		ShowComponent(challenge_pre_btn)
		AniPlayUnlockScreen(challenge_pre_btn, 200, 'ui_ani_show_default')
		ShowComponent(challenge_next_btn)
		AniPlayUnlockScreen(challenge_next_btn, 200, 'ui_ani_show_default')
	end
end
--]]
function ConfigChallengeGroup(challenge_group_id)
	local functionName = 'ConfigChallengeGroup'
	InitializeUIRoots()
	InitializeChallenge()
	InitializeChallengeAK()
	InitializeChallengeTR()
	
	_uiComponentDisplay.setDFlag(uiR_ui_challenge, true)
	flag_challengeMode = true
	
	--show challenge group
	if challenge_group_id == 1 then
		_uiComponentDisplay.setDFlag(uiR_ui_challenge_ak, true)
	elseif challenge_group_id == 2 then
		_uiComponentDisplay.setDFlag(uiR_ui_challenge_tr, true)
	end
	
	_uiComponentDisplay.setDFlag(uiC_navi_top_back_btn, false)

	ConfigUIRoots()
	ConfigNaviButtons()
	--ConfigChallengeNaviArrow()
	ConfigChallangeNavi(true)
	
	StateGarage:OnGoToChallenge()
end

function OnSwitchChallengeGroup(current_challenge_id, next_challenge_id)	
	local functionName = 'OnSwitchChallengeGroup'
	local current_challenge = GetChallengeUIById(current_challenge_id)
	local next_challenge = GetChallengeUIById(next_challenge_id)
	
	_uiComponentDisplay.setDFlag(current_challenge, false)
	_uiComponentDisplay.setDFlag(next_challenge, true)
	
	AM_ShowComponent(current_challenge)
	AM_ShowComponent(next_challenge)
end

function GetChallengeUIById(challenge_id)
	local functionName = 'GetChallengeUIById'
	local challenge_uiR
	
	if challenge_id == 1 then
		challenge_uiR = uiR_ui_challenge_ak
	elseif challenge_id == 2 then
		challenge_uiR = uiR_ui_challenge_tr
	end
	
	return challenge_uiR
end
---C-H-A-L-L-E-N-G-E------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------C-R-E-D-E-E-M---
function ClickChallengeRedeemButton()
	local functionName = 'ClickChallengeRedeemButton'
	InitializeUIRoots()
	
	_uiComponentDisplay.setDFlag(uiR_ui_challenge_redeem, true)
	_uiComponentDisplay.setDFlag(uiC_navi_top_back_btn, false)
	
	ConfigUIRoots()
	ConfigNaviButtons()
end

function ClickChallengeRedeemExitButton()
	local functionName = 'ClickChallengeRedeemExitButton'
	InitializeUIRoots()
	InitializeChallenge()
	InitializeChallengeAK()
	InitializeChallengeTR()
	
	_uiComponentDisplay.setDFlag(uiR_ui_challenge, true)
	_uiComponentDisplay.setDFlag(uiR_ui_challenge_ak, true)
	
	ConfigUIRoots()
	ConfigNaviButtons()
	
	SetCurrentUIData(uiR_ui_challenge)
	--ConfigChallengeNaviArrow()
	ConfigChallangeNavi(true)
end

function ClickChallengeRedeemButtonTR()
	local functionName = 'ClickChallengeRedeemButtonTR'
	InitializeUIRoots()
	InitializeChallengeRedeemTR()
	
	_uiComponentDisplay.setDFlag(uiR_ui_challenge_redeem_tr, true)
	_uiComponentDisplay.setDFlag(uiC_navi_top_back_btn, false)
	
	ConfigUIRoots()
	ConfigNaviButtons()
end

function ClickChallengeRedeemExitButtonTR()
	local functionName = 'ClickChallengeRedeemExitButtonTR'
	InitializeUIRoots()
	InitializeChallenge()
	InitializeChallengeAK()
	InitializeChallengeTR()
	
	_uiComponentDisplay.setDFlag(uiR_ui_challenge, true)
	_uiComponentDisplay.setDFlag(uiR_ui_challenge_tr, true)
	
	ConfigUIRoots()
	ConfigNaviButtons()
	
	SetCurrentUIData(uiR_ui_challenge)
	--ConfigChallengeNaviArrow()
	ConfigChallangeNavi(true)
end
---C-R-E-D-E-E-M----------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------C-H-A-M-P-I-O-N-S-H-I-P---
function ClickChampionshipButton()
	local functionName = 'ClickChampionshipButton'
	if StateGarage:IsAdaptionPackage() == 1 then
		StateGarage:OnGoToChampionship()
		
		InitializeUIRoots()
		InitializeChampionship()
		
		_uiComponentDisplay.setDFlag(uiR_ui_championship, true)
		_uiComponentDisplay.setDFlag(uiC_navi_top_back_btn, true)
		
		--HideComponent(main_btn_mission_dialog_bubble)
		AniPlayUnlockScreen(main_sidebar_left, 100, 'ui_ani_show_default')
		AniPlayUnlockScreen(main_sidebar_right, 100, 'ui_ani_show_default')
		AniPlayUnlockScreen(main_btn_bg, 100, 'ui_ani_hide_main_dbar')
		
		ConfigUIRoots()
		ConfigNaviButtons()
	else
		if StateGarage:IsTutorialFinished(7) == 0 then
			stringIndex = 113
			SetComponentText(navi_top_popup_msg_text, StateGarage:GetString(stringIndex).mValue)
			ShowComponent(navi_top_popup_msg)
			AniPlayUnlockScreen(navi_top_popup_msg, 0, 'ui_ani_show_popup_nobtn')
		else
			StateGarage:OnGoToChampionship()
			
			InitializeUIRoots()
			InitializeChampionship()
			
			_uiComponentDisplay.setDFlag(uiR_ui_championship, true)
			_uiComponentDisplay.setDFlag(uiC_navi_top_back_btn, true)
			
			--HideComponent(main_btn_mission_dialog_bubble)
			--AniPlayUnlockScreen(main_sidebar_left, 100, 'ui_ani_show_default')
			--AniPlayUnlockScreen(main_sidebar_right, 100, 'ui_ani_show_default')
			AniPlayUnlockScreen(main_btn_bg, 100, 'ui_ani_hide_main_dbar')
			
			ConfigUIRoots()
			ConfigNaviButtons()
		end
	end
end
---C-H-A-M-P-I-O-N-S-H-I-P------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------G-A-C-H-A---
function ClickGachaButton()
	local functionName = 'ClickGachaButton'
	--StateGarage:OnEnterVIPStore()
	
	InitializeUIRoots()
	
	_uiComponentDisplay.setDFlag(uiR_ui_gacha, true)
	_uiComponentDisplay.setDFlag(uiC_navi_top_back_btn, false)
	
	ConfigUIRoots()
	ConfigNaviButtons()
end

function ClickGachaExitButton()
	local functionName = 'ClickGachaExitButton'
	InitializeUIRoots()
	
	_uiComponentDisplay.setDFlag(uiR_ui_main, true)
	
	ConfigUIRoots()
	ConfigNaviButtons()
	
	InitializeMain()
	SetCurrentUIData(uiR_ui_main)
end
---G-A-C-H-A--------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------R-M---
function ClickVSRedeemButton()
	local functionName = 'ClickRmRedeemButton'
	InitializeRmRedeem('vs')
	--StateGarage:OnEnterVIPStore()
	
	InitializeUIRoots()
	
	_uiComponentDisplay.setDFlag(uiR_ui_rm_redeem, true)
	_uiComponentDisplay.setDFlag(uiC_navi_top_back_btn, false)
	
	ConfigUIRoots()
	ConfigNaviButtons()
end
---R-M-R-E-D-E-E-M--------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------V-S-M-O-D-E---
function ClickVSModeButton()
	local functionName = 'ClickVSModeButton'
	--StateGarage:OnEnterVIPStore()
	
	InitializeUIRoots()
	InitializeVSMode()
	
	_uiComponentDisplay.setDFlag(uiR_ui_vsmode, true)
	_uiComponentDisplay.setDFlag(uiC_navi_top_back_btn, true)
	
	ConfigEnergyBar(true)
	ConfigUIRoots()
	ConfigNaviButtons()
	HideComponent(stage_sub)
end

function ClickVSModeExitButton()
	local functionName = 'ClickVSModeExitButton'
	InitializeUIRoots()
	
	_uiComponentDisplay.setDFlag(uiR_ui_main, true)
	
	ConfigUIRoots()
	ConfigNaviButtons()
	
	InitializeMain()
	SetCurrentUIData(uiR_ui_main)
end
--V-S-M-O-D-E-------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------P-V-P-R-E-D-E-E-M---
function ClickPVPRedeemButton()
	local functionName = 'ClickPVPRedeemButton'
	
	InitializeUIRoots()
	InitializePVPRedeem()
	
	_uiComponentDisplay.setDFlag(uiR_ui_pvp_redeem, true)
	_uiComponentDisplay.setDFlag(uiC_navi_top_back_btn, false)
	
	ConfigUIRoots()
	ConfigNaviButtons()
end

function ClickPVPRedeemButtonPop()
	local functionName = 'ClickPVPRedeemButtonPop'
	flag_vs_redeem_from_pop = true

	InitializeUIRoots()
	InitializePVPRedeem()
	
	_uiComponentDisplay.setDFlag(uiR_ui_pvp_redeem, true)
	_uiComponentDisplay.setDFlag(uiC_navi_top_back_btn, false)
	
	ConfigUIRoots()
	ConfigNaviButtons()
	ConfigEnergyBar(true)
end

function ClickPVPRedeemExitButton()
	local functionName = 'ClickPVPRedeemExitButton'
	InitializeUIRoots()
	
	if flag_vs_redeem_from_pop == true then
		_uiComponentDisplay.setDFlag(uiR_ui_main, true)
	
		ConfigUIRoots()
		ConfigNaviButtons()
		
		InitializeMain()
		SetCurrentUIData(uiR_ui_main)
		
		flag_vs_redeem_from_pop = false
		flag_vs_mode = false
	else
		_uiComponentDisplay.setDFlag(uiR_ui_vsmode, true)
		_uiComponentDisplay.setDFlag(uiC_navi_top_back_btn, true)
		
		ConfigUIRoots()
		ConfigNaviButtons()
		
		InitializeVSMode()
		SetCurrentUIData(uiR_ui_vsmode)
	end
end
---P-V-P-R-E-D-E-E-M------------------------------------------------------------------------------------------------
---B-U-N-T-T-O-N----------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------D-A-T-A---
function SetSubstageData(chapter_id, stage_id)
	local functionName = 'SetSubstageData'
	local substage = StateGarage:GetStageInfoByID(chapter_id, stage_id)
	local current_chpinfo
	local chp_best_score
	local chp_rank
	local car_info = GetCurrentCarInfo()
	local currentCarSpeedTotal = 0
	local array_trophy_icon = {
		'ui_stage_info_tro_g',
		'ui_stage_info_tro_s',
		'ui_stage_info_tro_c',
		'',
	}
	
	--speed limit
	ConfigCarMaxSpeedWithDriverSkill(StateGarage:GetCurrentDriverShopItemId(), car_info)
	--car name
	SetComponentText(item_car_info_name, car_info.mName)
	AM_SetComponentText(item_stage_speed, '0', substage.mRecommendedSpeed, '0')
	AM_SetComponentText(item_stage_goal, substage.mClearDesc)
	
	if flag_championship_mode == true then
		current_chpinfo = StateGarage:GetChampionshipInfo(StateGarage:GetCurrentChampionship())
		chp_best_score = current_chpinfo.mBestScore
		chp_rank = current_chpinfo.mRank
		
		--title
		AM_SetComponentText(stage_info_stage_num, '', ' ', substage.mType)
		if chp_best_score ~= 0 then
			AM_SetComponentText(championship_record_time, GetTime(chp_best_score))
		else
			AM_SetComponentText(championship_record_time, '----')
		end
		if chp_rank ~= 0 then
			AM_SetComponentText(championship_record_pos, '0', '  ', chp_rank, '  ', '0')
		else
			AM_SetComponentText(championship_record_pos, '', '', '----', '', '')
		end
		--championship_obj
		AM_SetComponentText(stage_info_main_bottom, '', '', '', current_chpinfo.mRaceDesc)
	elseif flag_vs_mode == true then
		--title
		AM_SetComponentText(stage_info_stage_num, '', ' ', substage.mType)
	elseif stage_id == 0 then
		--title
		AM_SetComponentText(stage_info_stage_num, '', ' ', 'p')
		--championship_obj
		AM_SetComponentText(stage_info_main_bottom, '0', '----', '', '')
	else
		--title
		AM_SetComponentText(stage_info_stage_num, chapter_id .. '-' .. stage_id, ' ', substage.mType)
		--best score
		if substage.mBestScore ~= 0 then
			if Logic_or(substage.mType == 1, substage.mType == 2, substage.mType == 7) then
				AM_SetComponentText(stage_info_main_bottom, '0', GetTime(substage.mBestScore), '', '')
			elseif substage.mType == 3 then
				AM_SetComponentText(stage_info_main_bottom, '0', '----', '', '')
			else
				AM_SetComponentText(stage_info_main_bottom, '0', substage.mBestScore, substage.mName, '')
			end
		else
			AM_SetComponentText(stage_info_main_bottom, '0', '----', '', '')
		end
	end
	--recommended speed
	if substage.mType == 3 then
		AM_SetComponentText(item_next_stage_info_speed, ' ', '----', '')
	else
		AM_SetComponentText(item_next_stage_info_speed, ' ', substage.mRecommendedSpeed, '0')
	end
	--clear condition
	--normal clear
	if flag_championship_mode == true then
		SetComponentText(stage_info_main_waist, StateGarage:GetChampionshipInfo(StateGarage:GetCurrentChampionship()).mRaceDesc)
--[[		
	elseif flag_rm_mode == true then
		SetComponentText(stage_info_main_waist, '')
--]]	
	else
		SetComponentText(stage_info_main_waist, substage.mClearDesc)
	end

	if Logic_or(substage.mType == 1, substage.mType == 2, substage.mType == 7) then
		if flag_championship_mode == true then
			--gold clear
			AM_SetComponentText(stage_info_gold_detail, 'g', ' ', 'A', ' ', '')
			--silver clear
			AM_SetComponentText(stage_info_silver_detail, 's', ' ', 'B', ' ', '')
			--bronze clear
			AM_SetComponentText(stage_info_copper_detail, 'b', ' ', 'C', ' ', '')
		elseif chapter_id == 0 then
			--gold clear
			AM_SetComponentText(stage_info_gold_detail, 'g', ' ', '----', ' ', '')
			--silver clear
			AM_SetComponentText(stage_info_silver_detail, 's', ' ', '----', ' ', '')
			--bronze clear
			AM_SetComponentText(stage_info_copper_detail, 'b', ' ', '----', ' ', '')
		else
			--gold clear
			AM_SetComponentText(stage_info_gold_detail, 'g', ' ', GetTime(substage.mClearGold), ' ', '')
			--silver clear
			AM_SetComponentText(stage_info_silver_detail, 's', ' ', GetTime(substage.mClearSilver), ' ', '')
			--bronze clear
			AM_SetComponentText(stage_info_copper_detail, 'b', ' ', GetTime(substage.mClearBronze), ' ', '')
		end
	elseif substage.mType == 3 then
		--gold clear
		AM_SetComponentText(stage_info_gold_detail, 'g', ' ', '----', ' ', '')
		--silver clear
		AM_SetComponentText(stage_info_silver_detail, 's', ' ', '----', ' ', '')
		--bronze clear
		AM_SetComponentText(stage_info_copper_detail, 'b', ' ', '----', ' ', '')
	else
		--gold clear
		AM_SetComponentText(stage_info_gold_detail, 'g', ' ', substage.mClearGold, ' ', substage.mName)
		--silver clear
		AM_SetComponentText(stage_info_silver_detail, 's', ' ', substage.mClearSilver, ' ', substage.mName)
		--bronze clear
		AM_SetComponentText(stage_info_copper_detail, 'b', ' ', substage.mClearBronze, ' ', substage.mName)
	end
--[[
	if flag_championship_mode == true then
		AM_SetComponentText(stage_info_main_bottom, '', '', '', StateGarage:GetChampionshipInfo(StateGarage:GetCurrentChampionship()).mRaceDesc)
	else
		--best score
		if substage.mBestScore ~= 0 then
			if Logic_or(substage.mType == 1, substage.mType == 2, substage.mType == 7) then
				AM_SetComponentText(stage_info_main_bottom, '0', GetTime(substage.mBestScore), '', '')
			elseif substage.mType == 3 then
				AM_SetComponentText(stage_info_main_bottom, '0', '----', '', '')
			else
				AM_SetComponentText(stage_info_main_bottom, '0', substage.mBestScore, substage.mName, '')
			end
		else
			AM_SetComponentText(stage_info_main_bottom, '0', '----', '', '')
		end
	end
--]]
end

function RefreshChampionshipRank()
	local functionName = 'RefreshChampionshipRank'
	local current_chpinfo = StateGarage:GetChampionshipInfo(StateGarage:GetCurrentChampionship())
	local chp_best_score = current_chpinfo.mBestScore
	local chp_rank = current_chpinfo.mRank
	
	if chp_best_score ~= 0 then
		AM_SetComponentText(championship_record_time, GetTime(chp_best_score))
	else
		AM_SetComponentText(championship_record_time, '----')
	end
	if chp_rank ~= 0 then
		AM_SetComponentText(championship_record_pos, '0', '  ', chp_rank, '  ', '0')
	else
		AM_SetComponentText(championship_record_pos, '', '', '----', '', '')
	end
end

function GetClassName(class_name)
	local functionName = 'GetClassName'
	local recommended_class = ''
	local array_class_name = {
		'C',
		'B',
		'A',
		'S',
	}

	for v in ipairs(array_class_name) do
		if class_name == v then
			recommended_class = array_class_name[v]
			break
		end
	end

	return recommended_class
end
---D-A-T-A----------------------------------------------------------------------------------------------------------