LuaCore.Require("functions.lua")
LuaCore.Require("initialize.lua")
LuaCore.Require("display.lua")

------------------------------------------------------------------------------------------------G-A-M-E-S-T-A-R-T---
function OnStartGame()
end
---G-A-M-E-S-T-A-R-T------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------S-T-A-R-T---
function OnStartState()
	local functionName = 'OnStartState'
	HideComponent(driver_card_ability_1_tn)
	HideComponent(driver_card_ability_2_tn)
	HideComponent(driver_card_ability_3_tn)
	HideComponent(dealer_sale_time)
	HideComponent(dealer_data_price)
	HideComponent(dealer_data_payback)
	HideComponent(championship_locked)
	HideComponent(navi_top_stage_sub_chp_btn_start)
	HideComponent(navi_top_stage_sub_rm_btn_start)
	HideComponent(navi_top_stage_sub_rm_energy_bar)
		
	if channel_id == 'cmgVIP' then
		ShowComponent(main_btn_cmpack)
	else
		HideComponent(main_btn_cmpack)
	end
	if channel_id == 'dongyou' then
		HideComponent(main_service_btn)
	else
		ShowComponent(main_service_btn)
	end
	--AniPlayUnlockScreen(main_btn_mission_dialog_bubble, 1000, 'ui_ani_show_default')
	--DefaultPosition
--[[	
	if flag_sidebar_position == false then
		if flag_rmpack == true then
			SetComponentOffset(main_sidebar_right, 0, 0)
		else
			SetComponentOffset(main_sidebar_right, -350, 0)
		end
		flag_sidebar_position = true
	end
--]]	
	if flag_rmpack == true then
		--ShowComponent(main_rmpack)
		--ShowComponent(main_banner_move_btn)
	else
		HideComponent(main_rmpack)
		--HideComponent(main_banner_move_btn)
	end
	HideComponent(stage_sub)
	HideComponent(navi_top_close_vm_btn)
	AniPlayUnlockScreen(navi_top_vm_btn, 600, 'ui_ani_show_default')
	
	HideComponent(navi_top_popup_msg)
	ShowComponent(ui_map_root)
	_uiComponentDisplay.setDFlag(uiR_ui_map, true)
	ShowComponent(ui_navi_top_root)
	_uiComponentDisplay.setDFlag(uiC_navi_top_back_btn, false)
	ConfigNaviButtons(functionName)
	SetCurrentUIData(uiR_ui_main)
	StateGarage:SelectCarByShopItemID(StateGarage:GetCurrentPlayerCarShopItemID())
	InitializeMain()
	ClearScreen(false)
	
	AM_PringLog('CALL: ' .. functionName)
end
---S-T-A-R-T--------------------------------------------------------------------------------------------------------
function OnTutorialFinish(id)
	if id == 4 then
		stringIndex = 121
	elseif id == 6 then
		stringIndex = 122
	elseif id == 10 then
		stringIndex = 121
	elseif id == 11 then
		stringIndex = 122
	elseif id == 12 then
		stringIndex = 122
	else
		stringIndex = 113	
	end
end
------------------------------------------------------------------------------------------------------F-I-N-I-S-H---
function OnBackToGarage( autoExecStage )
	local functionName = 'OnBackToGarage'
	local current_chapterid = StateGarage:GetSelectedChapter()
	local current_stageid = StateGarage:GetSelectedStage()
	local current_stage = StateGarage:GetStageInfoByID(current_chapterid, current_stageid)
	
	SetSubstageData(current_chapterid, current_stageid)
	--AM_SetComponentText(item_next_stage_info_text, current_chapterid .. '-' .. current_stageid)
	--AM_SetComponentText(item_next_stage_info_type, current_stage.mType)
	--AM_SetComponentText(item_next_stage_info_obj, ' ', current_stage.mClearDesc, ' ')
	
	if current_stage.mType == 3 then
		--dialog stage
		if autoExecStage ~= 0 then
			if  not(Logic_and(current_chapterid == 1, current_stageid == 1)) then
				if Logic_and(current_chapterid == 1, current_stageid == 5) then
					-- 好友功能解锁后
					if StateGarage:IsTutorialFinished( 14 ) ~= 0 then
						StateGarage:LaunchStage(current_chapterid, current_stageid)
					end
				else
					StateGarage:LaunchStage(current_chapterid, current_stageid)
				end
			end
		end
		SetStageInfo()
		--AniMoveY(stage_info_title, 430, 200, 100)
		AniPlayUnlockScreen(stage_info_title, 300, 'ui_ani_show_default')
		flag_move_stage_title = true
	else
		--normal stage
		flag_move_stage_title = false
		ClickStageContinueButton()
	end	
	
	--ShowComponent(ui_map_root)
	ShowComponent(ui_navi_top_root)
	AM_PringLog('CALL: ' .. functionName)
end

function OnFinishChallenge(challenge_group_id)
	local functionName = 'OnFinishChallenge'
	--ClickChallengeButton()
	ConfigChallengeGroup(challenge_group_id)
	
	ShowComponent(ui_map_root)
	ShowComponent(ui_navi_top_root)
	AM_PringLog('CALL: ' .. functionName)
end

function OnFinishChampionship(championship_id)
	local functionName = 'OnFinishChampionship'
	SetSubstageData(901, championship_id)
	flag_move_stage_title = false
	ClickStageContinueButton()
	ShowComponent(ui_navi_top_root)
	AM_PringLog('CALL: ' .. functionName)
end

function OnFinishRm()
	local functionName = 'OnFinishRm'
	SetSubstageData(950, 1)
	flag_move_stage_title = false
	ClickRmButton()
	ShowComponent(ui_navi_top_root)
	AM_PringLog('CALL: ' .. functionName)
end

function BackToStage()
	local functionName = 'BackToStage'
	SetStageInfo()
	--AniMoveY(stage_info_title, 430, 200, 100)
	AniPlayUnlockScreen(stage_info_title, 200, 'ui_ani_show_stage_title_md')
	flag_move_stage_title = true
	--ShowComponent(ui_map_root)
	ShowComponent(ui_navi_top_root)
	AM_PringLog('CALL: ' .. functionName)
end

function ShowNaviTopAndMap()
	local functionName = 'ShowNaviTopAndMap'
	ShowComponent(ui_map_root)
	ShowComponent(ui_navi_top_root)
	SetCurrentUIData(uiR_ui_main)
	AM_PringLog('CALL: ' .. functionName)
end
---F-I-N-I-S-H------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------C-A-R-D-A-T-A---
function RefreshCurrentCarData(currentcarinfor)
	local acc_plus = ''
	local spmax_plus = ''
	local turning_plus = ''
	local maxData = StateGarage:GetMaxLevelCarInfo(StateGarage:GetCurrentCarShopItemID())
	local currentCarSpeedTotal = 0
	local currnet_car_currency = ''
	local current_car_price = ''
	local current_car_leveldot = ''
	local flag_car_sale = true
	
	local set_weitht = function(component_name, weight)
		SetComponentValue(component_name, weight-1)
	end

	local set_normal_price = function(str_price)
		local price_slash = '--'
		
		for i = 1, string.len(str_price) do
			price_slash = price_slash .. '-'
		end
		
		AM_SetComponentText(dealer_data_price_ml, ' ', price_slash)
		if flag_car_sale == true then
			ShowComponent(dealer_data_price)
		else
			HideComponent(dealer_data_price)
		end
	end
	
	
	currentCar = currentcarinfor
	if uiR_ui_garage.DFlag == true then
		--car class
		SetComponentValue(garage_class, currentcarinfor.mClass)
		if currentcarinfor.mClass == 0 then
			ReplaceSprByState(garage_namebar, EnumGUIGraphicState.Normal, 'ui_garage_name_vip_bg')
			ReplaceSprByState(garage_class, EnumGUIGraphicState.Normal, 'ui_car_class_vip_bg')
			ShowComponent(garage_class_vip)
		else
			ReplaceSprByState(garage_namebar, EnumGUIGraphicState.Normal, 'ui_garage_name_bg')
			ReplaceSprByState(garage_class, EnumGUIGraphicState.Normal, 'ui_car_class_bg')
			HideComponent(garage_class_vip)
		end
		--speed limit
		ConfigCarMaxSpeedWithDriverSkill(StateGarage:GetCurrentDriverShopItemId(), currentcarinfor)
		--car name
		SetComponentText(item_car_info_name, currentcarinfor.mName)
		--car weight
		--[[
		if weight == 1 then
			SetComponentValue(garage_weight, 0)
		elseif weight == 2 then
			SetComponentValue(garage_weight, 1)
		elseif weight == 3 then
			SetComponentValue(garage_weight, 2)
		end
		--]]
		set_weitht(garage_weight, currentcarinfor.mWeight)
		--car type
		SetComponentValue(garage_cartype, currentcarinfor.mCarType)
		--car name
		SetComponentText(garage_namebar, currentcarinfor.mName)
		SetComponentText(garage_namebar_shadow, currentcarinfor.mName)
		SetComponentText(garage_namebar_eff, currentcarinfor.mName)
		--pgbar
		AM_SetPGbarValue(garage_status_pgbar_acc, 999, currentcarinfor.mAccelCurrLevelDisplayValue, currentcarinfor.mAccelNextLevelDisplayValue)
		AM_SetPGbarValue(garage_status_pgbar_spmax, 999, currentcarinfor.mMaxSpeedCurrLevelDisplayValue, currentcarinfor.mMaxSpeedNextLevelDisplayValue)
		AM_SetPGbarValue(garage_status_pgbar_turning, 999, currentcarinfor.mTurningCurrLevelDisplayValue, currentcarinfor.mTurningNextLevelDisplayValue)	
		--car lv
		for i=1,5 do
			if i < currentcarinfor.mLevel then
			current_car_leveldot = current_car_leveldot .. '1'
			elseif i == currentcarinfor.mLevel then
			current_car_leveldot = current_car_leveldot .. '2'
			elseif i > currentcarinfor.mLevel then
			current_car_leveldot = current_car_leveldot .. '0'	
			end
		end
		SetComponentText(garage_lv, current_car_leveldot)
		--full lv
		if currentCar.mCarLevelIsFull ~= 0 then
			ShowComponent(garage_lvmax)
			HideComponent(garage_lvmax_not)
			HideComponent(garage_data_price)
			_uiComponentDisplay.setDFlag(uiC_garage_fuction_btn_upgd, false)
			_uiComponentDisplay.setDFlag(uiC_garage_btn_upgd2max, false)
			SetComponentText(garage_intro_text, StateGarage:GetString(109).mValue)
		else
			HideComponent(garage_lvmax)
			ShowComponent(garage_lvmax_not)
			ShowComponent(garage_data_price)
			acc_plus = 'A' .. currentcarinfor.mAccelNextLevelDisplayValue
			spmax_plus = 'A' .. currentcarinfor.mMaxSpeedNextLevelDisplayValue
			turning_plus = 'A' .. currentcarinfor.mTurningNextLevelDisplayValue
			_uiComponentDisplay.setDFlag(uiC_garage_fuction_btn_upgd, true)
			_uiComponentDisplay.setDFlag(uiC_garage_btn_upgd2max, true)
			SetComponentText(garage_intro_text, StateGarage:GetString(108).mValue)
		end
		--current data
		AM_SetComponentText(garage_status_acc_data_cur, currentcarinfor.mAccelCurrLevelDisplayValue, acc_plus)
		AM_SetComponentText(garage_status_spmax_data_cur, currentcarinfor.mMaxSpeedCurrLevelDisplayValue, spmax_plus)
		AM_SetComponentText(garage_status_turning_data_cur, currentcarinfor.mTurningCurrLevelDisplayValue, turning_plus)
		--set price
		if Logic_and(currentcarinfor.mUpgradeCoin == 0, currentcarinfor.mUpgradeMoney == 0) then
			SetComponentText(garage_data_price, 'P----')
		else
			SetPrice(garage_data_price, 'P', currentcarinfor.mUpgradeCoin, currentcarinfor.mUpgradeMoney)
		end
	end
	if uiR_ui_dealer.DFlag == true then
		HideComponent(dealer_sale_time)
		HideComponent(dealer_data_price)
		current_car_price = GetPrice(currentcarinfor.mCostCoin, currentcarinfor.mCostMoney, currentcarinfor.mCostRMB)
		currnet_car_currency = GetChurrency(currentcarinfor.mCostCoin, currentcarinfor.mCostMoney, currentcarinfor.mCostRMB)
		--car class
		SetComponentValue(dealer_class, currentcarinfor.mClass)
		if currentcarinfor.mClass == 0 then
			ReplaceSprByState(dealer_namebar, EnumGUIGraphicState.Normal, 'ui_garage_name_vip_bg')
			ReplaceSprByState(dealer_class, EnumGUIGraphicState.Normal, 'ui_car_class_vip_bg')
			ShowComponent(dealer_class_vip)
		else
			ReplaceSprByState(dealer_namebar, EnumGUIGraphicState.Normal, 'ui_garage_name_bg')
			ReplaceSprByState(dealer_class, EnumGUIGraphicState.Normal, 'ui_car_class_bg')
			HideComponent(dealer_class_vip)
		end
		--car weight
		--[[
		if weight == 1 then
			SetComponentValue(dealer_weight, 0)
		elseif weight == 2 then
			SetComponentValue(dealer_weight, 1)
		elseif weight == 3 then
			SetComponentValue(dealer_weight, 2)
		end
		--]]
		set_weitht(dealer_weight, currentcarinfor.mWeight)
		--car type
		SetComponentValue(dealer_cartype, currentcarinfor.mCarType)
		--car name
		SetComponentText(dealer_namebar, currentcarinfor.mName)
		SetComponentText(dealer_namebar_shadow, currentcarinfor.mName)
		SetComponentText(dealer_namebar_eff, currentcarinfor.mName)
		--pgbar front
		AM_SetPGbarValue(dealer_status_pgbar_acc, 999, currentCar.mAccelCurrLevelDisplayValue, maxData.mAccelValue)
		AM_SetPGbarValue(dealer_status_pgbar_spmax, 999, currentCar.mMaxSpeedCurrLevelDisplayValue, maxData.mMaxSpeedValue)
		AM_SetPGbarValue(dealer_status_pgbar_turning, 999, currentCar.mTurningCurrLevelDisplayValue, maxData.mTurningValue)
		--current
		AM_SetComponentText(dealer_status_acc_data_cur, currentcarinfor.mAccelCurrLevelDisplayValue, '/' .. maxData.mAccelValue)
		AM_SetComponentText(dealer_status_spmax_data_cur, currentcarinfor.mMaxSpeedCurrLevelDisplayValue, '/' .. maxData.mMaxSpeedValue)
		AM_SetComponentText(dealer_status_turning_data_cur, currentcarinfor.mTurningCurrLevelDisplayValue, '/' .. maxData.mTurningValue)
		--lock
		SetComponentText(dealer_lock, currentcarinfor.mLockDescription)
		--set price_payback
		SetComponentText(dealer_data_payback, currnet_car_currency .. currentcarinfor.mGetMoney)
		--set price_coin
		ShowComponent(dealer_btn_coinpurchase)
		if currentcarinfor.mCostCoin ~= 0 then
			AM_SetComponentText(dealer_btn_coinpurchase, 'C' .. currentcarinfor.mCostCoin)
			EnableComponent(dealer_btn_coinpurchase)
			ReplaceButtonRes(dealer_btn_coinpurchase, 'ui_ingame_gmovr_btn_b_l')
			ChangeComponent2Color(dealer_btn_coinpurchase)
		elseif currentcarinfor.mCarId == 24 then
				AM_SetComponentText(dealer_btn_coinpurchase, 'G' .. currentcarinfor.mCostMoney)
				EnableComponent(dealer_btn_coinpurchase)
				ReplaceButtonRes(dealer_btn_coinpurchase, 'ui_ingame_gmovr_btn_y_l')
				ChangeComponent2Color(dealer_btn_coinpurchase)
		else
			AM_SetComponentText(dealer_btn_coinpurchase, '------')
			DisableComponent(dealer_btn_coinpurchase)
			ReplaceButtonRes(dealer_btn_coinpurchase, 'ui_ingame_gmovr_btn_y_l')
			ChangeComponent2Grey(dealer_btn_coinpurchase)
		end
		--set price_realmoney
			
		if currnet_car_currency == 'Y' then
			AM_SetComponentText(dealer_btn_purchase, current_car_price .. currnet_car_currency)
			ReplaceButtonRes(dealer_btn_purchase, 'ui_ingame_gmovr_btn_r_l')
		elseif currnet_car_currency == 'B' then
			AM_SetComponentText(dealer_btn_purchase, currnet_car_currency)
			ReplaceButtonRes(dealer_btn_purchase, 'ui_ingame_gmovr_btn_b_l')
		else
			AM_SetComponentText(dealer_btn_purchase, currnet_car_currency .. current_car_price)
			ReplaceButtonRes(dealer_btn_purchase, 'ui_ingame_gmovr_btn_y_l')
		end
		
		if Logic_and(flag_smallpack == false, currentcarinfor.mCarId == 13) then
			if StateGarage:IsGiftPackBought(1) ~= 0 then
				ConfigSaleInfo(dealer_sale_banner, 'ui_welcomeplus_banner')
				AM_SetComponentText(dealer_data_price, 'P' .. currnet_car_currency .. current_car_price, ' ', 'sG85')
			else
				flag_car_sale = false
				AM_SetComponentText(dealer_data_price, 'P' .. currnet_car_currency .. current_car_price, ' ', '')
			end
		elseif Logic_and(flag_smallpack == false, currentcarinfor.mCarId == 37) then
			ConfigSaleInfo(dealer_sale_banner, 'ui_challenge_ad_ae86')
			flag_car_sale = false
			AM_SetComponentText(dealer_data_price, 'P' .. currnet_car_currency .. current_car_price, ' ', '')
		--[[
			elseif currentcarinfor.mCarId == 18 then
			ConfigSaleInfo(dealer_sale_mark)
			AM_SetComponentText(dealer_data_price, 'PY50', ' ', 'B' .. currnet_car_currency .. current_car_price)
		]]
		-- elseif currentcarinfor.mCarId == 39 then
			-- ConfigSaleInfo(dealer_sale_mark, dealer_sale_banner, 'ui_sale_info_bumble_t')
			-- AM_SetComponentText(dealer_data_price, 'PG998')
		elseif currentcarinfor.mCarId == 24 then
			if currentcarinfor.mPrimeIAP == 0 then 
				AM_SetComponentText(dealer_btn_purchase, '------')
				DisableComponent(dealer_btn_purchase)
				ReplaceButtonRes(dealer_btn_purchase, 'ui_ingame_gmovr_btn_y_l')
				ChangeComponent2Grey(dealer_btn_purchase)
				flag_car_sale = false
			else
				AM_SetComponentText(dealer_data_price, 'PG998')
				AM_SetComponentText(dealer_btn_purchase, 'P' .. current_car_price .. currnet_car_currency)
				EnableComponent(dealer_btn_purchase)
				ReplaceButtonRes(dealer_btn_purchase, 'ui_ingame_gmovr_btn_r_l')
				ChangeComponent2Color(dealer_btn_purchase)
				flag_car_sale = true
			end
		else
			if currentcarinfor.mDiscountPrice == current_car_price then
				flag_car_sale = false
			else
				ShowComponent(dealer_sale_time)
				ShowComponent(dealer_sale_mark_80)
				AniPlayUnlockScreen(dealer_sale_time, 200, 'ui_ani_show_default')
				AniPlayUnlockScreen(dealer_sale_mark_80, 500, 'ui_ani_show_default')
				AM_SetComponentText(dealer_data_price, 'P' .. currnet_car_currency .. current_car_price)
				AM_SetComponentText(dealer_btn_purchase, 'P' .. currnet_car_currency .. currentcarinfor.mDiscountPrice)
			end
		end
		set_normal_price(current_car_price)
		--set car desc
		SetComponentText(dealer_intro_text, currentcarinfor.mCarDescription)
	end
end

function ConfigSaleInfo(...)--(sale_mark_component, banner_component, banner_res, )
	local arguments = {...}

	if #arguments == 1 then
		ShowComponent(arguments[1])
		AniPlayUnlockScreen(arguments[1], 500, 'ui_ani_show_default')
	elseif 	#arguments == 2 then
		ReplaceSprByState(arguments[#arguments - 1], EnumGUIGraphicState.Normal, arguments[#arguments])
		ShowComponent(arguments[1])
		AniPlayUnlockScreen(arguments[1], 200, 'ui_ani_show_default')
	elseif #arguments == 3 then
		ReplaceSprByState(arguments[#arguments - 1], EnumGUIGraphicState.Normal, arguments[#arguments])
		ShowComponent(arguments[2])
		AniPlayUnlockScreen(arguments[2], 200, 'ui_ani_show_default')
		ShowComponent(arguments[1])
		AniPlayUnlockScreen(arguments[1], 500, 'ui_ani_show_default')
	end
end
---C-A-R-D-A-T-A----------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------U-P-G-R-A-D-E-C-A-R---
function OnUpgradeCar()
	----<CONFIG>----hide car data plus
	RefreshCurrentCarData(GetCurrentCarInfo())
	
	if currentCar.mCarLevelIsFull ~= 0 then
		ShowComponent(garage_lvmax)
		HideComponent(garage_data_price)
		_uiComponentDisplay.setDFlag(uiC_garage_fuction_btn_upgd, false)
		_uiComponentDisplay.setDFlag(uiC_garage_btn_upgd2max, false)
		ConfigShowgirl(garage_girl, '', AM_GetSTR(103))
	end
	
	ConfigCarFunctionButtons()
	
	ShowComponent(garage_data_bg_head_eff)
	AniPlayUnlockScreen(garage_data, 0, 'ui_ani_show_mvrl')	
end

function ClickUpgradeCar2MaxLvButton()
	local maxData = StateGarage:GetMaxLevelCarInfo(StateGarage:GetCurrentCarShopItemID())
	
	InitializeUIPopup()
	--current data
	AM_SetComponentText(popup_upg2max_status_acc_data_cur, currentCar.mAccelCurrLevelDisplayValue, 'A' .. maxData.mAccelValue)
	AM_SetComponentText(popup_upg2max_status_spmax_data_cur, currentCar.mMaxSpeedCurrLevelDisplayValue, 'A' .. maxData.mMaxSpeedValue)
	AM_SetComponentText(popup_upg2max_status_turning_data_cur, currentCar.mTurningCurrLevelDisplayValue, 'A' .. maxData.mTurningValue)
	--pgbar
	AM_SetPGbarValue(popup_upg2max_status_pgbar_acc, 999, currentCar.mAccelCurrLevelDisplayValue, maxData.mAccelValue)
	AM_SetPGbarValue(popup_upg2max_status_pgbar_spmax, 999, currentCar.mMaxSpeedCurrLevelDisplayValue, maxData.mMaxSpeedValue)
	AM_SetPGbarValue(popup_upg2max_status_pgbar_turning, 999, currentCar.mTurningCurrLevelDisplayValue, maxData.mTurningValue)
	--set price
	SetPrice(popup_upg2max_confirm_price, 'P', currentCar.mUpgradeCoin, currentCar.mUpgrade2MaxCost)

	_uiComponentDisplay.setDFlag(uiR_ui_popup_upg2max, true)
	
	ConfigUIPopup()
end

function ClickUpgradeCar2MaxLvCancelButton()
	InitializeUIPopup()
	ConfigUIPopup()
end
---U-P-G-R-A-D-E-C-A-R----------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------C-H-A-N-G-E-C-A-R---
function OnChangeCar()
	ShowComponent(garage_data_bg_head_eff)
	if uiR_ui_garage.DFlag == true then
		RefreshCurrentCarData(GetCurrentCarInfo())
		AniPlayUnlockScreen(garage_data, 0, 'ui_ani_show_mvrl')
		AniPlayUnlockScreen(garage_namebar, 200, 'ui_ani_show_mvx_fd')
		ShowComponent(garage_class)
		AniPlayUnlockScreen(garage_class, 400, 'ui_ani_show_default')
		AniPlayUnlockScreen(garage_weight, 350, 'ui_ani_show_mvx_fd')
		AniPlayUnlockScreen(garage_cartype, 400, 'ui_ani_show_mvx_fd')
	elseif uiR_ui_dealer.DFlag == true then
		HideComponent(dealer_sale_mark)
		HideComponent(dealer_sale_banner)
		RefreshCurrentCarData(GetCurrentCarInfoLevelOne())
		AniPlayUnlockScreen(dealer_data, 0, 'ui_ani_show_mvrl')
		if currentCar.mIsPurchased ~= 0 then
			HideComponent(dealer_lockedcar)
			HideComponent(dealer_lock)
			HideComponent(dealer_data_price)
			DisableComponent(dealer_btn_purchase)
			ReplaceButtonRes(dealer_btn_purchase, 'ui_ingame_gmovr_btn_y_l')
			ChangeComponent2Grey(dealer_btn_purchase)
			ShowComponent(dealer_purchased)
			ShowComponent(dealer_soldout)
			HideComponent(dealer_btn_coinpurchase)
			HideComponent(dealer_img_diamondbuy)
			AM_SetComponentText(dealer_btn_purchase, '------')
			HideComponent(dealer_data_payback)
		else
			HideComponent(dealer_purchased)
			HideComponent(dealer_soldout)
			if currentCar.mIsLock ~= 0 then
				ShowComponent(dealer_lock)
				DisableComponent(dealer_btn_purchase)
				ReplaceButtonRes(dealer_btn_purchase, 'ui_ingame_gmovr_btn_y_l')
				ChangeComponent2Grey(dealer_btn_purchase)
				ShowComponent(dealer_lockedcar)
				HideComponent(dealer_img_diamondbuy)
				HideComponent(dealer_data_payback)
			else
				-- if currentCar.mCarId == 24 then
				if Logic_and(currentCar.mPrimeIAP == 0 ,currentCar.mCarId == 24)then
					DisableComponent(dealer_btn_purchase)
					ChangeComponent2Grey(dealer_btn_purchase)
				else
					EnableComponent(dealer_btn_purchase)
					ChangeComponent2Color(dealer_btn_purchase)
				end
				HideComponent(dealer_lock)
				HideComponent(dealer_lockedcar)
				ShowComponent(dealer_img_diamondbuy)
				if currentCar.mGetMoney ~= 0 then
					ShowComponent(dealer_data_payback)
				else
					HideComponent(dealer_data_payback)
				end
			end
		end
		AniPlayUnlockScreen(dealer_namebar, 200, 'ui_ani_show_mvx_fd')
		ShowComponent(dealer_class)
		AniPlayUnlockScreen(dealer_class, 400, 'ui_ani_show_default')
		AniPlayUnlockScreen(dealer_weight, 350, 'ui_ani_show_mvx_fd')
		AniPlayUnlockScreen(dealer_cartype, 400, 'ui_ani_show_mvx_fd')
	end
	ConfigCarFunctionButtons()
	--change intro
	if dealer_girl:IsShow() == 0 then
		AniPlayUnlockScreen(dealer_intro, 500, 'ui_ani_show_default')
	end
	if garage_girl:IsShow() == 0 then
		AniPlayUnlockScreen(garage_intro, 500, 'ui_ani_show_default')
	end
end
---C-H-A-N-G-E-C-A-R------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------Y-C-A-R---
function OnBuyCar()
	OnChangeCar()
	if ui_dealer_root:IsShow() == 1 then
		ConfigShowgirl(dealer_girl, '', AM_GetSTR(104))
	end
end

function OnRedeemCar()
	local currentcarinfor = GetCurrentCarInfo()
	ConfigCarMaxSpeedWithDriverSkill(StateGarage:GetCurrentDriverShopItemId(), currentcarinfor)
	SetComponentText(item_car_info_name, currentcarinfor.mName)
end
---B-U-Y-C-A-R------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------S-E-L-E-C-T-C-A-R---
function OnSelectCar()
	ConfigCarFunctionButtons()
	ConfigShowgirl(garage_girl, '', AM_GetSTR(105))
end
---S-E-L-E-C-T-C-A-R------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------B-U-Y-D-R-I-V-E-R---
function OnBuyDriver()
	ConfigDriverInfo(StateGarage:GetCurrentDriverShopItemId())
	ReplaceSprByState(navi_top_rig_driver_icon, EnumGUIGraphicState.Normal, GetCurrentDriverInfo().mIcon .. '_body')
end
---B-U-Y-D-R-I-V-E-R------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------U-P-G-R-A-D-E-D-R-I-V-E-R---
function OnUpgradeDriver()
	ConfigDriverInfo(StateGarage:GetCurrentDriverShopItemId())
end
---U-P-G-R-A-D-E-D-R-I-V-E-R----------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------S-E-L-E-C-T-D-R-I-V-E-R---
function OnSelectDriver()
	ReplaceSprByState(navi_top_rig_driver_icon, EnumGUIGraphicState.Normal, GetCurrentDriverInfo().mIcon .. '_body')
	if StateGarage:GetCurrentDriverShopItemId() == StateGarage:GetSelectedDriverShopItemId() then
		_uiComponentDisplay.setDFlag(uiC_driver_btn_select, true)
		_uiComponentDisplay.setEFlag(uiC_driver_btn_select, false)
		SetComponentText(driver_btn_select, '1')
		ReplaceButtonRes(uiC_driver_btn_select.CName, 'ui_ingame_gmovr_btn_y_l')
		ChangeComponent2Grey(driver_btn_select)
		DisableComponent(driver_btn_select)
	else
		_uiComponentDisplay.setDFlag(uiC_driver_btn_select, true)
		_uiComponentDisplay.setEFlag(uiC_driver_btn_select, true)
		SetComponentText(driver_btn_select, '0')
		ReplaceButtonRes(uiC_driver_btn_select.CName, 'ui_ingame_gmovr_btn_b_l')
		ChangeComponent2Color(driver_btn_select)
		EnableComponent(driver_btn_select)
	end
	ConfigDriverFunctionButtons()
end
------------------------------------------------------------------------------------------S-E-L-E-C-T-D-R-I-V-E-R---
---R-E-F-R-E-S-H-C-A-R-D-A-T-A--------------------------------------------------------------------------------------
function OnRefreshCurrentCarData()
	RefreshCurrentCarData(GetCurrentCarInfo())
end
----------------------------------------------------------------------------------------R-E-F-R-E-S-H-C-A-R-D-A-T-A-
----------------------------------------------------------------------------------------------------S-T-A-N-D-B-Y---
function OnStandBy()

end

---S-T-A-N-D-B-Y----------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------F-U-N-C-T-I-O-N---

---F-U-N-C-T-I-O-N--------------------------------------------------------------------------------------------------