LuaCore.Require("functions.lua")
LuaCore.Require("initialize.lua")
----------------------------------------------------------------------------------------------I-N-I-T-I-A-L-I-Z-E---
function InitializeUIRoots()
	local functionName = 'InitializeUIRoots'
	_uiComponentDisplay.setDFlag(uiR_ui_select_item, false)
	_uiComponentDisplay.setDFlag(uiR_ui_stage, false)
	_uiComponentDisplay.setDFlag(uiR_ui_vipstore, false)
	_uiComponentDisplay.setDFlag(uiR_ui_gacha, false)
	_uiComponentDisplay.setDFlag(uiR_ui_vsmode, false)
	_uiComponentDisplay.setDFlag(uiR_ui_pvp_redeem, false)
	
	if flag_smallpack == false then
		_uiComponentDisplay.setDFlag(uiR_ui_challenge, false)
		_uiComponentDisplay.setDFlag(uiR_ui_challenge_ak, false)
		_uiComponentDisplay.setDFlag(uiR_ui_challenge_tr, false)
		_uiComponentDisplay.setDFlag(uiR_ui_challenge_redeem, false)
		_uiComponentDisplay.setDFlag(uiR_ui_challenge_redeem_tr, false)
		_uiComponentDisplay.setDFlag(uiR_ui_championship, false)
	end
	
	_uiComponentDisplay.setDFlag(uiR_ui_dealer, false)
	_uiComponentDisplay.setDFlag(uiR_ui_garage, false)
	_uiComponentDisplay.setDFlag(uiR_ui_driver, false)
	_uiComponentDisplay.setDFlag(uiR_ui_main, false)
	
	HideComponent(navi_top_back2title_btn)
	--HideComponent(navi_top_stage_sub_chp_btn_start)
--[[	
	if flag_pop_sidebar == true then
		AniMoveX(main_sidebar_right, 350, 200, 150)
		flag_pop_sidebar = false
	end
--]]
	AM_PringLog('CALL: ' .. functionName)
end

function ConfigUIRoots()
	local functionName = 'ConfigUIRoots'
	AM_ShowComponent(uiR_ui_select_item)
	AM_ShowComponent(uiR_ui_stage)
	AM_ShowComponent(uiR_ui_dealer)
	AM_ShowComponent(uiR_ui_garage)
	AM_ShowComponent(uiR_ui_vipstore)
	AM_ShowComponent(uiR_ui_gacha)
	AM_ShowComponent(uiR_ui_vsmode)
	AM_ShowComponent(uiR_ui_pvp_redeem)
	
	if flag_smallpack == false then
		AM_ShowComponent(uiR_ui_challenge)
		AM_ShowComponent(uiR_ui_challenge_ak)
		AM_ShowComponent(uiR_ui_challenge_tr)
		AM_ShowComponent(uiR_ui_challenge_redeem)
		AM_ShowComponent(uiR_ui_challenge_redeem_tr)
		AM_ShowComponent(uiR_ui_championship)
	end
	
	AM_ShowComponent(uiR_ui_driver)
	AM_ShowComponent(uiR_ui_main)
	
	if ui_dealer_root:IsShow() == 1 then
		if	flag_smallpack == true then
			AM_PlayBGM('bgm_garage')
		else
			AM_PlayBGM('bgm_shop')
		end
	elseif ui_challenge_root:IsShow() == 1 then
			AM_PlayBGM('bgm_city2')
	elseif Logic_and(ui_select_item_root:IsShow() == 1, flag_vs_mode == true) then
			AM_PlayBGM('bgm_seoul_menu')
	elseif ui_garage_root:IsShow() == 1 then
			AM_PlayBGM('bgm_garage')
	else
		AM_PlayBGM('bgm_garage')
	end

	if flag_vs_mode == true then
		ShowComponent(navi_top_stage_sub_rm_energy_bar)
		AniPlayUnlockScreen(navi_top_stage_sub_rm_energy_bar, 500, 'ui_ani_show_default')
		HideComponentWithAni(navi_top_inventory_t, 150, 'ui_ani_hide_default')
	else
		HideComponentWithAni(navi_top_stage_sub_rm_energy_bar, 150, 'ui_ani_hide_default')
		ShowComponent(navi_top_inventory_t)
		AniPlayUnlockScreen(navi_top_inventory_t, 300, 'ui_ani_show_default')
	end

	InitializeMap()
	InitializeNaviTop()
	AM_PringLog('CALL: ' .. functionName)
end

function InitializeUIPopup()
	_uiComponentDisplay.setDFlag(uiR_ui_popup_upg2max, false)
end

function ConfigUIPopup()
	AM_ShowComponent(uiR_ui_popup_upg2max, 'UEFF_POP', 50)
end

function InitializeMap()
	local functionName = 'InitializeMap'
	if Logic_or(uiR_ui_select_item.DFlag == true, uiR_ui_garage.DFlag == true, uiR_ui_dealer.DFlag == true, uiR_ui_vsmode.DFlag == true) then
		_uiComponentDisplay.setDFlag(uiR_ui_map, false)
		flag_show_map = true
		AM_PringLog('CALL: ' .. functionName .. '~hide')
	else
		--if uiR_ui_map.DFlag == true then
		if ui_map_root.IsShow() == true then
			flag_show_map = false
		end
		_uiComponentDisplay.setDFlag(uiR_ui_map, true)
		AM_PringLog('CALL: ' .. functionName .. '~show')
	end

	if flag_show_map == true then
		AM_ShowComponent(uiR_ui_map)
	end

end

function InitializeNaviTop()
	local functionName = 'InitializeNaviTop'
	if flag_rm_mode == true then
		HideComponent(item_next_stage_info_speed)
	else
		ShowComponent(item_next_stage_info_speed)
	end
--[[	
	if Logic_or(ui_rm_pr_root:IsShow() == 1, ui_main_root:IsShow() == 1) then
		HideComponent(navi_top_close_vm_btn)
	else
		ShowComponent(navi_top_close_vm_btn)
	end
--]]	
	HideComponent(navi_top_close_vm_btn)
	AM_PringLog('CALL: ' .. functionName)
end

function InitializeGarage()
	local functionName = 'InitializeGarage'
	HideComponent(garage_lvmax)
	ShowComponent(garage_lvmax_not)
	HideComponentWithAni(navi_top_stage_sub_rm_energy_bar, 50, 'ui_ani_hide_default')
	flag_show_energybar = false
	ConfigCarFunctionButtons()
	AM_PlayBGM('bgm_garage')
	AM_PringLog('CALL: ' .. functionName)
end

function InitializeDealer()
	--HideComponent(ui_map_root)
end

function InitializeMain()
	local functionName = 'InitializeMain'
	StateGarage:OnBackToMainUI()
	
	SetComponentOffset(stage_info_title, 0, 0)
	flag_move_stage_title = true
	selected_substage = false
	HideComponent(stage_btn_next)
	HideComponent(stage_sub)
	HideComponent(main_btn_friends)
	HideComponent(main_btn_invite_friends)
	--HideComponent(navi_top_stage_sub_rm)
	--ShowComponent(main_btn_mission_dialog_bubble)
	
	--AniMoveY(main_btn_bg, -150, 400, 100)
	AniPlayUnlockScreen(main_sidebar_left, 400, 'ui_ani_show_default')
	AniPlayUnlockScreen(main_sidebar_right, 400, 'ui_ani_show_default')
	
	AniPlayUnlockScreen(main_btn_mission, 350, 'ui_ani_show_default')
	--AniPlayUnlockScreen(main_btn_mission_dialog_bubble, 800, 'ui_ani_show_default')
--[[	
	if StateGarage:IsActivityOver(4) == 0 then
		ShowComponent(main_btn_campaign)
		AniPlayUnlockScreen(main_btn_campaign, 600, 'ui_ani_show_default')
	else
		HideComponent(main_btn_campaign)
	end
--]]	
	--AniPlayUnlockScreen(main_btn_rm, 400, 'ui_ani_show_default')
	-- if channel_id == 'cmgVIP' then
		-- AniPlayUnlockScreen(main_btn_cmpack, 600, 'ui_ani_show_default')
	-- end
	AniPlayUnlockScreen(main_btn_achievement, 350, 'ui_ani_show_default')
	-- AniPlayUnlockScreen(main_btn_friends, 350, 'ui_ani_show_default')
	
	AniPlayUnlockScreen(main_btn_bg, 350, 'ui_ani_show_main_dbar')

	if main_btn_shop_disable:IsShow() == 0 then
		ReplaceButtonRes(main_btn_shop, 'ui_main_shop')
	else
		ReplaceButtonRes(main_btn_shop, 'ui_main_shop_d')
	end
	ShowComponent(main_btn_shop)
	AniPlay(main_btn_shop_disable, 350, 'ui_ani_show_delay')
	
	if main_btn_garage_disable:IsShow() == 0 then
		ReplaceButtonRes(main_btn_garage, 'ui_main_garage')
	else
		ReplaceButtonRes(main_btn_garage, 'ui_main_garage_d')
	end
	ShowComponent(main_btn_garage)
	AniPlay(main_btn_garage_disable, 350, 'ui_ani_show_delay')
	
	if main_btn_driver_disable:IsShow() == 0 then
		ReplaceButtonRes(main_btn_driver, 'ui_main_driver')
	else
		ReplaceButtonRes(main_btn_driver, 'ui_main_driver_d')
	end
	ShowComponent(main_btn_driver)
	AniPlay(main_btn_driver_disable, 350, 'ui_ani_show_delay')
	
	if main_btn_pvp_disable:IsShow() == 0 then
		ReplaceButtonRes(main_btn_pvp, 'ui_main_btn_social')
	else
		ReplaceButtonRes(main_btn_pvp, 'ui_main_btn_social_d')
	end
	ShowComponent(main_btn_pvp)
	AniPlay(main_btn_pvp_disable, 350, 'ui_ani_show_delay')
	
	ShowComponent(main_btn_mall)
	
	AniPlay(main_stage_btn, 350, 'ui_ani_show_default')
	AniPlay(main_btn_stage_disable, 350, 'ui_ani_show_default')
	
	-- AniPlay(main_btn_invite_friends, 700, 'ui_ani_show_default')
	
	AM_PlayBGM('bgm_garage', 200, 300)
	
	ShowComponent(navi_top_back2title_btn)
	AniPlayUnlockScreen(navi_top_back2title_btn, 350, 'ui_ani_show_default')
	if channel_id == 'dongyou' then
		HideComponent(main_service_btn)
	else
		AniPlayUnlockScreen(main_service_btn, 350, 'ui_ani_show_default')
	end
	
	HideComponentWithAni(navi_top_stage_sub_rm_energy_bar, 150, 'ui_ani_hide_default')
	flag_show_energybar = false
	ShowComponent(navi_top_inventory_t)
	-- AniPlayUnlockScreen(navi_top_inventory, 300, 'ui_ani_show_default')
	--ShowComponent(ui_map_root)
	AM_PringLog('CALL: ' .. functionName)
end

function InitializeStage()
	local functionName = 'InitializeStage'
	local chapter_id = StateGarage:GetSelectedChapter()
	local stage_id = StateGarage:GetSelectedStage()
	local cur_substage = StateGarage:GetStageInfoByID(chapter_id, stage_id)
	flag_curstage_type = cur_substage.mType
	
	--AniPlay(stage_tip, 450, 'ui_ani_show_default')
	HideComponent(stage_locked)
	HideComponent(item_go_btn)
	HideComponent(navi_top_stage_sub_chp_btn_start)
	HideComponent(navi_top_stage_sub_vs_btn_start)
	ShowComponent(stage_sub_info)
	ShowComponent(stage_info_main_bottom)
	ShowComponent(stage_info_title)
	
	--dialog stage
	if Logic_or(cur_substage.mType == 3, stage_id == 0) then
		HideComponent(stage_btn_next)
		flag_show_btn_next = true
		ShowComponent(stage_btn_sinario)
		if flag_show_btn == true then
			AniPlayUnlockScreen(stage_btn_sinario, 200, 'ui_ani_show_default')
			flag_show_btn = false
		end
		ReplaceButtonRes(stage_sub_bg_text, 'ui_stage_story')
	--normal stage
	else
		ShowComponent(stage_btn_next)
		if flag_show_btn_next == true then
			AniPlayUnlockScreen(stage_btn_next, 200, 'ui_ani_show_default')
			flag_show_btn_next = false
		end
		HideComponent(stage_btn_sinario)
		flag_show_btn = true
		ReplaceButtonRes(stage_sub_bg_text, 'ui_stage_target')
	end
	--ShowComponent(ui_map_root)
	AM_PringLog('CALL: ' .. functionName)
end

function InitializeSelectItem()
	local functionName = 'InitializeSelectItem'
	if flag_championship_mode == true then
		HideComponent(item_go_btn)
		ShowComponent(navi_top_stage_sub_chp_btn_start)
		HideComponent(navi_top_stage_sub_rm_btn_start)
		AniPlayUnlockScreen(navi_top_stage_sub_chp_btn_start, 400, 'ui_ani_show_default')
	elseif flag_vs_mode == true then
		HideComponent(item_go_btn)
		ShowComponent(navi_top_stage_sub_vs_btn_start)
		AniPlayUnlockScreen(navi_top_stage_sub_vs_btn_start, 400, 'ui_ani_show_default')
		ShowComponent(stage_info_title)
	else
		SetSubstageData(StateGarage:GetSelectedChapter(), StateGarage:GetSelectedStage())
		HideComponent(navi_top_stage_sub_chp_btn_start)
		HideComponent(navi_top_stage_sub_rm_btn_start)
		ShowComponent(item_go_btn)
		AniPlayUnlockScreen(item_go_btn, 400, 'ui_ani_show_default')
	end
	
	HideComponent(stage_sub_info)
	HideComponent(stage_btn_next)
	flag_show_btn_next = true
	AniPlayUnlockScreen(navi_top_rig_car, 450, 'ui_ani_show_default')
	AniPlayUnlockScreen(navi_top_rig_car_disable, 450, 'ui_ani_show_default')
	AniPlayUnlockScreen(navi_top_rig_driver, 450, 'ui_ani_show_default')
	--AniPlayUnlockScreen(navi_top_rig_driver_bg, 450, 'ui_ani_show_default')
	AniPlayUnlockScreen(navi_top_rig_driver_disable, 450, 'ui_ani_show_default')
	
	--HideComponent(ui_map_root)
	AM_PringLog('CALL: ' .. functionName)
end

function InitializeChallenge()
	local functionName = 'InitializeChallenge'
	HideComponent(challenge_infotext_buyitem)
	--ShowComponent(challenge_infotext_network)
	ShowComponent(challenge_buy_item_btn)
	HideComponent(challenge_buy_item)
	HideComponent(challenge_back2normal_btn)
	HideComponent(challenge_back2normal_x_btn)
	AM_PringLog('CALL: ' .. functionName)
end

function InitializeChallengeAK()
	local functionName = 'InitializeChallengeAK'
	ShowComponent(challenge_ak_navi_slider)
	AM_PringLog('CALL: ' .. functionName)
end

function InitializeChallengeTR()
	local functionName = 'InitializeChallengeTR'
	ShowComponent(challenge_tr_navi_slider)
	AM_PringLog('CALL: ' .. functionName)
end

function InitializeChallengeRedeemTR()
	local functionName = 'InitializeChallengeRedeemTR'
	AniPlayUnlockScreen(challenge_redeem_tr_namebar, 200, 'ui_ani_show_mvx_fd')
	ShowComponent(challenge_redeem_tr_class)
	AniPlayUnlockScreen(challenge_redeem_tr_class, 400, 'ui_ani_show_default')
	AniPlayUnlockScreen(challenge_redeem_tr_weight, 350, 'ui_ani_show_mvx_fd')
	AniPlayUnlockScreen(challenge_redeem_tr_cartype, 400, 'ui_ani_show_mvx_fd')

	AniPlayUnlockScreen(challenge_redeem_tr_spark01, 400, 'ui_ani_show_mvx_fd')
	AniPlayUnlockScreen(challenge_redeem_tr_spark02, 450, 'ui_ani_show_mvx_fd')
	AniPlayUnlockScreen(challenge_redeem_tr_spark03, 500, 'ui_ani_show_mvx_fd')
	AniPlayUnlockScreen(challenge_redeem_tr_spark04, 550, 'ui_ani_show_mvx_fd')
	AniPlayUnlockScreen(challenge_redeem_tr_call, 650, 'ui_ani_show_default')
	
	AniPlayUnlockScreen(challenge_redeem_tr_intro, 500, 'ui_ani_show_default')
	AM_PringLog('CALL: ' .. functionName)
end

function InitializeChampionship()
	local functionName = 'InitializeChampionship'
	flag_championship_mode = true
	SetSubstageData(901, StateGarage:GetCurrentChampionship())
	ShowComponent(stage_btn_next)
	AniPlayUnlockScreen(stage_btn_next, 400, 'ui_ani_show_default')
	HideComponent(item_go_btn)
	HideComponent(navi_top_stage_sub_chp_btn_start)
	HideComponent(stage_btn_sinario)
	HideComponent(championship_locked)
	HideComponent(stage_info_main_bottom)
	ShowComponent(stage_sub_info)
	AM_PringLog('CALL: ' .. functionName)
end

function InitializeGacha()

end

function InitializeRm()
	local functionName = 'InitializeRm'
	flag_rm_mode = true
	SetSubstageData(950, 1)
	ShowComponent(stage_info_waist_eff)
	HideComponent(navi_top_stage_sub_rm_btn_start)
	HideComponent(stage_info_title)
	AM_PringLog('CALL: ' .. functionName)
end

function InitializeRmRedeem()
	flag_rm_mode = true
	--InitializeRm()
end

function InitializeVSMode()
	local functionName = 'InitializeRm'
	flag_vs_mode = true
	SetSubstageData(910, 1)
	ShowComponent(stage_info_waist_eff)
	HideComponent(navi_top_stage_sub_rm_btn_start)
	HideComponent(stage_sub)
	AM_PringLog('CALL: ' .. functionName)
end

function InitializePVPRedeem()

end
---I-N-I-T-I-A-L-I-Z-E----------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------D-I-S-P-L-A-Y---
function SetCurrentUIData(uiR_root)
	_uiComponentDisplay.setCName(uiR_current_ui, uiR_root.CName)
	_uiComponentDisplay.setDFlag(uiR_current_ui, uiC_navi_top_back_btn.DFlag)
end

function ConfigNaviButtons(...)
	local arguments = {...}
	local call_function_name
	
	if #arguments ~= 0 then
		call_function_name = '~BY~' .. arguments[1]
	else
		call_function_name = ''
	end
	
	local functionName = 'ConfigNaviButtons'
	DisplayConfigByCName(uiC_navi_top_back_btn)
	if ui_main_root:IsShow() == 1 then
		--AM_ShowComponent(uiC_navi_top_back_btn, '', 500)
		AniPlayUnlockScreen(navi_top_back_btn, 300, 'ui_ani_show_default')
	end
	
	if uiC_navi_top_back_btn.DFlag == true then
		ShowComponent(stage_sub)
		if flag_rm_mode == true then
			--ShowComponent(navi_top_stage_sub_rm_energy_bar)
			HideComponent(stage_sub_info)
			HideComponent(stage_btn_next)
			HideComponent(stage_btn_sinario)
			HideComponent(item_go_btn)
			--HideComponent(navi_top_inventory_t)
			HideComponent(navi_top_stage_sub_chp_btn_start)
			--HideComponent(item_next_stage_info_speed)
		else
			--HideComponent(navi_top_stage_sub_rm_energy_bar)
			--ShowComponent(item_next_stage_info_speed)
		end
		if flag_show_sub == true then
			AniPlayUnlockScreen(stage_sub, 300, 'ui_ani_show_default')
			flag_show_sub = false
		end
	else
		HideComponentWithAni(stage_sub, 200, 'ui_ani_hide_default')
		--AniPlay(stage_sub, 300, 'ui_ani_hide_default')
		flag_show_sub = true
	end
	AM_PringLog('CALL: ' .. functionName .. '~' .. navi_top_back_btn:IsShow() .. call_function_name)
end

function ConfigDriverFunctionButtons()
	DisplayConfigByCName(uiC_driver_btn_promote)
	DisplayConfigByCName(uiC_driver_btn_select)
	DisplayConfigByCName(uiC_driver_btn_buy)
end

function ConfigCarFunctionButtons()
	DisplayConfigByCName(uiC_garage_fuction_btn_upgd)
	DisplayConfigByCName(uiC_garage_btn_upgd2max)
end

function ConfigDriverInfo(shop_item_id)
	local driver_name
	local skill1_data
	local skill2_data
	local skill3_data
	
	currentDriver = _currentDriverInfo:new()
	AM_PlayBGM('bgm_garage')
	
	if shop_item_id == 0 then
		shop_item_id = (StateGarage:GetCurrentDriverShopItemId() and StateGarage:GetCurrentDriverShopItemId()) or 75
		HideComponent(navi_top_driver_text)
		ShowComponent(navi_top_rig_driver_icon_null)
		AniPlayUnlockScreen(navi_top_rig_driver_icon_null, 400, 'ui_ani_show_mvx_fd')
	else
		ShowComponent(navi_top_driver_text)
		HideComponent(navi_top_rig_driver_icon_null)
	end

	_currentDriverInfo.setCurrentDriver(currentDriver, shop_item_id)
	
	driver_name = (currentDriver.CurrentDriver.mLocked ~= 0 and '') or currentDriver.CurrentDriver.mName
	SetComponentText(driver_card_name, driver_name)
	SetComponentText(driver_card_name_shadow, driver_name)
	SetComponentText(driver_card_name_eff, driver_name)
	
	skill1_data = (currentDriver.Skill1.mData / 1000 >= 1 and currentDriver.Skill1.mData / 1000) or currentDriver.Skill1.mData
	SetComponentText(driver_card_ability_1_t, AM_GetSTR(currentDriver.Skill1.mDesc, skill1_data))

	skill2_data = (currentDriver.Skill2.mData / 1000 >= 1 and currentDriver.Skill2.mData / 1000) or currentDriver.Skill2.mData
	SetComponentText(driver_card_ability_2_t, AM_GetSTR(currentDriver.Skill2.mDesc, skill2_data))

	skill3_data = (currentDriver.Skill3.mData / 1000 >= 1 and currentDriver.Skill3.mData / 1000) or currentDriver.Skill3.mData
	SetComponentText(driver_card_ability_3_t, AM_GetSTR(currentDriver.Skill3.mDesc, skill3_data))
	
	if currentDriver.CurrentDriver.mPurchased ~= 0 then
		_uiComponentDisplay.setDFlag(uiC_driver_btn_promote, true)
		_uiComponentDisplay.setEFlag(uiC_driver_btn_promote, false)
		SetComponentText(driver_btn_promote, '1')
		ReplaceButtonRes(uiC_driver_btn_promote.CName, 'ui_btn_pop_g')
		
		if StateGarage:GetCurrentDriverShopItemId() == StateGarage:GetSelectedDriverShopItemId() then
			_uiComponentDisplay.setDFlag(uiC_driver_btn_select, true)
			_uiComponentDisplay.setEFlag(uiC_driver_btn_select, false)
			SetComponentText(driver_btn_select, '1')
			ReplaceButtonRes(uiC_driver_btn_select.CName, 'ui_ingame_gmovr_btn_y_l')
			ChangeComponent2Grey(driver_btn_select)
			DisableComponent(driver_btn_select)
		else
			_uiComponentDisplay.setDFlag(uiC_driver_btn_select, true)
			_uiComponentDisplay.setEFlag(uiC_driver_btn_select, true)
			SetComponentText(driver_btn_select, '0')
			ReplaceButtonRes(uiC_driver_btn_select.CName, 'ui_ingame_gmovr_btn_b_l')
			ChangeComponent2Color(driver_btn_select)
			EnableComponent(driver_btn_select)
		end
		_uiComponentDisplay.setDFlag(uiC_driver_btn_buy, false)
		ReplaceButtonRes(driver_pad_cover, 'ui_btn_t_choose')
		HideComponent(driver_btn_buy_price)
		--set sale mark
--[[
		if currentDriver.CurrentDriver.mID == 11 then
			ConfigSaleInfo(driver_sale_mark)
		else
			HideComponent(driver_sale_mark)
		end
--]]	
		HideComponent(driver_sale_mark)
		ShowComponent(driver_card_bg_head_eff)	
		
		--rm redeem
		HideComponent(driver_pad_redeem)
	else
		--set price
		--if Logic_or(currentDriver.CurrentDriver.mID == 12, currentDriver.CurrentDriver.mID == 14, currentDriver.CurrentDriver.mID == 16, currentDriver.CurrentDriver.mID == 18) then
		-- if Logic_and(currentDriver.CurrentDriver.mID >= 12, currentDriver.CurrentDriver.mID <= 18) then
			-- ConfigSaleInfo(driver_sale_mark)
			-- SetPrice(driver_btn_buy_price, 'D', currentDriver.CurrentDriver.mCoin, currentDriver.CurrentDriver.mRealMoney)
		-- else
			HideComponent(driver_sale_mark)
			SetPrice(driver_btn_buy_price, '', currentDriver.CurrentDriver.mCoin, currentDriver.CurrentDriver.mRealMoney)
		-- end
		if currentDriver.CurrentDriver.mID == 11 then
			SetComponentText(driver_discount,'PG200')
			ShowComponent(driver_discount)
			ReplaceButtonRes(driver_btn_buy, 'ui_ingame_gmovr_btn_r_l')
		else
			HideComponent(driver_discount)
			ReplaceButtonRes(driver_btn_buy, 'ui_ingame_gmovr_btn_y_l')
		end
		
		if currentDriver.CurrentDriver.mLocked ~= 0 then
			ShowComponent(driver_pad_cover)
			ReplaceButtonRes(driver_pad_cover, 'ui_btn_t_locked_driver')
			-- SetComponentText(driver_pad_cover, currentDriver.CurrentDriver.mDesc)
			AniFadeInUnlockScreen(driver_pad_cover, 200, 300)
			_uiComponentDisplay.setDFlag(uiC_driver_btn_buy, false)
			HideComponent(driver_btn_buy_price)
		else
			ReplaceButtonRes(driver_pad_cover, 'ui_btn_t_hire')
			_uiComponentDisplay.setDFlag(uiC_driver_btn_buy, true)
			ShowComponent(driver_btn_buy_price)
		end
	
		_uiComponentDisplay.setDFlag(uiC_driver_btn_promote, false)
		_uiComponentDisplay.setDFlag(uiC_driver_btn_select, false)
	end
	
	ConfigDriverFunctionButtons()
	AniPlayUnlockScreen(driver_card_cell, 0, 'ui_ani_show_mvrl')
	ShowComponent(driver_card_name)
	AniPlayUnlockScreen(driver_card_name, 200, 'ui_ani_show_mvx_fd')
end

function ConfigCarMaxSpeedWithDriverSkill(selected_driver_id, currentCar_info)
	local currentCarSpeedTotal = 0
	local skill1_desc = ''
	local skill2_desc = ''
	local skill3_desc = ''
	local skill1_data
	local skill2_data
	local skill3_data
	local substage = StateGarage:GetStageInfoByID(StateGarage:GetSelectedChapter(), StateGarage:GetSelectedStage())
	
	if selected_driver_id ~= 0 then
		local selected_driver = _currentDriverInfo:new()
		_currentDriverInfo.setCurrentDriver(selected_driver, selected_driver_id)
		
		if selected_driver.CurrentDriver.mPurchased ~= 0 then
			if selected_driver.Skill1.mType == 2 then
				driverSPMaxSkill = selected_driver.Skill1.mData
			else
				if selected_driver.Skill2.mType == 2 then
					driverSPMaxSkill = selected_driver.Skill2.mData
				else
					if selected_driver.Skill3.mType == 2 then
						driverSPMaxSkill = selected_driver.Skill3.mData
					else
						driverSPMaxSkill = ''
					end
				end
			end
			
			skill1_data = (selected_driver.Skill1.mData / 1000 >= 1 and selected_driver.Skill1.mData / 1000) or selected_driver.Skill1.mData
			skill1_desc = AM_GetSTR(selected_driver.Skill1.mDesc, skill1_data)
			skill2_data = (selected_driver.Skill2.mData / 1000 >= 1 and selected_driver.Skill2.mData / 1000) or selected_driver.Skill2.mData
			skill2_desc = AM_GetSTR(selected_driver.Skill2.mDesc, skill2_data)
			skill3_data = (selected_driver.Skill3.mData / 1000 >= 1 and selected_driver.Skill3.mData / 1000) or selected_driver.Skill3.mData
			skill3_desc = AM_GetSTR(selected_driver.Skill3.mDesc, skill3_data)
		else
			driverSPMaxSkill = ''
		end
		AM_SetComponentText(navi_top_driver_text, ' ', selected_driver.mName)
	else
		driverSPMaxSkill = ''
	end
	
	if driverSPMaxSkill == '' then
		currentCarSpeedTotal = currentCar_info.mMaxSpeedCurrLevelDisplayValue
	else
		currentCarSpeedTotal = currentCar_info.mMaxSpeedCurrLevelDisplayValue + driverSPMaxSkill
	end
	
	AM_SetComponentText(item_car_info_speed, currentCarSpeedTotal, '0')
	
	if substage.mRecommendedSpeed > currentCarSpeedTotal then
		ShowComponent(item_stage_speed)
	else
		HideComponent(item_stage_speed)
	end
	
	
	AM_SetComponentText(navi_top_rig_driver_skill_1, skill1_desc)
	AM_SetComponentText(navi_top_rig_driver_skill_2, skill2_desc)
	AM_SetComponentText(navi_top_rig_driver_skill_3, skill3_desc)
end

function ConfigShowgirl(component_name, ...)--(component_name, delay, string_index, fitst_time_delay)
	local arguments = {...}
	local delay = 2000
	local fitst_time_delay = 500
	local girl_pix = (component_name == dealer_girl and dealer_girl_pix) or garage_girl_pix
	local girl_talk = (component_name == dealer_girl and dealer_girl_talk) or garage_girl_talk
	local girl_talk_text = (component_name == dealer_girl and dealer_girl_talk_text) or garage_girl_talk_text
	local text_id = (component_name == dealer_girl and 107) or 106
	local string_index_value = AM_GetSTR(text_id)
	--[[
	if arguments[2] ~= nil  then
		if arguments[2] ~= '' then
			delay = arguments[2]
		end
	end
	
	if arguments[3] ~= nil then
		string_index_value = arguments[3]
	end
	
	if arguments[4] ~= nil then
		fitst_time_delay = arguments[4]
	end
	--]]
	if #arguments ~= 0 then
		for v in ipairs(arguments) do
			if v == 1 then
				if arguments[v] ~= '' then
					delay = arguments[v]
				end
			elseif v == 2 then
				string_index_value = arguments[v]
			elseif v == 3 then
				fitst_time_delay = arguments[v]
			end
		end
	end	
	
	
	SetComponentText(girl_talk_text, string_index_value)
	ShowComponent(component_name)
	AniPlayUnlockScreen(girl_pix, fitst_time_delay + 100, 'ui_ani_show_stageclass')
	AniPlayUnlockScreen(girl_talk, fitst_time_delay + 200, 'ui_ani_show_stageclass')
	HideComponentWithAni(component_name, delay, 'ui_ani_hide_default')
	
	if ui_dealer_root:IsShow() == 1 then
		AniPlayUnlockScreen(dealer_intro, 2500, 'ui_ani_show_default')
	elseif ui_garage_root:IsShow() == 1 then
		AniPlayUnlockScreen(garage_intro, 500, 'ui_ani_show_default')
	end
end

function ConfigMainButtonMask()
	if main_btn_shop_disable:IsShow() == 0 then
		ReplaceButtonRes(main_btn_shop, 'ui_main_shop')
		--AM_SetComponentText(main_btn_shop, '0')
	end

	if main_btn_garage_disable:IsShow() == 0 then
		ReplaceButtonRes(main_btn_garage, 'ui_main_garage')
		--AM_SetComponentText(main_btn_garage, '0')
	end

	if main_btn_driver_disable:IsShow() == 0 then
		ReplaceButtonRes(main_btn_driver, 'ui_main_driver')
		--AM_SetComponentText(main_btn_driver, '0')
	end

	if main_btn_pvp_disable:IsShow() == 0 then
		ReplaceButtonRes(main_btn_pvp, 'ui_main_btn_social')
		--AM_SetComponentText(main_btn_pvp, '0')
	end
end

function ClearScreen(flag, ...)
	local arguments = {...}
	local delay = 200
	
	if #arguments ~= 0 then
		delay = arguments[1]
	end
	
	if flag == true then
		HideComponentWithAni(main_sidebar_left, 0, 'ui_ani_hide_default')
		HideComponentWithAni(main_sidebar_right, 200, 'ui_ani_hide_default')
		HideComponentWithAni(navi_top_vm_btn, 100, 'ui_ani_hide_default')
		-- HideComponentWithAni(navi_top_close_vm_btn, 100, 'ui_ani_hide_default')
		HideComponentWithAni(map_topbar, 400, 'ui_ani_hide_default')
		HideComponentWithAni(navi_top_inventory, 400, 'ui_ani_hide_default')
		HideComponentWithAni(main_btn_bg, 400, 'ui_ani_hide_main_dbar')
		HideComponentWithAni(main_service_btn, 400, 'ui_ani_hide_default')
		-- if channel_id == 'cmgVIP' then
			-- HideComponentWithAni(main_btn_cmpack, 200, 'ui_ani_hide_default')
		-- end
--[[
		if flag_pop_sidebar == true then
			AniMoveX(main_sidebar_right, 390, 100, 200)
			flag_pop_sidebar = false
		else
			HideComponentWithAni(main_sidebar_right, 200, 'ui_ani_hide_default')
		end
--]]		
--[[
		if StateGarage:IsActivityOver(4) == 0 then
			HideComponentWithAni(main_btn_campaign, 200, 'ui_ani_hide_default')
		end
--]]
		--HideComponentWithAni(main_btn_rm, 200, 'ui_ani_hide_default')
		--HideComponentWithAni(main_driver_icon, 200, 'ui_ani_hide_default')
		-- if channel_id == 'dongyou' then
			-- HideComponent(main_service_btn)
		-- else
			-- HideComponentWithAni(main_service_btn, 100, 'ui_ani_hide_default')
		-- end
	else
		StateGarage:OnRefreshRMBannerXL()
		ShowComponent(main_sidebar_left)
		ShowComponent(map_topbar)
		ShowComponent(main_sidebar_right)
		ShowComponent(navi_top_vm_btn)
		ShowComponent(navi_top_inventory)
		ShowComponent(main_btn_bg)
		ShowComponent(main_service_btn)
		--ShowComponent(main_btn_mission_dialog_bubble)
--[[		
		if StateGarage:IsActivityOver(4) == 0 then
			ShowComponent(main_btn_campaign)
			AniPlayUnlockScreen(main_btn_campaign, 400 + delay, 'ui_ani_show_default')
		else
			HideComponent(main_btn_campaign)
		end
--]]		
		--ShowComponent(main_btn_rm)
		--AniPlayUnlockScreen(main_btn_rm, 400 + delay, 'ui_ani_show_default')
		--ShowComponent(main_driver_icon)
		--AniPlayUnlockScreen(main_driver_icon, 500 + delay, 'ui_ani_show_default')
		-- if channel_id == 'cmgVIP' then
			-- ShowComponent(main_btn_cmpack)
			-- AniPlayUnlockScreen(main_btn_cmpack, 400 + delay, 'ui_ani_show_default')
		-- end
		-- if channel_id == 'dongyou' then
			-- HideComponent(main_service_btn)
		-- else
			-- ShowComponent(main_service_btn)
			-- AniPlayUnlockScreen(main_service_btn, 200 + delay, 'ui_ani_show_default')
		-- end
		AniPlayUnlockScreen(main_service_btn, 200 + delay, 'ui_ani_show_main_ubar')
		AniPlayUnlockScreen(main_sidebar_left, 400 + delay, 'ui_ani_show_default')
		AniPlayUnlockScreen(main_sidebar_right, 600 + delay, 'ui_ani_show_default')
		AniPlayUnlockScreen(navi_top_vm_btn, 200 + delay, 'ui_ani_show_main_ubar')	
		AniPlayUnlockScreen(map_topbar, 200 + delay, 'ui_ani_show_main_ubar')
		AniPlayUnlockScreen(navi_top_inventory, 200 + delay, 'ui_ani_show_main_ubar')
		AniPlayUnlockScreen(main_btn_bg, 200 + delay, 'ui_ani_show_main_dbar')
		--AniPlayUnlockScreen(main_btn_mission_dialog_bubble, 800 + delay, 'ui_ani_show_default')
		AniPlayUnlockScreen(main_sidebar_right, 400 + delay, 'ui_ani_show_default')
		AniPlayUnlockScreen(navi_top_vm_btn, 400 + delay, 'ui_ani_show_default')	
		AniPlayUnlockScreen(navi_top_inventory, 200 + delay, 'ui_ani_show_default')
		AniPlayUnlockScreen(main_btn_bg, 400 + delay, 'ui_ani_show_main_dbar')
	end
end

function ConfigEnergyBar(show_flag)
	if show_flag == true then
		ShowComponent(navi_top_stage_sub_rm_energy_bar)
		if flag_show_energybar == false then
			AniPlayUnlockScreen(navi_top_stage_sub_rm_energy_bar, 500, 'ui_ani_show_default')
			flag_show_energybar = true
		end
		HideComponentWithAni(navi_top_inventory_t, 150, 'ui_ani_hide_default')
	else
		HideComponentWithAni(navi_top_stage_sub_rm_energy_bar, 150, 'ui_ani_hide_default')
		flag_show_energybar = false
		ShowComponent(navi_top_inventory_t)
		AniPlayUnlockScreen(navi_top_inventory_t, 300, 'ui_ani_show_default')
	end
end
---D-I-S-P-L-A-Y----------------------------------------------------------------------------------------------------
--]]