JSCore.Require("functions.js")
JSCore.Require("initialize.js")

//--------------------------------------------------------------------------------------------I-N-I-T-I-A-L-I-Z-E-//
function InitializeUIRoots()
{
	uiR_ui_select_item.setDFlag(false);
	uiR_ui_stage.setDFlag(false);
	uiR_ui_stage_info.setDFlag(false);
	uiR_ui_garage.setDFlag(false);
	uiR_ui_vipstore.setDFlag(false);
	uiR_ui_challenge.setDFlag(false);
	uiR_ui_challenge_ak.setDFlag(false);
	uiR_ui_challenge_tr.setDFlag(false);
	uiR_ui_challenge_redeem.setDFlag(false);
	uiR_ui_challenge_redeem_tr.setDFlag(false);
	uiR_ui_dealer.setDFlag(false);
	uiR_ui_garage.setDFlag(false);
	uiR_ui_driver.setDFlag(false);
	uiR_ui_main.setDFlag(false);
	uiR_ui_popup_casino.setDFlag(false);
	
	HideComponent(navi_top_back2title_btn);
}

function ConfigUIRoots()
{
	AM_ShowComponent(uiR_ui_select_item);
	AM_ShowComponent(uiR_ui_stage);
	AM_ShowComponent(uiR_ui_stage_info);
	AM_ShowComponent(uiR_ui_dealer);
	AM_ShowComponent(uiR_ui_garage);
	AM_ShowComponent(uiR_ui_vipstore);
	AM_ShowComponent(uiR_ui_challenge);
	AM_ShowComponent(uiR_ui_challenge_ak);
	AM_ShowComponent(uiR_ui_challenge_tr);
	AM_ShowComponent(uiR_ui_challenge_redeem);
	AM_ShowComponent(uiR_ui_challenge_redeem_tr);
	AM_ShowComponent(uiR_ui_driver);
	AM_ShowComponent(uiR_ui_main);
	AM_ShowComponent(uiR_ui_popup_casino);
	//AM_ShowComponent(uiR_ui_social);
	
	if(ui_dealer_root.IsShow())
	{
		AM_PlayBGM('bgm_shop.ogg');
	}
	else if(ui_challenge_root.IsShow())
	{
		AM_PlayBGM('bgm_city2.ogg');
	}
	else if(ui_driver_root.IsShow())
	{
		AM_PlayBGM('bgm_garage.ogg');
	}
	else
	{
		AM_PlayBGM('bgm_garage.ogg');
	}
}

function InitializeUIPopup()
{
	uiR_ui_popup_upg2max.setDFlag(false);
}

function ConfigUIPopup()
{
	AM_ShowComponent(uiR_ui_popup_upg2max, 'UEFF_POP', 50);
}

function InitializeGarage()
{	
	HideComponent(garage_lvmax);
	//uiC_garage_btn_upgd2max_confirm.setDFlag(false);
	//uiC_garage_btn_upgd2max_cancel.setDFlag(false);
	ConfigCarFunctionButtons();
}

function InitializeDealer()
{	

}

function InitializeCasino()
{	

}

function InitializeMain()
{
	StateGarage.OnBackToMainUI();

	//AniPlay(main_btn_gift, 350, 'ui_ani_show_default');
	AniPlay(main_btn_mission, 350, 'ui_ani_show_default');
	AniPlay(main_btn_achievement, 350, 'ui_ani_show_default');
	AniPlay(main_btn_friends, 350, 'ui_ani_show_default');
	
	AniPlay(main_btn_bg, 350, 'ui_ani_show_default');
	
	if(!main_btn_shop_disable.IsShow())
	{
		ReplaceButtonRes(main_btn_shop, 'ui_main_shop');
	}
	else
	{
		ReplaceButtonRes(main_btn_shop, 'ui_main_shop_d');
	}
	ShowComponent(main_btn_shop);
	//ShowComponent(main_btn_shop_disable);
	//AniPlay(main_btn_shop, 350, 'ui_ani_show_delay');
	AniPlay(main_btn_shop_disable, 350, 'ui_ani_show_delay');
	
	if(!main_btn_garage_disable.IsShow())
	{
		ReplaceButtonRes(main_btn_garage, 'ui_main_garage');
	}
	else
	{
		ReplaceButtonRes(main_btn_garage, 'ui_main_garage_d');
	}
	ShowComponent(main_btn_garage);
	//ShowComponent(main_btn_garage_disable);
	//AniPlay(main_btn_garage, 350, 'ui_ani_show_delay');
	AniPlay(main_btn_garage_disable, 350, 'ui_ani_show_delay');
	
	if(!main_btn_driver_disable.IsShow())
	{
		ReplaceButtonRes(main_btn_driver, 'ui_main_driver');
	}
	else
	{
		ReplaceButtonRes(main_btn_driver, 'ui_main_driver_d');
	}
	ShowComponent(main_btn_driver);
	//ShowComponent(main_btn_driver_disable);
	//AniPlay(main_btn_driver, 350, 'ui_ani_show_delay');
	AniPlay(main_btn_driver_disable, 350, 'ui_ani_show_delay');
	
	if(!main_btn_pvp_disable.IsShow())
	{
		ReplaceButtonRes(main_btn_pvp, 'ui_main_social');
	}
	else
	{
		ReplaceButtonRes(main_btn_pvp, 'ui_main_social_d');
	}
	ShowComponent(main_btn_pvp);
	//ShowComponent(main_btn_pvp_disable);
	//AniPlay(main_btn_pvp, 350, 'ui_ani_show_delay');
	AniPlay(main_btn_pvp_disable, 350, 'ui_ani_show_delay');
	
	ShowComponent(main_btn_mall);
	//AniPlay(main_btn_mall, 350, 'ui_ani_show_delay');
	
	AniPlay(main_stage_btn, 400, 'ui_ani_show_stagecontinue');
	AniPlay(main_btn_stage_disable, 400, 'ui_ani_show_stagecontinue');
	
	AniPlay(main_btn_news, 700, 'ui_ani_show_default');
	AniPlay(main_banner_slider, 700, 'ui_ani_show_default');
	AniPlay(main_btn_rival_akina, 700, 'ui_ani_show_default');
	AniPlay(main_btn_invite_friends, 700, 'ui_ani_show_default');
	
	AM_PlayBGM('bgm_garage.ogg', 200, 300);
	
	ShowComponent(navi_top_back2title_btn);
	AniPlay(navi_top_back2title_btn, 350, 'ui_ani_show_default');
	AniPlay(main_service_btn, 350, 'ui_ani_show_default');
}

function InitializeStage()
{
	AniPlay(stage_tip, 450, 'ui_ani_show_default');
	HideComponent(stage_locked);
}

function InitializeStageInfo()
{
	SetSubstageData(StateGarage.GetStageInfoByID(StateGarage.GetSelectedChapter(), StateGarage.GetSelectedStage()));

	ShowComponent(stage_info_waist_eff);
	AniPlayUnlockScreen(stage_info_btn_rank, 400, 'ui_ani_show_stageclass');
	AniPlayUnlockScreen(stage_info_btn_continue, 450, 'ui_ani_show_stageclass');
}

function InitializeSelectItem()
{
	SetSubstageData(StateGarage.GetStageInfoByID(StateGarage.GetSelectedChapter(), StateGarage.GetSelectedStage()));
	
	//ShowComponent(item_next_stage_bg_line_eff);
	AniPlayUnlockScreen(item_go_btn, 400, 'ui_ani_show_stageclass');
	AniPlayUnlockScreen(navi_top_rig_car, 450, 'ui_ani_show_stageclass');
	AniPlayUnlockScreen(navi_top_rig_car_disable, 450, 'ui_ani_show_stageclass');
	//AniPlayUnlockScreen(item_car_info, 550, 'ui_ani_show_default');
	AniPlayUnlockScreen(navi_top_rig_driver, 600, 'ui_ani_show_default');
	AniPlayUnlockScreen(navi_top_rig_driver_bg, 600, 'ui_ani_show_default');
	AniPlayUnlockScreen(navi_top_rig_driver_disable, 600, 'ui_ani_show_default');
}

function InitializeChallenge()
{
	//ShowComponent(challenge_navi_slider);
	HideComponent(challenge_infotext_buyitem);
	ShowComponent(challenge_infotext_network);
	ShowComponent(challenge_buy_item_btn);
	HideComponent(challenge_buy_item);
	HideComponent(challenge_back2normal_btn);
	HideComponent(challenge_back2normal_x_btn);
}

function InitializeChallengeAK()
{
	ShowComponent(challenge_ak_navi_slider);
}

function InitializeChallengeTR()
{
	ShowComponent(challenge_tr_navi_slider);
}

function InitializeChallengeRedeemTR()
{
	AniPlayUnlockScreen(challenge_redeem_tr_namebar, 200, 'ui_ani_show_mvx_fd');
	ShowComponent(challenge_redeem_tr_class);
	AniPlayUnlockScreen(challenge_redeem_tr_class, 400, 'ui_ani_show_default');
	AniPlayUnlockScreen(challenge_redeem_tr_weight, 350, 'ui_ani_show_mvx_fd');
	AniPlayUnlockScreen(challenge_redeem_tr_cartype, 400, 'ui_ani_show_mvx_fd');

	AniPlayUnlockScreen(challenge_redeem_tr_spark01, 400, 'ui_ani_show_mvx_fd');
	AniPlayUnlockScreen(challenge_redeem_tr_spark02, 450, 'ui_ani_show_mvx_fd');
	AniPlayUnlockScreen(challenge_redeem_tr_spark03, 500, 'ui_ani_show_mvx_fd');
	AniPlayUnlockScreen(challenge_redeem_tr_spark04, 550, 'ui_ani_show_mvx_fd');
	AniPlayUnlockScreen(challenge_redeem_tr_call, 650, 'ui_ani_show_default');
	
	AniPlayUnlockScreen(challenge_redeem_tr_intro, 500, 'ui_ani_show_default');
}
//-I-N-I-T-I-A-L-I-Z-E--------------------------------------------------------------------------------------------//
//--------------------------------------------------------------------------------------------------D-I-S-P-L-A-Y-//
function SetCurrentUIData(uiR_root)
{
	uiR_current_ui.setCName(uiR_root.CName);
	uiR_current_ui.setDFlag(uiC_navi_top_back_btn.DFlag);
}

function ConfigNaviButtons()
{
	DisplayConfigByCName(uiC_navi_top_back_btn);
	//DisplayConfigByCName(uiC_navi_top_rig);
	//AM_ShowComponent(uiC_navi_top_rig);
	if(ui_main_root.IsShow())
	{
		AM_ShowComponent(uiC_navi_top_back_btn, '', 500);
	}
	//AM_ShowComponent(uiC_navi_top_back_btn, '', 500);
}

function ConfigDriverFunctionButtons()
{
	DisplayConfigByCName(uiC_driver_btn_promote);
	DisplayConfigByCName(uiC_driver_btn_select);
	DisplayConfigByCName(uiC_driver_btn_buy);
}

function ConfigCarFunctionButtons()
{
	DisplayConfigByCName(uiC_garage_fuction_btn_upgd);
	DisplayConfigByCName(uiC_garage_btn_upgd2max);
	//DisplayConfigByCName(uiC_garage_btn_upgd2max_confirm);
	//DisplayConfigByCName(uiC_garage_btn_upgd2max_cancel);
}

function ConfigDriverInfo(shop_item_id)
{
	var skill1_plus = '';
	var skill2_plus = '';
	var skill3_plus = '';
	var driver_name;
	var skill1_data;
	var skill2_data;
	var skill3_data;
	
	currentDriver = new _currentDriverInfo();
	AM_PlayBGM('bgm_garage.ogg');
	
	if(shop_item_id == 0)
	{
		shop_item_id = StateGarage.GetCurrentDriverShopItemId() ? StateGarage.GetCurrentDriverShopItemId() : 42;
		ShowComponent(navi_top_driver_text);
	}
	else
	{
		HideComponent(navi_top_driver_text);
	}

	currentDriver.setCurrentDriver(shop_item_id);
	
	driver_name = currentDriver.CurrentDriver.mLocked ? '????' : currentDriver.CurrentDriver.mName;
	//driver_name = currentDriver.CurrentDriver.mName;
	//ReplaceSprByState(driver_card_name, EnumGUIGraphicState.Normal, currentDriver.CurrentDriver.mIcon + '_name');
	SetComponentText(driver_card_name, driver_name);
	SetComponentText(driver_card_name_shadow, driver_name);
	SetComponentText(driver_card_name_eff, driver_name);
	SetComponentText(driver_card_level, 'LV.' + currentDriver.CurrentDriver.mLevel.toString());
	
	if(currentDriver.CurrentDriver.mSkill1Level)
	{
		if(currentDriver.CurrentDriver.mPurchased && currentDriver.CurrentDriver.mSkill1Level != currentDriver.Skill1.mMaxLevel && currentDriver.CurrentDriver.mSkill1Level != currentDriver.Skill1NextLv)
		{
			//ShowComponent(driver_card_ability_1_tn);
			//AM_SetComponentText(driver_card_ability_1_tn, ' ', currentDriver.Skill1.mNextLevelData.toString());
		}
		else
		{
			//HideComponent(driver_card_ability_1_tn);
		}
		skill1_data = currentDriver.Skill1.mData / 1000 >= 1 ? currentDriver.Skill1.mData / 1000 : currentDriver.Skill1.mData;
		SetComponentText(driver_card_ability_1_t, AM_GetSTRIndex(currentDriver.Skill1.mDesc, skill1_data.toString(), 'STRING'));
		//SetComponentText(driver_card_ability_1_t, AM_GetSTRIndex(currentDriver.Skill1.mDesc, currentDriver.Skill1.mData.toString(), 'STRING'));
	}
	else
	{
		SetComponentText(driver_card_ability_1_t, currentDriver.Skill1UnlockDesc);
		//HideComponent(driver_card_ability_1_tn);
	}
	
	if(currentDriver.CurrentDriver.mSkill2Level)
	{
		if(currentDriver.CurrentDriver.mPurchased && currentDriver.CurrentDriver.mSkill2Level != currentDriver.Skill2.mMaxLevel && currentDriver.CurrentDriver.mSkill2Level != currentDriver.Skill2NextLv)
		{
			//ShowComponent(driver_card_ability_2_tn);
			//AM_SetComponentText(driver_card_ability_2_tn, ' ', currentDriver.Skill2.mNextLevelData.toString());
		}
		else
		{
			//HideComponent(driver_card_ability_2_tn);
		}
		skill2_data = currentDriver.Skill2.mData / 1000 >= 1 ? currentDriver.Skill2.mData / 1000 : currentDriver.Skill2.mData;
		SetComponentText(driver_card_ability_2_t, AM_GetSTRIndex(currentDriver.Skill2.mDesc, skill2_data.toString(), 'STRING'));
		//SetComponentText(driver_card_ability_2_t, AM_GetSTRIndex(currentDriver.Skill2.mDesc, currentDriver.Skill2.mData.toString(), 'STRING'));
	}
	else
	{
		SetComponentText(driver_card_ability_2_t, currentDriver.Skill2UnlockDesc);
		//HideComponent(driver_card_ability_2_tn);
	}
	if(currentDriver.CurrentDriver.mSkill3Level)
	{
		if(currentDriver.CurrentDriver.mPurchased && currentDriver.CurrentDriver.mSkill3Level != currentDriver.Skill3.mMaxLevel && currentDriver.CurrentDriver.mSkill3Level != currentDriver.Skill3NextLv)
		{
			//ShowComponent(driver_card_ability_3_tn);
			//AM_SetComponentText(driver_card_ability_3_tn, ' ', currentDriver.Skill3.mNextLevelData.toString());
		}
		else
		{
			//HideComponent(driver_card_ability_3_tn);
		}
		
		//if(currentDriver.Skill3.mData / 1000 >= 1)
		//{
		//	skill3_data = currentDriver.Skill3.mData / 1000;
		//}
		//else
		//{
		//	skill3_data = currentDriver.Skill3.mData;
		//}
		
		skill3_data = currentDriver.Skill3.mData / 1000 >= 1 ? currentDriver.Skill3.mData / 1000 : currentDriver.Skill3.mData;
		SetComponentText(driver_card_ability_3_t, AM_GetSTRIndex(currentDriver.Skill3.mDesc, skill3_data.toString(), 'STRING'));
	}
	else
	{
		SetComponentText(driver_card_ability_3_t, currentDriver.Skill3UnlockDesc);
		//HideComponent(driver_card_ability_3_tn);
	}
	
	SetComponentText(driver_card_ability_1_dot, currentDriver.getSkillLvDot(currentDriver.Skill1, currentDriver.Skill1NextLv));
	SetComponentText(driver_card_ability_2_dot, currentDriver.getSkillLvDot(currentDriver.Skill2, currentDriver.Skill2NextLv));
	SetComponentText(driver_card_ability_3_dot, currentDriver.getSkillLvDot(currentDriver.Skill3, currentDriver.Skill3NextLv));
	//currentDriver.setSkillBarBg(driver_card_ability_1, driver_card_ability_2, driver_card_ability_3, 0);
	
	if(currentDriver.CurrentDriver.mPurchased)
	{
		//driver full level
		if(currentDriver.CurrentDriver.mDriverLevelIsFull)
		{
			uiC_driver_btn_promote.setDFlag(true);
			uiC_driver_btn_promote.setEFlag(false);
			SetComponentText(driver_btn_promote, '1');
			ReplaceButtonRes(uiC_driver_btn_promote.CName, 'ui_btn_pop_g');
		}
		else
		{
			uiC_driver_btn_promote.setDFlag(true);
			uiC_driver_btn_promote.setEFlag(true);
			SetComponentText(driver_btn_promote, '0');
			ReplaceButtonRes(uiC_driver_btn_promote.CName, 'ui_btn_pop_r');
		}
		if(StateGarage.GetCurrentDriverShopItemId() == StateGarage.GetSelectedDriverShopItemId())
		{
			uiC_driver_btn_select.setDFlag(true);
			uiC_driver_btn_select.setEFlag(false);
			SetComponentText(driver_btn_select, '1');
			ReplaceButtonRes(uiC_driver_btn_select.CName, 'ui_btn_pop_g');
		}
		else
		{
			uiC_driver_btn_select.setDFlag(true);
			uiC_driver_btn_select.setEFlag(true);
			//SetComponentText(navi_top_next_btn, StateGarage.GetCurrentDriverShopItemId().toString() + 'and' + StateGarage.GetSelectedDriverShopItemId().toString());
			SetComponentText(driver_btn_select, '0');
			ReplaceButtonRes(uiC_driver_btn_select.CName, 'ui_btn_pop_y');
		}
		uiC_driver_btn_buy.setDFlag(false);
		HideComponent(driver_pad_cover);
		ShowComponent(driver_btn_buy_price);
		
		//set sale mark
		switch(currentDriver.CurrentDriver.mID)
		{
			case 11:
				ConfigSaleInfo(driver_sale_mark);
				break;
			default :
				HideComponent(driver_sale_mark);
		}
		currentDriver.setUpgradePrice(driver_btn_buy_price);
		ShowComponent(driver_card_bg_head_eff);	
	}
	else
	{
		//set price
		switch(currentDriver.CurrentDriver.mID)
		{
			case 11:
				ConfigSaleInfo(driver_sale_mark);
				SetPrice(driver_btn_buy_price, currentDriver.CurrentDriver.mCoin, currentDriver.CurrentDriver.mRealMoney, 'D');
				break;
			default :
				HideComponent(driver_sale_mark);
				SetPrice(driver_btn_buy_price, currentDriver.CurrentDriver.mCoin, currentDriver.CurrentDriver.mRealMoney, 'P');
		}
		
		if(currentDriver.CurrentDriver.mLocked)
		{
			ShowComponent(driver_pad_cover);
			SetComponentText(driver_pad_cover, currentDriver.CurrentDriver.mDesc);
			AniFadeInUnlockScreen(driver_pad_cover, 200, 300);
			uiC_driver_btn_buy.setDFlag(false);
			HideComponent(driver_btn_buy_price);
			//ReplaceButtonRes(uiC_driver_btn_buy.CName, 'ui_btn_pop_g');
		}
		else
		{
			HideComponent(driver_pad_cover);
			uiC_driver_btn_buy.setDFlag(true);
			ShowComponent(driver_btn_buy_price);
			//ReplaceButtonRes(uiC_driver_btn_buy.CName, 'ui_btn_pop_r');
		}
	
		//uiC_driver_btn_promote.setDFlag(true);
		uiC_driver_btn_promote.setDFlag(false);
		//ReplaceButtonRes(uiC_driver_btn_promote.CName, 'ui_btn_pop_g');
		
		uiC_driver_btn_select.setDFlag(false);
		//uiC_driver_btn_buy.setDFlag(true);
		
		//HideComponent(driver_card_level);
	}
	
	ConfigDriverFunctionButtons();
	AniPlayUnlockScreen(driver_card_cell, 0, 'ui_ani_show_mvrl');
	ShowComponent(driver_card_name);
	AniPlayUnlockScreen(driver_card_name, 200, 'ui_ani_show_mvx_fd');
}

function ConfigCarMaxSpeedWithDriverSkill(selected_driver_id, currentCar_info)
{
	var currentCarSpeedTotal = 0;
	var skill1_desc = '';
	var skill2_desc = '';
	var skill3_desc = '';
	var skill1_mark = '';
	var skill2_mark = '';
	var skill3_mark = '';
	var skill3_data;
	
	if(selected_driver_id != 0)
	{
		var selected_driver = new _currentDriverInfo();
		selected_driver.setCurrentDriver(selected_driver_id);
		
		if(selected_driver.CurrentDriver.mPurchased)
		{
			if(selected_driver.Skill1.mType == 2)
			{
				driverSPMaxSkill = selected_driver.Skill1.mData.toString();
			}
			else
			{
				if(selected_driver.Skill2.mType == 2)
				{
					driverSPMaxSkill = selected_driver.Skill2.mData.toString();
				}
				else
				{
					if(selected_driver.Skill3.mType == 2)
					{
						driverSPMaxSkill = selected_driver.Skill3.mData.toString();
					}
					else
					{
						driverSPMaxSkill = '';
					}
				}
			}
			
			//skill1_desc = AM_GetSTRIndex(selected_driver.Skill1.mDesc, selected_driver.Skill1.mData.toString(), 'STRING');
			//skill2_desc = AM_GetSTRIndex(selected_driver.Skill2.mDesc, selected_driver.Skill2.mData.toString(), 'STRING');
			skill1_data = selected_driver.Skill1.mData / 1000 >= 1 ? selected_driver.Skill1.mData / 1000 : selected_driver.Skill1.mData;
			skill1_desc = AM_GetSTRIndex(selected_driver.Skill1.mDesc, skill1_data.toString(), 'STRING');
			skill2_data = selected_driver.Skill2.mData / 1000 >= 1 ? selected_driver.Skill2.mData / 1000 : selected_driver.Skill2.mData;
			skill2_desc = AM_GetSTRIndex(selected_driver.Skill2.mDesc, skill2_data.toString(), 'STRING');
			skill3_data = selected_driver.Skill3.mData / 1000 >= 1 ? selected_driver.Skill3.mData / 1000 : selected_driver.Skill3.mData;
			skill3_desc = AM_GetSTRIndex(selected_driver.Skill3.mDesc, skill3_data.toString(), 'STRING');
			skill1_mark = '0';
			skill2_mark = '0';
			skill3_mark = '0';
		}
		else
		{
			driverSPMaxSkill = '';
		}
	}
	else
	{
		driverSPMaxSkill = '';
	}
	
	if(driverSPMaxSkill == '')
	{
		AM_SetComponentText(item_car_info_speed, ' ', currentCar_info.mMaxSpeedCurrLevelDisplayValue.toString(), ' ');
	}
	else
	{
		currentCarSpeedTotal = currentCar_info.mMaxSpeedCurrLevelDisplayValue + Number(driverSPMaxSkill);
		AM_SetComponentText(item_car_info_speed, ' ', currentCarSpeedTotal.toString(), ' ');
	}
	
	AM_SetComponentText(navi_top_rig_driver_skill_1, skill1_mark, skill1_desc);
	AM_SetComponentText(navi_top_rig_driver_skill_2, skill2_mark, skill2_desc);
	AM_SetComponentText(navi_top_rig_driver_skill_3, skill3_mark, skill3_desc);
}

function ConfigShowgirl()//(component_name, delay, string_index, fitst_time_delay)
{
	var delay = 2000;
	var fitst_time_delay = 500;
	var girl_pix = arguments[0] == dealer_girl ? dealer_girl_pix : garage_girl_pix;
	var girl_talk = arguments[0] == dealer_girl ? dealer_girl_talk : garage_girl_talk;
	var girl_talk_text = arguments[0] == dealer_girl ? dealer_girl_talk_text : garage_girl_talk_text;
	var text_id = arguments[0] == dealer_girl ? 107 : 106;
	var string_index_value = AM_GetSTRIndex(text_id);
	
	if(arguments.length >= 2 && arguments[1] != '')
	{
		delay = arguments[1];
	}
	
	if(arguments.length >= 3)
	{
		string_index_value = arguments[2];
	}
	
	if(arguments.length == 4)
	{
		fitst_time_delay = arguments[3];
	}
	
	SetComponentText(girl_talk_text, string_index_value);
	ShowComponent(arguments[0]);
	AniPlayUnlockScreen(girl_pix, fitst_time_delay + 100, 'ui_ani_show_stageclass');
	AniPlayUnlockScreen(girl_talk, fitst_time_delay + 200, 'ui_ani_show_stageclass');
	HideComponentWithAni(arguments[0], delay, 'ui_ani_hide_default');
	
	if(ui_dealer_root.IsShow())
	{
		AniPlayUnlockScreen(dealer_intro, delay + 500, 'ui_ani_show_default');
	}
	if(ui_garage_root.IsShow())
	{
		AniPlayUnlockScreen(garage_intro, delay + 500, 'ui_ani_show_default');
	}
}

function ConfigMainButtonMask()
{
	if(!main_btn_shop_disable.IsShow())
	{
		ReplaceButtonRes(main_btn_shop, 'ui_main_shop');
		AM_SetComponentText(main_btn_shop, '0');
	}

	if(!main_btn_garage_disable.IsShow())
	{
		ReplaceButtonRes(main_btn_garage, 'ui_main_garage');
		AM_SetComponentText(main_btn_garage, '0');
	}

	if(!main_btn_driver_disable.IsShow())
	{
		ReplaceButtonRes(main_btn_driver, 'ui_main_driver');
		AM_SetComponentText(main_btn_driver, '0');
	}

	if(!main_btn_pvp_disable.IsShow())
	{
		ReplaceButtonRes(main_btn_pvp, 'ui_main_social');
		AM_SetComponentText(main_btn_pvp, '0');
	}
}
//-D-I-S-P-L-A-Y--------------------------------------------------------------------------------------------------//